#!/usr/bin/php
<?php

$added = 0;
$removed = 0;
$changed = null;
$changedOld = 0;
$changedNew = 0;


$changedFiles = array();
$lastFile = '';

while (($line = fgets(STDIN)) !== false) {
  switch ($line[0]) {
    case '+': $added++;
              break;
    case '!': if ($changed == 'removed') { $changedOld++; }
              else if ($changed == 'added') { $changedNew++; }
              break;
    case '-': if ($line[1] == ' ') { 
		$removed++; 
                break;
	      }
	      // without break here because there are lines with - which may be important
    default:
              $arr = explode(' ', $line);
	      if ($arr[0] == '***') { $changed = 'removed'; }
              if ($arr[0] == '---') { $changed = 'added'; }

              if (count($arr) == 4 && $arr[0] == '***') { //this is a file changed line
		$arr = explode("\t", $arr[1]);
                if (count($arr) == 2) {
		  $changedFiles[$arr[0]] = array();
                  $lastFile = $arr[0];
                }
              } else {
                if ($arr[0] == '***************') {
                  unset($arr[0]);
                  $changedFiles[$lastFile][] = join(' ', $arr);
                } else { }
              }
              break;
  }
}

echo "Result: added=$added, removed=$removed, changedOld=$changedOld changedNew=$changedNew\n";

$changedFuncs = 0;
echo "Changed Files:\n";
foreach ($changedFiles as $file => $changes) {
  echo "\t$file\n";
  $changes = array_unique($changes);
  foreach ($changes as $func) {
    echo "\t\t$func\n";
    $changedFuncs++;
  }
}

echo "Changes: #Files=".count($changedFiles)." #Functions=$changedFuncs\n";
