// $ANTLR 3.0.1 Odl__.g 2008-06-17 17:30:14

  package de.sm.odl;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

public class OdlLexer extends Lexer {
    public static final int CLASS=4;
    public static final int RBRACE=14;
    public static final int TRAIT=5;
    public static final int LETTER=19;
    public static final int CONST=8;
    public static final int LBRACE=13;
    public static final int BEFORE=7;
    public static final int RPARENTHESIS=17;
    public static final int T25=25;
    public static final int Tokens=26;
    public static final int T24=24;
    public static final int EOF=-1;
    public static final int ZERO_ARR=10;
    public static final int LPARENTHESIS=16;
    public static final int RESTRICT=9;
    public static final int POSITION=18;
    public static final int COLON=15;
    public static final int ML_COMMENT=23;
    public static final int WS=21;
    public static final int NEWLINE=11;
    public static final int IDENTIFIER=12;
    public static final int REFINE=6;
    public static final int DIGIT=20;
    public static final int COMMENT=22;
    public OdlLexer() {;} 
    public OdlLexer(CharStream input) {
        super(input);
    }
    public String getGrammarFileName() { return "Odl__.g"; }

    // $ANTLR start CLASS
    public final void mCLASS() throws RecognitionException {
        try {
            int _type = CLASS;
            // Odl__.g:10:7: ( 'class' )
            // Odl__.g:10:9: 'class'
            {
            match("class"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end CLASS

    // $ANTLR start TRAIT
    public final void mTRAIT() throws RecognitionException {
        try {
            int _type = TRAIT;
            // Odl__.g:11:7: ( 'trait' )
            // Odl__.g:11:9: 'trait'
            {
            match("trait"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end TRAIT

    // $ANTLR start REFINE
    public final void mREFINE() throws RecognitionException {
        try {
            int _type = REFINE;
            // Odl__.g:12:8: ( 'refine' )
            // Odl__.g:12:10: 'refine'
            {
            match("refine"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end REFINE

    // $ANTLR start BEFORE
    public final void mBEFORE() throws RecognitionException {
        try {
            int _type = BEFORE;
            // Odl__.g:13:8: ( 'before' )
            // Odl__.g:13:10: 'before'
            {
            match("before"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end BEFORE

    // $ANTLR start CONST
    public final void mCONST() throws RecognitionException {
        try {
            int _type = CONST;
            // Odl__.g:14:7: ( 'const' )
            // Odl__.g:14:9: 'const'
            {
            match("const"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end CONST

    // $ANTLR start RESTRICT
    public final void mRESTRICT() throws RecognitionException {
        try {
            int _type = RESTRICT;
            // Odl__.g:15:10: ( 'restrict' )
            // Odl__.g:15:12: 'restrict'
            {
            match("restrict"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end RESTRICT

    // $ANTLR start ZERO_ARR
    public final void mZERO_ARR() throws RecognitionException {
        try {
            int _type = ZERO_ARR;
            // Odl__.g:16:10: ( '[0]' )
            // Odl__.g:16:12: '[0]'
            {
            match("[0]"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end ZERO_ARR

    // $ANTLR start T24
    public final void mT24() throws RecognitionException {
        try {
            int _type = T24;
            // Odl__.g:17:5: ( ',' )
            // Odl__.g:17:7: ','
            {
            match(','); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T24

    // $ANTLR start T25
    public final void mT25() throws RecognitionException {
        try {
            int _type = T25;
            // Odl__.g:18:5: ( '*' )
            // Odl__.g:18:7: '*'
            {
            match('*'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T25

    // $ANTLR start POSITION
    public final void mPOSITION() throws RecognitionException {
        try {
            int _type = POSITION;
            // Odl__.g:117:9: ( BEFORE )
            // Odl__.g:117:11: BEFORE
            {
            mBEFORE(); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end POSITION

    // $ANTLR start IDENTIFIER
    public final void mIDENTIFIER() throws RecognitionException {
        try {
            int _type = IDENTIFIER;
            // Odl__.g:119:12: ( ( LETTER | '_' ) ( DIGIT | LETTER | '_' )* )
            // Odl__.g:119:14: ( LETTER | '_' ) ( DIGIT | LETTER | '_' )*
            {
            if ( (input.LA(1)>='A' && input.LA(1)<='Z')||input.LA(1)=='_'||(input.LA(1)>='a' && input.LA(1)<='z') ) {
                input.consume();

            }
            else {
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recover(mse);    throw mse;
            }

            // Odl__.g:119:29: ( DIGIT | LETTER | '_' )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( ((LA1_0>='0' && LA1_0<='9')||(LA1_0>='A' && LA1_0<='Z')||LA1_0=='_'||(LA1_0>='a' && LA1_0<='z')) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // Odl__.g:
            	    {
            	    if ( (input.LA(1)>='0' && input.LA(1)<='9')||(input.LA(1)>='A' && input.LA(1)<='Z')||input.LA(1)=='_'||(input.LA(1)>='a' && input.LA(1)<='z') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recover(mse);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end IDENTIFIER

    // $ANTLR start DIGIT
    public final void mDIGIT() throws RecognitionException {
        try {
            int _type = DIGIT;
            // Odl__.g:122:5: ( '0' .. '9' )
            // Odl__.g:122:10: '0' .. '9'
            {
            matchRange('0','9'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end DIGIT

    // $ANTLR start LETTER
    public final void mLETTER() throws RecognitionException {
        try {
            // Odl__.g:125:5: ( 'a' .. 'z' | 'A' .. 'Z' )
            // Odl__.g:
            {
            if ( (input.LA(1)>='A' && input.LA(1)<='Z')||(input.LA(1)>='a' && input.LA(1)<='z') ) {
                input.consume();

            }
            else {
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recover(mse);    throw mse;
            }


            }

        }
        finally {
        }
    }
    // $ANTLR end LETTER

    // $ANTLR start NEWLINE
    public final void mNEWLINE() throws RecognitionException {
        try {
            int _type = NEWLINE;
            // Odl__.g:130:3: ( ( '\\r' )? '\\n' )
            // Odl__.g:130:5: ( '\\r' )? '\\n'
            {
            // Odl__.g:130:5: ( '\\r' )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0=='\r') ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // Odl__.g:130:5: '\\r'
                    {
                    match('\r'); 

                    }
                    break;

            }

            match('\n'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end NEWLINE

    // $ANTLR start WS
    public final void mWS() throws RecognitionException {
        try {
            int _type = WS;
            // Odl__.g:135:3: ( ( ' ' | '\\t' )+ )
            // Odl__.g:135:5: ( ' ' | '\\t' )+
            {
            // Odl__.g:135:5: ( ' ' | '\\t' )+
            int cnt3=0;
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( (LA3_0=='\t'||LA3_0==' ') ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // Odl__.g:
            	    {
            	    if ( input.LA(1)=='\t'||input.LA(1)==' ' ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recover(mse);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt3 >= 1 ) break loop3;
                        EarlyExitException eee =
                            new EarlyExitException(3, input);
                        throw eee;
                }
                cnt3++;
            } while (true);

             channel=HIDDEN; 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end WS

    // $ANTLR start COMMENT
    public final void mCOMMENT() throws RecognitionException {
        try {
            int _type = COMMENT;
            // Odl__.g:140:3: ( '//' (~ ( '\\n' | '\\r' ) )* NEWLINE )
            // Odl__.g:140:5: '//' (~ ( '\\n' | '\\r' ) )* NEWLINE
            {
            match("//"); 

            // Odl__.g:140:10: (~ ( '\\n' | '\\r' ) )*
            loop4:
            do {
                int alt4=2;
                int LA4_0 = input.LA(1);

                if ( ((LA4_0>='\u0000' && LA4_0<='\t')||(LA4_0>='\u000B' && LA4_0<='\f')||(LA4_0>='\u000E' && LA4_0<='\uFFFE')) ) {
                    alt4=1;
                }


                switch (alt4) {
            	case 1 :
            	    // Odl__.g:140:11: ~ ( '\\n' | '\\r' )
            	    {
            	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='\t')||(input.LA(1)>='\u000B' && input.LA(1)<='\f')||(input.LA(1)>='\u000E' && input.LA(1)<='\uFFFE') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recover(mse);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop4;
                }
            } while (true);

            mNEWLINE(); 
             channel=HIDDEN; 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end COMMENT

    // $ANTLR start ML_COMMENT
    public final void mML_COMMENT() throws RecognitionException {
        try {
            int _type = ML_COMMENT;
            // Odl__.g:146:3: ( '/*' ( options {greedy=false; } : . )* '*/' )
            // Odl__.g:146:5: '/*' ( options {greedy=false; } : . )* '*/'
            {
            match("/*"); 

            // Odl__.g:146:10: ( options {greedy=false; } : . )*
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);

                if ( (LA5_0=='*') ) {
                    int LA5_1 = input.LA(2);

                    if ( (LA5_1=='/') ) {
                        alt5=2;
                    }
                    else if ( ((LA5_1>='\u0000' && LA5_1<='.')||(LA5_1>='0' && LA5_1<='\uFFFE')) ) {
                        alt5=1;
                    }


                }
                else if ( ((LA5_0>='\u0000' && LA5_0<=')')||(LA5_0>='+' && LA5_0<='\uFFFE')) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    // Odl__.g:146:37: .
            	    {
            	    matchAny(); 

            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);

            match("*/"); 

             channel=HIDDEN; 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end ML_COMMENT

    // $ANTLR start LPARENTHESIS
    public final void mLPARENTHESIS() throws RecognitionException {
        try {
            int _type = LPARENTHESIS;
            // Odl__.g:150:13: ( '(' )
            // Odl__.g:150:15: '('
            {
            match('('); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end LPARENTHESIS

    // $ANTLR start RPARENTHESIS
    public final void mRPARENTHESIS() throws RecognitionException {
        try {
            int _type = RPARENTHESIS;
            // Odl__.g:151:13: ( ')' )
            // Odl__.g:151:15: ')'
            {
            match(')'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end RPARENTHESIS

    // $ANTLR start COLON
    public final void mCOLON() throws RecognitionException {
        try {
            int _type = COLON;
            // Odl__.g:152:8: ( ':' )
            // Odl__.g:152:10: ':'
            {
            match(':'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end COLON

    // $ANTLR start LBRACE
    public final void mLBRACE() throws RecognitionException {
        try {
            int _type = LBRACE;
            // Odl__.g:153:8: ( '{' )
            // Odl__.g:153:10: '{'
            {
            match('{'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end LBRACE

    // $ANTLR start RBRACE
    public final void mRBRACE() throws RecognitionException {
        try {
            int _type = RBRACE;
            // Odl__.g:154:8: ( '}' )
            // Odl__.g:154:10: '}'
            {
            match('}'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end RBRACE

    public void mTokens() throws RecognitionException {
        // Odl__.g:1:8: ( CLASS | TRAIT | REFINE | BEFORE | CONST | RESTRICT | ZERO_ARR | T24 | T25 | POSITION | IDENTIFIER | DIGIT | NEWLINE | WS | COMMENT | ML_COMMENT | LPARENTHESIS | RPARENTHESIS | COLON | LBRACE | RBRACE )
        int alt6=21;
        switch ( input.LA(1) ) {
        case 'c':
            {
            switch ( input.LA(2) ) {
            case 'o':
                {
                int LA6_18 = input.LA(3);

                if ( (LA6_18=='n') ) {
                    int LA6_25 = input.LA(4);

                    if ( (LA6_25=='s') ) {
                        int LA6_31 = input.LA(5);

                        if ( (LA6_31=='t') ) {
                            int LA6_37 = input.LA(6);

                            if ( ((LA6_37>='0' && LA6_37<='9')||(LA6_37>='A' && LA6_37<='Z')||LA6_37=='_'||(LA6_37>='a' && LA6_37<='z')) ) {
                                alt6=11;
                            }
                            else {
                                alt6=5;}
                        }
                        else {
                            alt6=11;}
                    }
                    else {
                        alt6=11;}
                }
                else {
                    alt6=11;}
                }
                break;
            case 'l':
                {
                int LA6_19 = input.LA(3);

                if ( (LA6_19=='a') ) {
                    int LA6_26 = input.LA(4);

                    if ( (LA6_26=='s') ) {
                        int LA6_32 = input.LA(5);

                        if ( (LA6_32=='s') ) {
                            int LA6_38 = input.LA(6);

                            if ( ((LA6_38>='0' && LA6_38<='9')||(LA6_38>='A' && LA6_38<='Z')||LA6_38=='_'||(LA6_38>='a' && LA6_38<='z')) ) {
                                alt6=11;
                            }
                            else {
                                alt6=1;}
                        }
                        else {
                            alt6=11;}
                    }
                    else {
                        alt6=11;}
                }
                else {
                    alt6=11;}
                }
                break;
            default:
                alt6=11;}

            }
            break;
        case 't':
            {
            int LA6_2 = input.LA(2);

            if ( (LA6_2=='r') ) {
                int LA6_20 = input.LA(3);

                if ( (LA6_20=='a') ) {
                    int LA6_27 = input.LA(4);

                    if ( (LA6_27=='i') ) {
                        int LA6_33 = input.LA(5);

                        if ( (LA6_33=='t') ) {
                            int LA6_39 = input.LA(6);

                            if ( ((LA6_39>='0' && LA6_39<='9')||(LA6_39>='A' && LA6_39<='Z')||LA6_39=='_'||(LA6_39>='a' && LA6_39<='z')) ) {
                                alt6=11;
                            }
                            else {
                                alt6=2;}
                        }
                        else {
                            alt6=11;}
                    }
                    else {
                        alt6=11;}
                }
                else {
                    alt6=11;}
            }
            else {
                alt6=11;}
            }
            break;
        case 'r':
            {
            int LA6_3 = input.LA(2);

            if ( (LA6_3=='e') ) {
                switch ( input.LA(3) ) {
                case 's':
                    {
                    int LA6_28 = input.LA(4);

                    if ( (LA6_28=='t') ) {
                        int LA6_34 = input.LA(5);

                        if ( (LA6_34=='r') ) {
                            int LA6_40 = input.LA(6);

                            if ( (LA6_40=='i') ) {
                                int LA6_46 = input.LA(7);

                                if ( (LA6_46=='c') ) {
                                    int LA6_49 = input.LA(8);

                                    if ( (LA6_49=='t') ) {
                                        int LA6_52 = input.LA(9);

                                        if ( ((LA6_52>='0' && LA6_52<='9')||(LA6_52>='A' && LA6_52<='Z')||LA6_52=='_'||(LA6_52>='a' && LA6_52<='z')) ) {
                                            alt6=11;
                                        }
                                        else {
                                            alt6=6;}
                                    }
                                    else {
                                        alt6=11;}
                                }
                                else {
                                    alt6=11;}
                            }
                            else {
                                alt6=11;}
                        }
                        else {
                            alt6=11;}
                    }
                    else {
                        alt6=11;}
                    }
                    break;
                case 'f':
                    {
                    int LA6_29 = input.LA(4);

                    if ( (LA6_29=='i') ) {
                        int LA6_35 = input.LA(5);

                        if ( (LA6_35=='n') ) {
                            int LA6_41 = input.LA(6);

                            if ( (LA6_41=='e') ) {
                                int LA6_47 = input.LA(7);

                                if ( ((LA6_47>='0' && LA6_47<='9')||(LA6_47>='A' && LA6_47<='Z')||LA6_47=='_'||(LA6_47>='a' && LA6_47<='z')) ) {
                                    alt6=11;
                                }
                                else {
                                    alt6=3;}
                            }
                            else {
                                alt6=11;}
                        }
                        else {
                            alt6=11;}
                    }
                    else {
                        alt6=11;}
                    }
                    break;
                default:
                    alt6=11;}

            }
            else {
                alt6=11;}
            }
            break;
        case 'b':
            {
            int LA6_4 = input.LA(2);

            if ( (LA6_4=='e') ) {
                int LA6_22 = input.LA(3);

                if ( (LA6_22=='f') ) {
                    int LA6_30 = input.LA(4);

                    if ( (LA6_30=='o') ) {
                        int LA6_36 = input.LA(5);

                        if ( (LA6_36=='r') ) {
                            int LA6_42 = input.LA(6);

                            if ( (LA6_42=='e') ) {
                                int LA6_48 = input.LA(7);

                                if ( ((LA6_48>='0' && LA6_48<='9')||(LA6_48>='A' && LA6_48<='Z')||LA6_48=='_'||(LA6_48>='a' && LA6_48<='z')) ) {
                                    alt6=11;
                                }
                                else {
                                    alt6=4;}
                            }
                            else {
                                alt6=11;}
                        }
                        else {
                            alt6=11;}
                    }
                    else {
                        alt6=11;}
                }
                else {
                    alt6=11;}
            }
            else {
                alt6=11;}
            }
            break;
        case '[':
            {
            alt6=7;
            }
            break;
        case ',':
            {
            alt6=8;
            }
            break;
        case '*':
            {
            alt6=9;
            }
            break;
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case '_':
        case 'a':
        case 'd':
        case 'e':
        case 'f':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 's':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':
            {
            alt6=11;
            }
            break;
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
            {
            alt6=12;
            }
            break;
        case '\n':
        case '\r':
            {
            alt6=13;
            }
            break;
        case '\t':
        case ' ':
            {
            alt6=14;
            }
            break;
        case '/':
            {
            int LA6_12 = input.LA(2);

            if ( (LA6_12=='*') ) {
                alt6=16;
            }
            else if ( (LA6_12=='/') ) {
                alt6=15;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("1:1: Tokens : ( CLASS | TRAIT | REFINE | BEFORE | CONST | RESTRICT | ZERO_ARR | T24 | T25 | POSITION | IDENTIFIER | DIGIT | NEWLINE | WS | COMMENT | ML_COMMENT | LPARENTHESIS | RPARENTHESIS | COLON | LBRACE | RBRACE );", 6, 12, input);

                throw nvae;
            }
            }
            break;
        case '(':
            {
            alt6=17;
            }
            break;
        case ')':
            {
            alt6=18;
            }
            break;
        case ':':
            {
            alt6=19;
            }
            break;
        case '{':
            {
            alt6=20;
            }
            break;
        case '}':
            {
            alt6=21;
            }
            break;
        default:
            NoViableAltException nvae =
                new NoViableAltException("1:1: Tokens : ( CLASS | TRAIT | REFINE | BEFORE | CONST | RESTRICT | ZERO_ARR | T24 | T25 | POSITION | IDENTIFIER | DIGIT | NEWLINE | WS | COMMENT | ML_COMMENT | LPARENTHESIS | RPARENTHESIS | COLON | LBRACE | RBRACE );", 6, 0, input);

            throw nvae;
        }

        switch (alt6) {
            case 1 :
                // Odl__.g:1:10: CLASS
                {
                mCLASS(); 

                }
                break;
            case 2 :
                // Odl__.g:1:16: TRAIT
                {
                mTRAIT(); 

                }
                break;
            case 3 :
                // Odl__.g:1:22: REFINE
                {
                mREFINE(); 

                }
                break;
            case 4 :
                // Odl__.g:1:29: BEFORE
                {
                mBEFORE(); 

                }
                break;
            case 5 :
                // Odl__.g:1:36: CONST
                {
                mCONST(); 

                }
                break;
            case 6 :
                // Odl__.g:1:42: RESTRICT
                {
                mRESTRICT(); 

                }
                break;
            case 7 :
                // Odl__.g:1:51: ZERO_ARR
                {
                mZERO_ARR(); 

                }
                break;
            case 8 :
                // Odl__.g:1:60: T24
                {
                mT24(); 

                }
                break;
            case 9 :
                // Odl__.g:1:64: T25
                {
                mT25(); 

                }
                break;
            case 10 :
                // Odl__.g:1:68: POSITION
                {
                mPOSITION(); 

                }
                break;
            case 11 :
                // Odl__.g:1:77: IDENTIFIER
                {
                mIDENTIFIER(); 

                }
                break;
            case 12 :
                // Odl__.g:1:88: DIGIT
                {
                mDIGIT(); 

                }
                break;
            case 13 :
                // Odl__.g:1:94: NEWLINE
                {
                mNEWLINE(); 

                }
                break;
            case 14 :
                // Odl__.g:1:102: WS
                {
                mWS(); 

                }
                break;
            case 15 :
                // Odl__.g:1:105: COMMENT
                {
                mCOMMENT(); 

                }
                break;
            case 16 :
                // Odl__.g:1:113: ML_COMMENT
                {
                mML_COMMENT(); 

                }
                break;
            case 17 :
                // Odl__.g:1:124: LPARENTHESIS
                {
                mLPARENTHESIS(); 

                }
                break;
            case 18 :
                // Odl__.g:1:137: RPARENTHESIS
                {
                mRPARENTHESIS(); 

                }
                break;
            case 19 :
                // Odl__.g:1:150: COLON
                {
                mCOLON(); 

                }
                break;
            case 20 :
                // Odl__.g:1:156: LBRACE
                {
                mLBRACE(); 

                }
                break;
            case 21 :
                // Odl__.g:1:163: RBRACE
                {
                mRBRACE(); 

                }
                break;

        }

    }


 

}