// $ANTLR 3.0.1 /VMADL.j/src/de/sm/vmadl/Vmadl.g 2008-05-27 18:36:48

  package de.sm.vmadl;
  
  import de.sm.vmadl.elements.*;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

import org.antlr.runtime.tree.*;

public class VmadlParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "SERVICE", "STARTUP", "SHUTDOWN", "EXPOSE", "ADVICE", "POINTCUT", "REQUIRE", "BOOT", "FOR", "NEWLINE", "SERVICE_NAME", "LBRACE", "RBRACE", "LETTER", "DIGIT", "SPECIAL", "WS", "COMMENT", "ML_COMMENT", "';'", "'#'"
    };
    public static final int EXPOSE=7;
    public static final int RBRACE=16;
    public static final int LETTER=17;
    public static final int LBRACE=15;
    public static final int FOR=12;
    public static final int BOOT=11;
    public static final int EOF=-1;
    public static final int REQUIRE=10;
    public static final int ADVICE=8;
    public static final int POINTCUT=9;
    public static final int ML_COMMENT=22;
    public static final int WS=20;
    public static final int NEWLINE=13;
    public static final int SERVICE=4;
    public static final int SPECIAL=19;
    public static final int SHUTDOWN=6;
    public static final int DIGIT=18;
    public static final int COMMENT=21;
    public static final int SERVICE_NAME=14;
    public static final int STARTUP=5;

        public VmadlParser(TokenStream input) {
            super(input);
            ruleMemo = new HashMap[75+1];
         }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "/VMADL.j/src/de/sm/vmadl/Vmadl.g"; }


    	private ServiceRegistry reg;


    public static class architecture_return extends ParserRuleReturnScope {
        public List<ServiceModule> modules;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start architecture
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:36:0: architecture[ServiceRegistry reg] returns [ List<ServiceModule> modules ] : ( NEWLINE | service )* EOF ;
    public final architecture_return architecture(ServiceRegistry reg) throws RecognitionException {
        architecture_return retval = new architecture_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token NEWLINE1=null;
        Token EOF3=null;
        service_return service2 = null;


        Object NEWLINE1_tree=null;
        Object EOF3_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:36:76: ( ( NEWLINE | service )* EOF )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:37:1: ( NEWLINE | service )* EOF
            {
            root_0 = (Object)adaptor.nil();

            if ( backtracking==0 ) {
               
              	retval.modules = new ArrayList<ServiceModule>();
              	this.reg = reg;

            }
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:42:5: ( NEWLINE | service )*
            loop1:
            do {
                int alt1=3;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==NEWLINE) ) {
                    alt1=1;
                }
                else if ( (LA1_0==SERVICE) ) {
                    alt1=2;
                }


                switch (alt1) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:43:6: NEWLINE
            	    {
            	    NEWLINE1=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_architecture207); if (failed) return retval;

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:44:8: service
            	    {
            	    pushFollow(FOLLOW_service_in_architecture217);
            	    service2=service();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, service2.getTree());
            	    if ( backtracking==0 ) {
            	       retval.modules.add(service2.s);
            	    }

            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            EOF3=(Token)input.LT(1);
            match(input,EOF,FOLLOW_EOF_in_architecture229); if (failed) return retval;

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end architecture

    public static class service_return extends ParserRuleReturnScope {
        public ServiceModule s;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start service
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:52:0: service returns [ServiceModule s] : SERVICE SERVICE_NAME ( LBRACE ( require | startup | shutdown | expose | NEWLINE | advice | declarations | optionalRelations )* RBRACE ) ;
    public final service_return service() throws RecognitionException {
        service_return retval = new service_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token SERVICE4=null;
        Token SERVICE_NAME5=null;
        Token LBRACE6=null;
        Token NEWLINE11=null;
        Token RBRACE15=null;
        require_return require7 = null;

        startup_return startup8 = null;

        shutdown_return shutdown9 = null;

        expose_return expose10 = null;

        advice_return advice12 = null;

        declarations_return declarations13 = null;

        optionalRelations_return optionalRelations14 = null;


        Object SERVICE4_tree=null;
        Object SERVICE_NAME5_tree=null;
        Object LBRACE6_tree=null;
        Object NEWLINE11_tree=null;
        Object RBRACE15_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:52:35: ( SERVICE SERVICE_NAME ( LBRACE ( require | startup | shutdown | expose | NEWLINE | advice | declarations | optionalRelations )* RBRACE ) )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:53:3: SERVICE SERVICE_NAME ( LBRACE ( require | startup | shutdown | expose | NEWLINE | advice | declarations | optionalRelations )* RBRACE )
            {
            root_0 = (Object)adaptor.nil();

            SERVICE4=(Token)input.LT(1);
            match(input,SERVICE,FOLLOW_SERVICE_in_service248); if (failed) return retval;
            if ( backtracking==0 ) {
            SERVICE4_tree = (Object)adaptor.create(SERVICE4);
            adaptor.addChild(root_0, SERVICE4_tree);
            }
            SERVICE_NAME5=(Token)input.LT(1);
            match(input,SERVICE_NAME,FOLLOW_SERVICE_NAME_in_service250); if (failed) return retval;
            if ( backtracking==0 ) {
            SERVICE_NAME5_tree = (Object)adaptor.create(SERVICE_NAME5);
            adaptor.addChild(root_0, SERVICE_NAME5_tree);
            }
            if ( backtracking==0 ) {
               retval.s = reg.get(SERVICE_NAME5.getText()); 
            }
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:54:3: ( LBRACE ( require | startup | shutdown | expose | NEWLINE | advice | declarations | optionalRelations )* RBRACE )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:54:4: LBRACE ( require | startup | shutdown | expose | NEWLINE | advice | declarations | optionalRelations )* RBRACE
            {
            LBRACE6=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_service257); if (failed) return retval;
            if ( backtracking==0 ) {
            LBRACE6_tree = (Object)adaptor.create(LBRACE6);
            adaptor.addChild(root_0, LBRACE6_tree);
            }
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:55:4: ( require | startup | shutdown | expose | NEWLINE | advice | declarations | optionalRelations )*
            loop2:
            do {
                int alt2=9;
                switch ( input.LA(1) ) {
                case REQUIRE:
                    {
                    alt2=1;
                    }
                    break;
                case STARTUP:
                    {
                    alt2=2;
                    }
                    break;
                case SHUTDOWN:
                    {
                    alt2=3;
                    }
                    break;
                case EXPOSE:
                    {
                    alt2=4;
                    }
                    break;
                case NEWLINE:
                    {
                    alt2=5;
                    }
                    break;
                case ADVICE:
                    {
                    alt2=6;
                    }
                    break;
                case SERVICE_NAME:
                case LETTER:
                case DIGIT:
                case SPECIAL:
                case WS:
                case COMMENT:
                case ML_COMMENT:
                case 24:
                    {
                    alt2=7;
                    }
                    break;
                case FOR:
                    {
                    alt2=8;
                    }
                    break;

                }

                switch (alt2) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:55:7: require
            	    {
            	    pushFollow(FOLLOW_require_in_service266);
            	    require7=require();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, require7.getTree());
            	    if ( backtracking==0 ) {
            	       retval.s.requirements.add(require7.service); 
            	    }

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:56:7: startup
            	    {
            	    pushFollow(FOLLOW_startup_in_service278);
            	    startup8=startup();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, startup8.getTree());

            	    }
            	    break;
            	case 3 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:57:7: shutdown
            	    {
            	    pushFollow(FOLLOW_shutdown_in_service286);
            	    shutdown9=shutdown();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, shutdown9.getTree());

            	    }
            	    break;
            	case 4 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:58:7: expose
            	    {
            	    pushFollow(FOLLOW_expose_in_service294);
            	    expose10=expose();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, expose10.getTree());
            	    if ( backtracking==0 ) {
            	       retval.s.pointcuts = expose10.pointcuts; 
            	    }

            	    }
            	    break;
            	case 5 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:59:7: NEWLINE
            	    {
            	    NEWLINE11=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_service307); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    NEWLINE11_tree = (Object)adaptor.create(NEWLINE11);
            	    adaptor.addChild(root_0, NEWLINE11_tree);
            	    }

            	    }
            	    break;
            	case 6 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:60:7: advice
            	    {
            	    pushFollow(FOLLOW_advice_in_service315);
            	    advice12=advice();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, advice12.getTree());
            	    if ( backtracking==0 ) {
            	       retval.s.advices.add(input.toString(advice12.start,advice12.stop)); 
            	    }

            	    }
            	    break;
            	case 7 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:61:7: declarations
            	    {
            	    pushFollow(FOLLOW_declarations_in_service328);
            	    declarations13=declarations();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, declarations13.getTree());
            	    if ( backtracking==0 ) {
            	       retval.s.declarations.add(input.toString(declarations13.start,declarations13.stop)); 
            	    }

            	    }
            	    break;
            	case 8 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:62:7: optionalRelations
            	    {
            	    pushFollow(FOLLOW_optionalRelations_in_service338);
            	    optionalRelations14=optionalRelations();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, optionalRelations14.getTree());
            	    if ( backtracking==0 ) {
            	       retval.s.relations.add(optionalRelations14.s); 
            	    }

            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

            RBRACE15=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_service348); if (failed) return retval;
            if ( backtracking==0 ) {
            RBRACE15_tree = (Object)adaptor.create(RBRACE15);
            adaptor.addChild(root_0, RBRACE15_tree);
            }

            }

            if ( backtracking==0 ) {
               retval.s.initialized = true; 
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end service

    public static class advice_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start advice
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:67:0: advice : ADVICE adviceHeader content ;
    public final advice_return advice() throws RecognitionException {
        advice_return retval = new advice_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token ADVICE16=null;
        adviceHeader_return adviceHeader17 = null;

        content_return content18 = null;


        Object ADVICE16_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:67:8: ( ADVICE adviceHeader content )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:68:2: ADVICE adviceHeader content
            {
            root_0 = (Object)adaptor.nil();

            ADVICE16=(Token)input.LT(1);
            match(input,ADVICE,FOLLOW_ADVICE_in_advice363); if (failed) return retval;
            if ( backtracking==0 ) {
            ADVICE16_tree = (Object)adaptor.create(ADVICE16);
            adaptor.addChild(root_0, ADVICE16_tree);
            }
            pushFollow(FOLLOW_adviceHeader_in_advice365);
            adviceHeader17=adviceHeader();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, adviceHeader17.getTree());
            pushFollow(FOLLOW_content_in_advice367);
            content18=content();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, content18.getTree());

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end advice

    public static class adviceHeader_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start adviceHeader
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:71:0: adviceHeader : (~ ( LBRACE | RBRACE | ';' ) )+ ;
    public final adviceHeader_return adviceHeader() throws RecognitionException {
        adviceHeader_return retval = new adviceHeader_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set19=null;

        Object set19_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:71:14: ( (~ ( LBRACE | RBRACE | ';' ) )+ )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:72:3: (~ ( LBRACE | RBRACE | ';' ) )+
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:72:3: (~ ( LBRACE | RBRACE | ';' ) )+
            int cnt3=0;
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( ((LA3_0>=SERVICE && LA3_0<=SERVICE_NAME)||(LA3_0>=LETTER && LA3_0<=ML_COMMENT)||LA3_0==24) ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:72:5: ~ ( LBRACE | RBRACE | ';' )
            	    {
            	    set19=(Token)input.LT(1);
            	    if ( (input.LA(1)>=SERVICE && input.LA(1)<=SERVICE_NAME)||(input.LA(1)>=LETTER && input.LA(1)<=ML_COMMENT)||input.LA(1)==24 ) {
            	        input.consume();
            	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set19));
            	        errorRecovery=false;failed=false;
            	    }
            	    else {
            	        if (backtracking>0) {failed=true; return retval;}
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_adviceHeader380);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt3 >= 1 ) break loop3;
            	    if (backtracking>0) {failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(3, input);
                        throw eee;
                }
                cnt3++;
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end adviceHeader

    public static class declarations_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start declarations
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:75:0: declarations : ( preprocessor | declaration );
    public final declarations_return declarations() throws RecognitionException {
        declarations_return retval = new declarations_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        preprocessor_return preprocessor20 = null;

        declaration_return declaration21 = null;



        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:75:14: ( preprocessor | declaration )
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==24) ) {
                alt4=1;
            }
            else if ( (LA4_0==SERVICE_NAME||(LA4_0>=LETTER && LA4_0<=ML_COMMENT)) ) {
                alt4=2;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("75:0: declarations : ( preprocessor | declaration );", 4, 0, input);

                throw nvae;
            }
            switch (alt4) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:76:2: preprocessor
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_preprocessor_in_declarations404);
                    preprocessor20=preprocessor();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, preprocessor20.getTree());

                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:76:17: declaration
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_declaration_in_declarations408);
                    declaration21=declaration();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, declaration21.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end declarations

    public static class preprocessor_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start preprocessor
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:79:0: preprocessor : '#' ( options {greedy=false; } : (~ ( LBRACE | RBRACE | ';' | NEWLINE ) )+ ) NEWLINE ;
    public final preprocessor_return preprocessor() throws RecognitionException {
        preprocessor_return retval = new preprocessor_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token char_literal22=null;
        Token set23=null;
        Token NEWLINE24=null;

        Object char_literal22_tree=null;
        Object set23_tree=null;
        Object NEWLINE24_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:79:14: ( '#' ( options {greedy=false; } : (~ ( LBRACE | RBRACE | ';' | NEWLINE ) )+ ) NEWLINE )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:80:3: '#' ( options {greedy=false; } : (~ ( LBRACE | RBRACE | ';' | NEWLINE ) )+ ) NEWLINE
            {
            root_0 = (Object)adaptor.nil();

            char_literal22=(Token)input.LT(1);
            match(input,24,FOLLOW_24_in_preprocessor419); if (failed) return retval;
            if ( backtracking==0 ) {
            char_literal22_tree = (Object)adaptor.create(char_literal22);
            adaptor.addChild(root_0, char_literal22_tree);
            }
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:81:3: ( options {greedy=false; } : (~ ( LBRACE | RBRACE | ';' | NEWLINE ) )+ )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:81:30: (~ ( LBRACE | RBRACE | ';' | NEWLINE ) )+
            {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:81:30: (~ ( LBRACE | RBRACE | ';' | NEWLINE ) )+
            int cnt5=0;
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);

                if ( ((LA5_0>=SERVICE && LA5_0<=FOR)||LA5_0==SERVICE_NAME||(LA5_0>=LETTER && LA5_0<=ML_COMMENT)||LA5_0==24) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:81:31: ~ ( LBRACE | RBRACE | ';' | NEWLINE )
            	    {
            	    set23=(Token)input.LT(1);
            	    if ( (input.LA(1)>=SERVICE && input.LA(1)<=FOR)||input.LA(1)==SERVICE_NAME||(input.LA(1)>=LETTER && input.LA(1)<=ML_COMMENT)||input.LA(1)==24 ) {
            	        input.consume();
            	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set23));
            	        errorRecovery=false;failed=false;
            	    }
            	    else {
            	        if (backtracking>0) {failed=true; return retval;}
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_preprocessor434);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt5 >= 1 ) break loop5;
            	    if (backtracking>0) {failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(5, input);
                        throw eee;
                }
                cnt5++;
            } while (true);


            }

            NEWLINE24=(Token)input.LT(1);
            match(input,NEWLINE,FOLLOW_NEWLINE_in_preprocessor459); if (failed) return retval;
            if ( backtracking==0 ) {
            NEWLINE24_tree = (Object)adaptor.create(NEWLINE24);
            adaptor.addChild(root_0, NEWLINE24_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end preprocessor

    public static class declaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start declaration
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:93:0: declaration : (~ ( '#' | NEWLINE | LBRACE | RBRACE | ';' | SERVICE | STARTUP | SHUTDOWN | EXPOSE | ADVICE | POINTCUT | REQUIRE | BOOT | FOR ) ) (~ ( LBRACE | RBRACE | ';' ) )+ ( content )? ( ';' )? ;
    public final declaration_return declaration() throws RecognitionException {
        declaration_return retval = new declaration_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set25=null;
        Token set26=null;
        Token char_literal28=null;
        content_return content27 = null;


        Object set25_tree=null;
        Object set26_tree=null;
        Object char_literal28_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:93:13: ( (~ ( '#' | NEWLINE | LBRACE | RBRACE | ';' | SERVICE | STARTUP | SHUTDOWN | EXPOSE | ADVICE | POINTCUT | REQUIRE | BOOT | FOR ) ) (~ ( LBRACE | RBRACE | ';' ) )+ ( content )? ( ';' )? )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:94:2: (~ ( '#' | NEWLINE | LBRACE | RBRACE | ';' | SERVICE | STARTUP | SHUTDOWN | EXPOSE | ADVICE | POINTCUT | REQUIRE | BOOT | FOR ) ) (~ ( LBRACE | RBRACE | ';' ) )+ ( content )? ( ';' )?
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:94:2: (~ ( '#' | NEWLINE | LBRACE | RBRACE | ';' | SERVICE | STARTUP | SHUTDOWN | EXPOSE | ADVICE | POINTCUT | REQUIRE | BOOT | FOR ) )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:94:3: ~ ( '#' | NEWLINE | LBRACE | RBRACE | ';' | SERVICE | STARTUP | SHUTDOWN | EXPOSE | ADVICE | POINTCUT | REQUIRE | BOOT | FOR )
            {
            set25=(Token)input.LT(1);
            if ( input.LA(1)==SERVICE_NAME||(input.LA(1)>=LETTER && input.LA(1)<=ML_COMMENT) ) {
                input.consume();
                if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set25));
                errorRecovery=false;failed=false;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recoverFromMismatchedSet(input,mse,FOLLOW_set_in_declaration481);    throw mse;
            }


            }

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:96:2: (~ ( LBRACE | RBRACE | ';' ) )+
            int cnt6=0;
            loop6:
            do {
                int alt6=2;
                switch ( input.LA(1) ) {
                case REQUIRE:
                    {
                    int LA6_4 = input.LA(2);

                    if ( (synpred34()) ) {
                        alt6=1;
                    }


                    }
                    break;
                case STARTUP:
                    {
                    int LA6_5 = input.LA(2);

                    if ( (synpred34()) ) {
                        alt6=1;
                    }


                    }
                    break;
                case SHUTDOWN:
                    {
                    int LA6_6 = input.LA(2);

                    if ( (synpred34()) ) {
                        alt6=1;
                    }


                    }
                    break;
                case EXPOSE:
                    {
                    int LA6_7 = input.LA(2);

                    if ( (synpred34()) ) {
                        alt6=1;
                    }


                    }
                    break;
                case NEWLINE:
                    {
                    int LA6_8 = input.LA(2);

                    if ( (synpred34()) ) {
                        alt6=1;
                    }


                    }
                    break;
                case ADVICE:
                    {
                    int LA6_9 = input.LA(2);

                    if ( (synpred34()) ) {
                        alt6=1;
                    }


                    }
                    break;
                case 24:
                    {
                    int LA6_10 = input.LA(2);

                    if ( (synpred34()) ) {
                        alt6=1;
                    }


                    }
                    break;
                case SERVICE_NAME:
                case LETTER:
                case DIGIT:
                case SPECIAL:
                case WS:
                case COMMENT:
                case ML_COMMENT:
                    {
                    int LA6_11 = input.LA(2);

                    if ( (synpred34()) ) {
                        alt6=1;
                    }


                    }
                    break;
                case FOR:
                    {
                    int LA6_12 = input.LA(2);

                    if ( (synpred34()) ) {
                        alt6=1;
                    }


                    }
                    break;
                case SERVICE:
                case POINTCUT:
                case BOOT:
                    {
                    alt6=1;
                    }
                    break;

                }

                switch (alt6) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:96:4: ~ ( LBRACE | RBRACE | ';' )
            	    {
            	    set26=(Token)input.LT(1);
            	    if ( (input.LA(1)>=SERVICE && input.LA(1)<=SERVICE_NAME)||(input.LA(1)>=LETTER && input.LA(1)<=ML_COMMENT)||input.LA(1)==24 ) {
            	        input.consume();
            	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set26));
            	        errorRecovery=false;failed=false;
            	    }
            	    else {
            	        if (backtracking>0) {failed=true; return retval;}
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_declaration545);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt6 >= 1 ) break loop6;
            	    if (backtracking>0) {failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(6, input);
                        throw eee;
                }
                cnt6++;
            } while (true);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:97:2: ( content )?
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==LBRACE) ) {
                alt7=1;
            }
            switch (alt7) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:0:0: content
                    {
                    pushFollow(FOLLOW_content_in_declaration562);
                    content27=content();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, content27.getTree());

                    }
                    break;

            }

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:98:2: ( ';' )?
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==23) ) {
                alt8=1;
            }
            switch (alt8) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:0:0: ';'
                    {
                    char_literal28=(Token)input.LT(1);
                    match(input,23,FOLLOW_23_in_declaration567); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal28_tree = (Object)adaptor.create(char_literal28);
                    adaptor.addChild(root_0, char_literal28_tree);
                    }

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end declaration

    public static class content_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start content
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:101:0: content : LBRACE ( content | (~ ( LBRACE | RBRACE ) )+ )* RBRACE ;
    public final content_return content() throws RecognitionException {
        content_return retval = new content_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token LBRACE29=null;
        Token set31=null;
        Token RBRACE32=null;
        content_return content30 = null;


        Object LBRACE29_tree=null;
        Object set31_tree=null;
        Object RBRACE32_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:102:3: ( LBRACE ( content | (~ ( LBRACE | RBRACE ) )+ )* RBRACE )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:103:5: LBRACE ( content | (~ ( LBRACE | RBRACE ) )+ )* RBRACE
            {
            root_0 = (Object)adaptor.nil();

            LBRACE29=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_content584); if (failed) return retval;
            if ( backtracking==0 ) {
            LBRACE29_tree = (Object)adaptor.create(LBRACE29);
            adaptor.addChild(root_0, LBRACE29_tree);
            }
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:104:2: ( content | (~ ( LBRACE | RBRACE ) )+ )*
            loop10:
            do {
                int alt10=3;
                int LA10_0 = input.LA(1);

                if ( (LA10_0==LBRACE) ) {
                    alt10=1;
                }
                else if ( ((LA10_0>=SERVICE && LA10_0<=SERVICE_NAME)||(LA10_0>=LETTER && LA10_0<=24)) ) {
                    alt10=2;
                }


                switch (alt10) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:104:3: content
            	    {
            	    pushFollow(FOLLOW_content_in_content588);
            	    content30=content();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, content30.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:104:13: (~ ( LBRACE | RBRACE ) )+
            	    {
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:104:13: (~ ( LBRACE | RBRACE ) )+
            	    int cnt9=0;
            	    loop9:
            	    do {
            	        int alt9=2;
            	        int LA9_0 = input.LA(1);

            	        if ( ((LA9_0>=SERVICE && LA9_0<=SERVICE_NAME)||(LA9_0>=LETTER && LA9_0<=24)) ) {
            	            int LA9_2 = input.LA(2);

            	            if ( (synpred39()) ) {
            	                alt9=1;
            	            }


            	        }


            	        switch (alt9) {
            	    	case 1 :
            	    	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:104:14: ~ ( LBRACE | RBRACE )
            	    	    {
            	    	    set31=(Token)input.LT(1);
            	    	    if ( (input.LA(1)>=SERVICE && input.LA(1)<=SERVICE_NAME)||(input.LA(1)>=LETTER && input.LA(1)<=24) ) {
            	    	        input.consume();
            	    	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set31));
            	    	        errorRecovery=false;failed=false;
            	    	    }
            	    	    else {
            	    	        if (backtracking>0) {failed=true; return retval;}
            	    	        MismatchedSetException mse =
            	    	            new MismatchedSetException(null,input);
            	    	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_content593);    throw mse;
            	    	    }


            	    	    }
            	    	    break;

            	    	default :
            	    	    if ( cnt9 >= 1 ) break loop9;
            	    	    if (backtracking>0) {failed=true; return retval;}
            	                EarlyExitException eee =
            	                    new EarlyExitException(9, input);
            	                throw eee;
            	        }
            	        cnt9++;
            	    } while (true);


            	    }
            	    break;

            	default :
            	    break loop10;
                }
            } while (true);

            RBRACE32=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_content607); if (failed) return retval;
            if ( backtracking==0 ) {
            RBRACE32_tree = (Object)adaptor.create(RBRACE32);
            adaptor.addChild(root_0, RBRACE32_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end content

    public static class startup_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start startup
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:108:0: startup : STARTUP ( LBRACE ( expose | advice | boot )* RBRACE ) ;
    public final startup_return startup() throws RecognitionException {
        startup_return retval = new startup_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token STARTUP33=null;
        Token LBRACE34=null;
        Token RBRACE38=null;
        expose_return expose35 = null;

        advice_return advice36 = null;

        boot_return boot37 = null;


        Object STARTUP33_tree=null;
        Object LBRACE34_tree=null;
        Object RBRACE38_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:109:3: ( STARTUP ( LBRACE ( expose | advice | boot )* RBRACE ) )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:109:5: STARTUP ( LBRACE ( expose | advice | boot )* RBRACE )
            {
            root_0 = (Object)adaptor.nil();

            STARTUP33=(Token)input.LT(1);
            match(input,STARTUP,FOLLOW_STARTUP_in_startup618); if (failed) return retval;
            if ( backtracking==0 ) {
            STARTUP33_tree = (Object)adaptor.create(STARTUP33);
            adaptor.addChild(root_0, STARTUP33_tree);
            }
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:110:2: ( LBRACE ( expose | advice | boot )* RBRACE )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:110:3: LBRACE ( expose | advice | boot )* RBRACE
            {
            LBRACE34=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_startup622); if (failed) return retval;
            if ( backtracking==0 ) {
            LBRACE34_tree = (Object)adaptor.create(LBRACE34);
            adaptor.addChild(root_0, LBRACE34_tree);
            }
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:110:10: ( expose | advice | boot )*
            loop11:
            do {
                int alt11=4;
                switch ( input.LA(1) ) {
                case EXPOSE:
                    {
                    alt11=1;
                    }
                    break;
                case ADVICE:
                    {
                    alt11=2;
                    }
                    break;
                case BOOT:
                    {
                    alt11=3;
                    }
                    break;

                }

                switch (alt11) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:110:11: expose
            	    {
            	    pushFollow(FOLLOW_expose_in_startup625);
            	    expose35=expose();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, expose35.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:110:20: advice
            	    {
            	    pushFollow(FOLLOW_advice_in_startup629);
            	    advice36=advice();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, advice36.getTree());

            	    }
            	    break;
            	case 3 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:110:29: boot
            	    {
            	    pushFollow(FOLLOW_boot_in_startup633);
            	    boot37=boot();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, boot37.getTree());

            	    }
            	    break;

            	default :
            	    break loop11;
                }
            } while (true);

            RBRACE38=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_startup638); if (failed) return retval;
            if ( backtracking==0 ) {
            RBRACE38_tree = (Object)adaptor.create(RBRACE38);
            adaptor.addChild(root_0, RBRACE38_tree);
            }

            }


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end startup

    public static class shutdown_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start shutdown
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:112:0: shutdown : SHUTDOWN ( LBRACE ( expose | advice )* RBRACE ) ;
    public final shutdown_return shutdown() throws RecognitionException {
        shutdown_return retval = new shutdown_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token SHUTDOWN39=null;
        Token LBRACE40=null;
        Token RBRACE43=null;
        expose_return expose41 = null;

        advice_return advice42 = null;


        Object SHUTDOWN39_tree=null;
        Object LBRACE40_tree=null;
        Object RBRACE43_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:113:3: ( SHUTDOWN ( LBRACE ( expose | advice )* RBRACE ) )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:113:5: SHUTDOWN ( LBRACE ( expose | advice )* RBRACE )
            {
            root_0 = (Object)adaptor.nil();

            SHUTDOWN39=(Token)input.LT(1);
            match(input,SHUTDOWN,FOLLOW_SHUTDOWN_in_shutdown649); if (failed) return retval;
            if ( backtracking==0 ) {
            SHUTDOWN39_tree = (Object)adaptor.create(SHUTDOWN39);
            adaptor.addChild(root_0, SHUTDOWN39_tree);
            }
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:114:2: ( LBRACE ( expose | advice )* RBRACE )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:114:3: LBRACE ( expose | advice )* RBRACE
            {
            LBRACE40=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_shutdown653); if (failed) return retval;
            if ( backtracking==0 ) {
            LBRACE40_tree = (Object)adaptor.create(LBRACE40);
            adaptor.addChild(root_0, LBRACE40_tree);
            }
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:114:10: ( expose | advice )*
            loop12:
            do {
                int alt12=3;
                int LA12_0 = input.LA(1);

                if ( (LA12_0==EXPOSE) ) {
                    alt12=1;
                }
                else if ( (LA12_0==ADVICE) ) {
                    alt12=2;
                }


                switch (alt12) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:114:11: expose
            	    {
            	    pushFollow(FOLLOW_expose_in_shutdown656);
            	    expose41=expose();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, expose41.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:114:20: advice
            	    {
            	    pushFollow(FOLLOW_advice_in_shutdown660);
            	    advice42=advice();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, advice42.getTree());

            	    }
            	    break;

            	default :
            	    break loop12;
                }
            } while (true);

            RBRACE43=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_shutdown664); if (failed) return retval;
            if ( backtracking==0 ) {
            RBRACE43_tree = (Object)adaptor.create(RBRACE43);
            adaptor.addChild(root_0, RBRACE43_tree);
            }

            }


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end shutdown

    public static class boot_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start boot
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:116:0: boot : BOOT (~ ( LBRACE | RBRACE | ';' ) )+ ';' ;
    public final boot_return boot() throws RecognitionException {
        boot_return retval = new boot_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token BOOT44=null;
        Token set45=null;
        Token char_literal46=null;

        Object BOOT44_tree=null;
        Object set45_tree=null;
        Object char_literal46_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:116:6: ( BOOT (~ ( LBRACE | RBRACE | ';' ) )+ ';' )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:117:2: BOOT (~ ( LBRACE | RBRACE | ';' ) )+ ';'
            {
            root_0 = (Object)adaptor.nil();

            BOOT44=(Token)input.LT(1);
            match(input,BOOT,FOLLOW_BOOT_in_boot676); if (failed) return retval;
            if ( backtracking==0 ) {
            BOOT44_tree = (Object)adaptor.create(BOOT44);
            adaptor.addChild(root_0, BOOT44_tree);
            }
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:118:2: (~ ( LBRACE | RBRACE | ';' ) )+
            int cnt13=0;
            loop13:
            do {
                int alt13=2;
                int LA13_0 = input.LA(1);

                if ( ((LA13_0>=SERVICE && LA13_0<=SERVICE_NAME)||(LA13_0>=LETTER && LA13_0<=ML_COMMENT)||LA13_0==24) ) {
                    alt13=1;
                }


                switch (alt13) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:118:4: ~ ( LBRACE | RBRACE | ';' )
            	    {
            	    set45=(Token)input.LT(1);
            	    if ( (input.LA(1)>=SERVICE && input.LA(1)<=SERVICE_NAME)||(input.LA(1)>=LETTER && input.LA(1)<=ML_COMMENT)||input.LA(1)==24 ) {
            	        input.consume();
            	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set45));
            	        errorRecovery=false;failed=false;
            	    }
            	    else {
            	        if (backtracking>0) {failed=true; return retval;}
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_boot681);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt13 >= 1 ) break loop13;
            	    if (backtracking>0) {failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(13, input);
                        throw eee;
                }
                cnt13++;
            } while (true);

            char_literal46=(Token)input.LT(1);
            match(input,23,FOLLOW_23_in_boot698); if (failed) return retval;
            if ( backtracking==0 ) {
            char_literal46_tree = (Object)adaptor.create(char_literal46);
            adaptor.addChild(root_0, char_literal46_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end boot

    public static class expose_return extends ParserRuleReturnScope {
        public List<String> pointcuts;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start expose
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:122:0: expose returns [List<String> pointcuts] : EXPOSE ( NEWLINE )* LBRACE ( NEWLINE )* ( pointcut )* RBRACE ;
    public final expose_return expose() throws RecognitionException {
        expose_return retval = new expose_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token EXPOSE47=null;
        Token NEWLINE48=null;
        Token LBRACE49=null;
        Token NEWLINE50=null;
        Token RBRACE52=null;
        pointcut_return pointcut51 = null;


        Object EXPOSE47_tree=null;
        Object NEWLINE48_tree=null;
        Object LBRACE49_tree=null;
        Object NEWLINE50_tree=null;
        Object RBRACE52_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:122:41: ( EXPOSE ( NEWLINE )* LBRACE ( NEWLINE )* ( pointcut )* RBRACE )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:123:1: EXPOSE ( NEWLINE )* LBRACE ( NEWLINE )* ( pointcut )* RBRACE
            {
            root_0 = (Object)adaptor.nil();

            if ( backtracking==0 ) {
               retval.pointcuts = new ArrayList<String>(); 
            }
            EXPOSE47=(Token)input.LT(1);
            match(input,EXPOSE,FOLLOW_EXPOSE_in_expose716); if (failed) return retval;
            if ( backtracking==0 ) {
            EXPOSE47_tree = (Object)adaptor.create(EXPOSE47);
            adaptor.addChild(root_0, EXPOSE47_tree);
            }
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:124:10: ( NEWLINE )*
            loop14:
            do {
                int alt14=2;
                int LA14_0 = input.LA(1);

                if ( (LA14_0==NEWLINE) ) {
                    alt14=1;
                }


                switch (alt14) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:0:0: NEWLINE
            	    {
            	    NEWLINE48=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_expose718); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    NEWLINE48_tree = (Object)adaptor.create(NEWLINE48);
            	    adaptor.addChild(root_0, NEWLINE48_tree);
            	    }

            	    }
            	    break;

            	default :
            	    break loop14;
                }
            } while (true);

            LBRACE49=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_expose721); if (failed) return retval;
            if ( backtracking==0 ) {
            LBRACE49_tree = (Object)adaptor.create(LBRACE49);
            adaptor.addChild(root_0, LBRACE49_tree);
            }
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:124:26: ( NEWLINE )*
            loop15:
            do {
                int alt15=2;
                int LA15_0 = input.LA(1);

                if ( (LA15_0==NEWLINE) ) {
                    alt15=1;
                }


                switch (alt15) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:0:0: NEWLINE
            	    {
            	    NEWLINE50=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_expose723); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    NEWLINE50_tree = (Object)adaptor.create(NEWLINE50);
            	    adaptor.addChild(root_0, NEWLINE50_tree);
            	    }

            	    }
            	    break;

            	default :
            	    break loop15;
                }
            } while (true);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:125:2: ( pointcut )*
            loop16:
            do {
                int alt16=2;
                int LA16_0 = input.LA(1);

                if ( (LA16_0==POINTCUT) ) {
                    alt16=1;
                }


                switch (alt16) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:125:4: pointcut
            	    {
            	    pushFollow(FOLLOW_pointcut_in_expose730);
            	    pointcut51=pointcut();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, pointcut51.getTree());
            	    if ( backtracking==0 ) {
            	      retval.pointcuts.add(input.toString(pointcut51.start,pointcut51.stop)); 
            	    }

            	    }
            	    break;

            	default :
            	    break loop16;
                }
            } while (true);

            RBRACE52=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_expose739); if (failed) return retval;
            if ( backtracking==0 ) {
            RBRACE52_tree = (Object)adaptor.create(RBRACE52);
            adaptor.addChild(root_0, RBRACE52_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end expose

    public static class require_return extends ParserRuleReturnScope {
        public ServiceModule service;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start require
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:130:0: require returns [ ServiceModule service ] : REQUIRE SERVICE_NAME ';' ;
    public final require_return require() throws RecognitionException {
        require_return retval = new require_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token REQUIRE53=null;
        Token SERVICE_NAME54=null;
        Token char_literal55=null;

        Object REQUIRE53_tree=null;
        Object SERVICE_NAME54_tree=null;
        Object char_literal55_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:130:43: ( REQUIRE SERVICE_NAME ';' )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:131:2: REQUIRE SERVICE_NAME ';'
            {
            root_0 = (Object)adaptor.nil();

            REQUIRE53=(Token)input.LT(1);
            match(input,REQUIRE,FOLLOW_REQUIRE_in_require754); if (failed) return retval;
            if ( backtracking==0 ) {
            REQUIRE53_tree = (Object)adaptor.create(REQUIRE53);
            adaptor.addChild(root_0, REQUIRE53_tree);
            }
            SERVICE_NAME54=(Token)input.LT(1);
            match(input,SERVICE_NAME,FOLLOW_SERVICE_NAME_in_require756); if (failed) return retval;
            if ( backtracking==0 ) {
            SERVICE_NAME54_tree = (Object)adaptor.create(SERVICE_NAME54);
            adaptor.addChild(root_0, SERVICE_NAME54_tree);
            }
            if ( backtracking==0 ) {
               retval.service = reg.get(SERVICE_NAME54.getText()); 
            }
            char_literal55=(Token)input.LT(1);
            match(input,23,FOLLOW_23_in_require762); if (failed) return retval;
            if ( backtracking==0 ) {
            char_literal55_tree = (Object)adaptor.create(char_literal55);
            adaptor.addChild(root_0, char_literal55_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end require

    public static class pointcut_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start pointcut
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:134:0: pointcut : POINTCUT (~ ( ';' ) )* ';' ( NEWLINE )* ;
    public final pointcut_return pointcut() throws RecognitionException {
        pointcut_return retval = new pointcut_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token POINTCUT56=null;
        Token set57=null;
        Token char_literal58=null;
        Token NEWLINE59=null;

        Object POINTCUT56_tree=null;
        Object set57_tree=null;
        Object char_literal58_tree=null;
        Object NEWLINE59_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:134:10: ( POINTCUT (~ ( ';' ) )* ';' ( NEWLINE )* )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:135:2: POINTCUT (~ ( ';' ) )* ';' ( NEWLINE )*
            {
            root_0 = (Object)adaptor.nil();

            POINTCUT56=(Token)input.LT(1);
            match(input,POINTCUT,FOLLOW_POINTCUT_in_pointcut772); if (failed) return retval;
            if ( backtracking==0 ) {
            POINTCUT56_tree = (Object)adaptor.create(POINTCUT56);
            adaptor.addChild(root_0, POINTCUT56_tree);
            }
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:136:2: (~ ( ';' ) )*
            loop17:
            do {
                int alt17=2;
                int LA17_0 = input.LA(1);

                if ( ((LA17_0>=SERVICE && LA17_0<=ML_COMMENT)||LA17_0==24) ) {
                    alt17=1;
                }


                switch (alt17) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:136:3: ~ ( ';' )
            	    {
            	    set57=(Token)input.LT(1);
            	    if ( (input.LA(1)>=SERVICE && input.LA(1)<=ML_COMMENT)||input.LA(1)==24 ) {
            	        input.consume();
            	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set57));
            	        errorRecovery=false;failed=false;
            	    }
            	    else {
            	        if (backtracking>0) {failed=true; return retval;}
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_pointcut777);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop17;
                }
            } while (true);

            char_literal58=(Token)input.LT(1);
            match(input,23,FOLLOW_23_in_pointcut785); if (failed) return retval;
            if ( backtracking==0 ) {
            char_literal58_tree = (Object)adaptor.create(char_literal58);
            adaptor.addChild(root_0, char_literal58_tree);
            }
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:137:6: ( NEWLINE )*
            loop18:
            do {
                int alt18=2;
                int LA18_0 = input.LA(1);

                if ( (LA18_0==NEWLINE) ) {
                    alt18=1;
                }


                switch (alt18) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:0:0: NEWLINE
            	    {
            	    NEWLINE59=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_pointcut787); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    NEWLINE59_tree = (Object)adaptor.create(NEWLINE59);
            	    adaptor.addChild(root_0, NEWLINE59_tree);
            	    }

            	    }
            	    break;

            	default :
            	    break loop18;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end pointcut

    public static class optionalRelations_return extends ParserRuleReturnScope {
        public OptionalRelation s;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start optionalRelations
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:140:0: optionalRelations returns [OptionalRelation s] : FOR SERVICE_NAME ( LBRACE ( require | startup | shutdown | expose | NEWLINE | advice | declarations )* RBRACE ) ;
    public final optionalRelations_return optionalRelations() throws RecognitionException {
        optionalRelations_return retval = new optionalRelations_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token FOR60=null;
        Token SERVICE_NAME61=null;
        Token LBRACE62=null;
        Token NEWLINE67=null;
        Token RBRACE70=null;
        require_return require63 = null;

        startup_return startup64 = null;

        shutdown_return shutdown65 = null;

        expose_return expose66 = null;

        advice_return advice68 = null;

        declarations_return declarations69 = null;


        Object FOR60_tree=null;
        Object SERVICE_NAME61_tree=null;
        Object LBRACE62_tree=null;
        Object NEWLINE67_tree=null;
        Object RBRACE70_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:140:48: ( FOR SERVICE_NAME ( LBRACE ( require | startup | shutdown | expose | NEWLINE | advice | declarations )* RBRACE ) )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:141:2: FOR SERVICE_NAME ( LBRACE ( require | startup | shutdown | expose | NEWLINE | advice | declarations )* RBRACE )
            {
            root_0 = (Object)adaptor.nil();

            FOR60=(Token)input.LT(1);
            match(input,FOR,FOLLOW_FOR_in_optionalRelations803); if (failed) return retval;
            if ( backtracking==0 ) {
            FOR60_tree = (Object)adaptor.create(FOR60);
            adaptor.addChild(root_0, FOR60_tree);
            }
            SERVICE_NAME61=(Token)input.LT(1);
            match(input,SERVICE_NAME,FOLLOW_SERVICE_NAME_in_optionalRelations805); if (failed) return retval;
            if ( backtracking==0 ) {
            SERVICE_NAME61_tree = (Object)adaptor.create(SERVICE_NAME61);
            adaptor.addChild(root_0, SERVICE_NAME61_tree);
            }
            if ( backtracking==0 ) {
               retval.s = new OptionalRelation(); 
              										 retval.s.service = reg.get(SERVICE_NAME61.getText()); 
            }
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:143:2: ( LBRACE ( require | startup | shutdown | expose | NEWLINE | advice | declarations )* RBRACE )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:143:3: LBRACE ( require | startup | shutdown | expose | NEWLINE | advice | declarations )* RBRACE
            {
            LBRACE62=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_optionalRelations811); if (failed) return retval;
            if ( backtracking==0 ) {
            LBRACE62_tree = (Object)adaptor.create(LBRACE62);
            adaptor.addChild(root_0, LBRACE62_tree);
            }
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:144:4: ( require | startup | shutdown | expose | NEWLINE | advice | declarations )*
            loop19:
            do {
                int alt19=8;
                switch ( input.LA(1) ) {
                case REQUIRE:
                    {
                    alt19=1;
                    }
                    break;
                case STARTUP:
                    {
                    alt19=2;
                    }
                    break;
                case SHUTDOWN:
                    {
                    alt19=3;
                    }
                    break;
                case EXPOSE:
                    {
                    alt19=4;
                    }
                    break;
                case NEWLINE:
                    {
                    alt19=5;
                    }
                    break;
                case ADVICE:
                    {
                    alt19=6;
                    }
                    break;
                case SERVICE_NAME:
                case LETTER:
                case DIGIT:
                case SPECIAL:
                case WS:
                case COMMENT:
                case ML_COMMENT:
                case 24:
                    {
                    alt19=7;
                    }
                    break;

                }

                switch (alt19) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:144:7: require
            	    {
            	    pushFollow(FOLLOW_require_in_optionalRelations820);
            	    require63=require();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, require63.getTree());
            	    if ( backtracking==0 ) {
            	       retval.s.requirements.add(require63.service); 
            	    }

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:145:7: startup
            	    {
            	    pushFollow(FOLLOW_startup_in_optionalRelations832);
            	    startup64=startup();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, startup64.getTree());

            	    }
            	    break;
            	case 3 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:146:7: shutdown
            	    {
            	    pushFollow(FOLLOW_shutdown_in_optionalRelations840);
            	    shutdown65=shutdown();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, shutdown65.getTree());

            	    }
            	    break;
            	case 4 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:147:7: expose
            	    {
            	    pushFollow(FOLLOW_expose_in_optionalRelations848);
            	    expose66=expose();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, expose66.getTree());
            	    if ( backtracking==0 ) {
            	       retval.s.pointcuts = expose66.pointcuts; 
            	    }

            	    }
            	    break;
            	case 5 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:148:7: NEWLINE
            	    {
            	    NEWLINE67=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_optionalRelations861); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    NEWLINE67_tree = (Object)adaptor.create(NEWLINE67);
            	    adaptor.addChild(root_0, NEWLINE67_tree);
            	    }

            	    }
            	    break;
            	case 6 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:149:7: advice
            	    {
            	    pushFollow(FOLLOW_advice_in_optionalRelations869);
            	    advice68=advice();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, advice68.getTree());
            	    if ( backtracking==0 ) {
            	       retval.s.advices.add(input.toString(advice68.start,advice68.stop)); 
            	    }

            	    }
            	    break;
            	case 7 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:150:7: declarations
            	    {
            	    pushFollow(FOLLOW_declarations_in_optionalRelations882);
            	    declarations69=declarations();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, declarations69.getTree());
            	    if ( backtracking==0 ) {
            	       retval.s.declarations.add(input.toString(declarations69.start,declarations69.stop)); 
            	    }

            	    }
            	    break;

            	default :
            	    break loop19;
                }
            } while (true);

            RBRACE70=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_optionalRelations892); if (failed) return retval;
            if ( backtracking==0 ) {
            RBRACE70_tree = (Object)adaptor.create(RBRACE70);
            adaptor.addChild(root_0, RBRACE70_tree);
            }

            }


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end optionalRelations

    // $ANTLR start synpred34
    public final void synpred34_fragment() throws RecognitionException {   
        // /VMADL.j/src/de/sm/vmadl/Vmadl.g:96:4: (~ ( LBRACE | RBRACE | ';' ) )
        // /VMADL.j/src/de/sm/vmadl/Vmadl.g:96:4: ~ ( LBRACE | RBRACE | ';' )
        {
        if ( (input.LA(1)>=SERVICE && input.LA(1)<=SERVICE_NAME)||(input.LA(1)>=LETTER && input.LA(1)<=ML_COMMENT)||input.LA(1)==24 ) {
            input.consume();
            errorRecovery=false;failed=false;
        }
        else {
            if (backtracking>0) {failed=true; return ;}
            MismatchedSetException mse =
                new MismatchedSetException(null,input);
            recoverFromMismatchedSet(input,mse,FOLLOW_set_in_synpred34545);    throw mse;
        }


        }
    }
    // $ANTLR end synpred34

    // $ANTLR start synpred39
    public final void synpred39_fragment() throws RecognitionException {   
        // /VMADL.j/src/de/sm/vmadl/Vmadl.g:104:14: (~ ( LBRACE | RBRACE ) )
        // /VMADL.j/src/de/sm/vmadl/Vmadl.g:104:14: ~ ( LBRACE | RBRACE )
        {
        if ( (input.LA(1)>=SERVICE && input.LA(1)<=SERVICE_NAME)||(input.LA(1)>=LETTER && input.LA(1)<=24) ) {
            input.consume();
            errorRecovery=false;failed=false;
        }
        else {
            if (backtracking>0) {failed=true; return ;}
            MismatchedSetException mse =
                new MismatchedSetException(null,input);
            recoverFromMismatchedSet(input,mse,FOLLOW_set_in_synpred39593);    throw mse;
        }


        }
    }
    // $ANTLR end synpred39

    public final boolean synpred34() {
        backtracking++;
        int start = input.mark();
        try {
            synpred34_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !failed;
        input.rewind(start);
        backtracking--;
        failed=false;
        return success;
    }
    public final boolean synpred39() {
        backtracking++;
        int start = input.mark();
        try {
            synpred39_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !failed;
        input.rewind(start);
        backtracking--;
        failed=false;
        return success;
    }


 

    public static final BitSet FOLLOW_NEWLINE_in_architecture207 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_service_in_architecture217 = new BitSet(new long[]{0x0000000000002010L});
    public static final BitSet FOLLOW_EOF_in_architecture229 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SERVICE_in_service248 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_SERVICE_NAME_in_service250 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_LBRACE_in_service257 = new BitSet(new long[]{0x00000000017F75E0L});
    public static final BitSet FOLLOW_require_in_service266 = new BitSet(new long[]{0x00000000017F75E0L});
    public static final BitSet FOLLOW_startup_in_service278 = new BitSet(new long[]{0x00000000017F75E0L});
    public static final BitSet FOLLOW_shutdown_in_service286 = new BitSet(new long[]{0x00000000017F75E0L});
    public static final BitSet FOLLOW_expose_in_service294 = new BitSet(new long[]{0x00000000017F75E0L});
    public static final BitSet FOLLOW_NEWLINE_in_service307 = new BitSet(new long[]{0x00000000017F75E0L});
    public static final BitSet FOLLOW_advice_in_service315 = new BitSet(new long[]{0x00000000017F75E0L});
    public static final BitSet FOLLOW_declarations_in_service328 = new BitSet(new long[]{0x00000000017F75E0L});
    public static final BitSet FOLLOW_optionalRelations_in_service338 = new BitSet(new long[]{0x00000000017F75E0L});
    public static final BitSet FOLLOW_RBRACE_in_service348 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ADVICE_in_advice363 = new BitSet(new long[]{0x00000000017E7FF0L});
    public static final BitSet FOLLOW_adviceHeader_in_advice365 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_content_in_advice367 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_adviceHeader380 = new BitSet(new long[]{0x00000000017E7FF2L});
    public static final BitSet FOLLOW_preprocessor_in_declarations404 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_declaration_in_declarations408 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_24_in_preprocessor419 = new BitSet(new long[]{0x00000000017E5FF0L});
    public static final BitSet FOLLOW_set_in_preprocessor434 = new BitSet(new long[]{0x00000000017E7FF0L});
    public static final BitSet FOLLOW_NEWLINE_in_preprocessor459 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_declaration481 = new BitSet(new long[]{0x00000000017E7FF0L});
    public static final BitSet FOLLOW_set_in_declaration545 = new BitSet(new long[]{0x0000000001FEFFF2L});
    public static final BitSet FOLLOW_content_in_declaration562 = new BitSet(new long[]{0x0000000000800002L});
    public static final BitSet FOLLOW_23_in_declaration567 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LBRACE_in_content584 = new BitSet(new long[]{0x0000000001FFFFF0L});
    public static final BitSet FOLLOW_content_in_content588 = new BitSet(new long[]{0x0000000001FFFFF0L});
    public static final BitSet FOLLOW_set_in_content593 = new BitSet(new long[]{0x0000000001FFFFF0L});
    public static final BitSet FOLLOW_RBRACE_in_content607 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STARTUP_in_startup618 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_LBRACE_in_startup622 = new BitSet(new long[]{0x0000000000010980L});
    public static final BitSet FOLLOW_expose_in_startup625 = new BitSet(new long[]{0x0000000000010980L});
    public static final BitSet FOLLOW_advice_in_startup629 = new BitSet(new long[]{0x0000000000010980L});
    public static final BitSet FOLLOW_boot_in_startup633 = new BitSet(new long[]{0x0000000000010980L});
    public static final BitSet FOLLOW_RBRACE_in_startup638 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SHUTDOWN_in_shutdown649 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_LBRACE_in_shutdown653 = new BitSet(new long[]{0x0000000000010180L});
    public static final BitSet FOLLOW_expose_in_shutdown656 = new BitSet(new long[]{0x0000000000010180L});
    public static final BitSet FOLLOW_advice_in_shutdown660 = new BitSet(new long[]{0x0000000000010180L});
    public static final BitSet FOLLOW_RBRACE_in_shutdown664 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_BOOT_in_boot676 = new BitSet(new long[]{0x00000000017E7FF0L});
    public static final BitSet FOLLOW_set_in_boot681 = new BitSet(new long[]{0x0000000001FE7FF0L});
    public static final BitSet FOLLOW_23_in_boot698 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EXPOSE_in_expose716 = new BitSet(new long[]{0x000000000000A000L});
    public static final BitSet FOLLOW_NEWLINE_in_expose718 = new BitSet(new long[]{0x000000000000A000L});
    public static final BitSet FOLLOW_LBRACE_in_expose721 = new BitSet(new long[]{0x0000000000012200L});
    public static final BitSet FOLLOW_NEWLINE_in_expose723 = new BitSet(new long[]{0x0000000000012200L});
    public static final BitSet FOLLOW_pointcut_in_expose730 = new BitSet(new long[]{0x0000000000010200L});
    public static final BitSet FOLLOW_RBRACE_in_expose739 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REQUIRE_in_require754 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_SERVICE_NAME_in_require756 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_23_in_require762 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_POINTCUT_in_pointcut772 = new BitSet(new long[]{0x0000000001FFFFF0L});
    public static final BitSet FOLLOW_set_in_pointcut777 = new BitSet(new long[]{0x0000000001FFFFF0L});
    public static final BitSet FOLLOW_23_in_pointcut785 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_NEWLINE_in_pointcut787 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_FOR_in_optionalRelations803 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_SERVICE_NAME_in_optionalRelations805 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_LBRACE_in_optionalRelations811 = new BitSet(new long[]{0x00000000017F65E0L});
    public static final BitSet FOLLOW_require_in_optionalRelations820 = new BitSet(new long[]{0x00000000017F65E0L});
    public static final BitSet FOLLOW_startup_in_optionalRelations832 = new BitSet(new long[]{0x00000000017F65E0L});
    public static final BitSet FOLLOW_shutdown_in_optionalRelations840 = new BitSet(new long[]{0x00000000017F65E0L});
    public static final BitSet FOLLOW_expose_in_optionalRelations848 = new BitSet(new long[]{0x00000000017F65E0L});
    public static final BitSet FOLLOW_NEWLINE_in_optionalRelations861 = new BitSet(new long[]{0x00000000017F65E0L});
    public static final BitSet FOLLOW_advice_in_optionalRelations869 = new BitSet(new long[]{0x00000000017F65E0L});
    public static final BitSet FOLLOW_declarations_in_optionalRelations882 = new BitSet(new long[]{0x00000000017F65E0L});
    public static final BitSet FOLLOW_RBRACE_in_optionalRelations892 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_synpred34545 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_synpred39593 = new BitSet(new long[]{0x0000000000000002L});

}