// $ANTLR 3.0.1 /VMADL.j/src/de/sm/vmadl/Vmadl.g 2008-08-02 22:28:30

  package de.sm.vmadl;
  
  import de.sm.vmadl.elements.*;
  import java.io.File;
  import de.sm.odl.elements.TypeRef;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;


import org.antlr.runtime.tree.*;

public class VmadlParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "SERVICE", "STARTUP", "SHUTDOWN", "EXPOSE", "ADVICE", "POINTCUT", "REPLACE", "REQUIRE", "BOOT", "FOR", "TYPES", "COMBINE", "STATIC", "EXTERN", "CONST", "HEXPREFIX", "RESTRICT", "NEWLINE", "IDENTIFIER", "LBRACE", "RBRACE", "DIGIT", "LPARENTHESIS", "RPARENTHESIS", "PPCONTINUE", "LETTER", "SPECIAL", "WS", "COMMENT", "ML_COMMENT", "','", "'['", "']'", "'='", "';'", "'*'", "'a'", "'f'", "'A'", "'F'", "'#'", "'.'"
    };
    public static final int EXPOSE=7;
    public static final int RBRACE=24;
    public static final int LETTER=29;
    public static final int STATIC=16;
    public static final int CONST=18;
    public static final int COMBINE=15;
    public static final int LBRACE=23;
    public static final int FOR=13;
    public static final int TYPES=14;
    public static final int EXTERN=17;
    public static final int RPARENTHESIS=27;
    public static final int BOOT=12;
    public static final int EOF=-1;
    public static final int REQUIRE=11;
    public static final int LPARENTHESIS=26;
    public static final int ADVICE=8;
    public static final int RESTRICT=20;
    public static final int POINTCUT=9;
    public static final int ML_COMMENT=33;
    public static final int WS=31;
    public static final int PPCONTINUE=28;
    public static final int NEWLINE=21;
    public static final int SPECIAL=30;
    public static final int SERVICE=4;
    public static final int IDENTIFIER=22;
    public static final int REPLACE=10;
    public static final int SHUTDOWN=6;
    public static final int DIGIT=25;
    public static final int COMMENT=32;
    public static final int HEXPREFIX=19;
    public static final int STARTUP=5;

        public VmadlParser(TokenStream input) {
            super(input);
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "/VMADL.j/src/de/sm/vmadl/Vmadl.g"; }


    	private ServiceRegistry reg;
    	private CombinationRegistry combReg;
    	private File parsedFile;
    	
    	/**
    	* Make like error reporting for parser errors allows to benefit
    	* from IDE make integration.
    	*/
    	@Override
    	public void reportError(RecognitionException re) {
    	  String errorMsg = "";
    	  if (parsedFile != null) {
    	    errorMsg += parsedFile.getAbsolutePath();
    	  }
    	  
    	  errorMsg += ":" + re.line + ": error: ";
    	  System.err.print(errorMsg);
    	  super.reportError(re);
    	}
    	
    	/**
    	* Set the file which is actually parsed.
    	* Is used to be able to generate meaningful error messages.
    	* Is not used for parsing at all.
    	*/
    	public void setParsedFile(File file) {
    	  parsedFile = file;
    	}


    public static class architecture_return extends ParserRuleReturnScope {
        public List<ServiceModule> modules;
        public List<Combination> combinations;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start architecture
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:72:0: architecture[ServiceRegistry reg, CombinationRegistry combReg] returns [ List<ServiceModule> modules, List<Combination> combinations ] : ( NEWLINE | service | combination )* EOF ;
    public final architecture_return architecture(ServiceRegistry reg, CombinationRegistry combReg) throws RecognitionException {
        architecture_return retval = new architecture_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token NEWLINE1=null;
        Token EOF4=null;
        service_return service2 = null;

        combination_return combination3 = null;


        Object NEWLINE1_tree=null;
        Object EOF4_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:73:74: ( ( NEWLINE | service | combination )* EOF )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:74:1: ( NEWLINE | service | combination )* EOF
            {
            root_0 = (Object)adaptor.nil();

             
            	retval.modules = new ArrayList<ServiceModule>();
            	retval.combinations = new ArrayList<Combination>();
            	
            	this.reg = reg;
            	this.combReg = combReg;

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:82:5: ( NEWLINE | service | combination )*
            loop1:
            do {
                int alt1=4;
                switch ( input.LA(1) ) {
                case NEWLINE:
                    {
                    alt1=1;
                    }
                    break;
                case SERVICE:
                    {
                    alt1=2;
                    }
                    break;
                case COMBINE:
                    {
                    alt1=3;
                    }
                    break;

                }

                switch (alt1) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:83:6: NEWLINE
            	    {
            	    NEWLINE1=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_architecture303); 

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:84:8: service
            	    {
            	    pushFollow(FOLLOW_service_in_architecture313);
            	    service2=service();
            	    _fsp--;

            	    adaptor.addChild(root_0, service2.getTree());
            	     retval.modules.add(service2.s);

            	    }
            	    break;
            	case 3 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:85:8: combination
            	    {
            	    pushFollow(FOLLOW_combination_in_architecture324);
            	    combination3=combination();
            	    _fsp--;

            	    adaptor.addChild(root_0, combination3.getTree());
            	     retval.combinations.add(combination3.c); 

            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            EOF4=(Token)input.LT(1);
            match(input,EOF,FOLLOW_EOF_in_architecture336); 

            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end architecture

    public static class interaction_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start interaction
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:89:0: interaction : ( NEWLINE | combination )* EOF ;
    public final interaction_return interaction() throws RecognitionException {
        interaction_return retval = new interaction_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token NEWLINE5=null;
        Token EOF7=null;
        combination_return combination6 = null;


        Object NEWLINE5_tree=null;
        Object EOF7_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:89:12: ( ( NEWLINE | combination )* EOF )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:90:3: ( NEWLINE | combination )* EOF
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:90:3: ( NEWLINE | combination )*
            loop2:
            do {
                int alt2=3;
                int LA2_0 = input.LA(1);

                if ( (LA2_0==NEWLINE) ) {
                    alt2=1;
                }
                else if ( (LA2_0==COMBINE) ) {
                    alt2=2;
                }


                switch (alt2) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:90:5: NEWLINE
            	    {
            	    NEWLINE5=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_interaction349); 

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:90:16: combination
            	    {
            	    pushFollow(FOLLOW_combination_in_interaction354);
            	    combination6=combination();
            	    _fsp--;

            	    adaptor.addChild(root_0, combination6.getTree());

            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

            EOF7=(Token)input.LT(1);
            match(input,EOF,FOLLOW_EOF_in_interaction359); 

            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end interaction

    public static class combination_return extends ParserRuleReturnScope {
        public Combination c;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start combination
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:93:0: combination returns [Combination c] : COMBINE a= IDENTIFIER ',' b= IDENTIFIER LBRACE ( combinationContent[$c] )* RBRACE ;
    public final combination_return combination() throws RecognitionException {
        combination_return retval = new combination_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token a=null;
        Token b=null;
        Token COMBINE8=null;
        Token char_literal9=null;
        Token LBRACE10=null;
        Token RBRACE12=null;
        combinationContent_return combinationContent11 = null;


        Object a_tree=null;
        Object b_tree=null;
        Object COMBINE8_tree=null;
        Object char_literal9_tree=null;
        Object LBRACE10_tree=null;
        Object RBRACE12_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:93:36: ( COMBINE a= IDENTIFIER ',' b= IDENTIFIER LBRACE ( combinationContent[$c] )* RBRACE )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:94:3: COMBINE a= IDENTIFIER ',' b= IDENTIFIER LBRACE ( combinationContent[$c] )* RBRACE
            {
            root_0 = (Object)adaptor.nil();

            COMBINE8=(Token)input.LT(1);
            match(input,COMBINE,FOLLOW_COMBINE_in_combination374); 
            COMBINE8_tree = (Object)adaptor.create(COMBINE8);
            adaptor.addChild(root_0, COMBINE8_tree);

            a=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_combination378); 
            a_tree = (Object)adaptor.create(a);
            adaptor.addChild(root_0, a_tree);

            char_literal9=(Token)input.LT(1);
            match(input,34,FOLLOW_34_in_combination380); 
            char_literal9_tree = (Object)adaptor.create(char_literal9);
            adaptor.addChild(root_0, char_literal9_tree);

            b=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_combination384); 
            b_tree = (Object)adaptor.create(b);
            adaptor.addChild(root_0, b_tree);

             retval.c = combReg.get(new CombinationId(reg.get(a.getText()), reg.get(b.getText()))); 
            LBRACE10=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_combination393); 
            LBRACE10_tree = (Object)adaptor.create(LBRACE10);
            adaptor.addChild(root_0, LBRACE10_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:96:10: ( combinationContent[$c] )*
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( ((LA3_0>=STARTUP && LA3_0<=SHUTDOWN)||LA3_0==ADVICE||LA3_0==REQUIRE||(LA3_0>=STATIC && LA3_0<=CONST)||(LA3_0>=NEWLINE && LA3_0<=IDENTIFIER)||LA3_0==44) ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:96:12: combinationContent[$c]
            	    {
            	    pushFollow(FOLLOW_combinationContent_in_combination397);
            	    combinationContent11=combinationContent(retval.c);
            	    _fsp--;

            	    adaptor.addChild(root_0, combinationContent11.getTree());

            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);

            RBRACE12=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_combination403); 
            RBRACE12_tree = (Object)adaptor.create(RBRACE12);
            adaptor.addChild(root_0, RBRACE12_tree);

             retval.c.lazyInitWith(retval, parsedFile); 

            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end combination

    public static class service_return extends ParserRuleReturnScope {
        public ServiceModule s;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start service
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:101:0: service returns [ServiceModule s] : SERVICE IDENTIFIER LBRACE ( basicModuleContent[$s] )* RBRACE ;
    public final service_return service() throws RecognitionException {
        service_return retval = new service_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token SERVICE13=null;
        Token IDENTIFIER14=null;
        Token LBRACE15=null;
        Token RBRACE17=null;
        basicModuleContent_return basicModuleContent16 = null;


        Object SERVICE13_tree=null;
        Object IDENTIFIER14_tree=null;
        Object LBRACE15_tree=null;
        Object RBRACE17_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:101:35: ( SERVICE IDENTIFIER LBRACE ( basicModuleContent[$s] )* RBRACE )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:102:3: SERVICE IDENTIFIER LBRACE ( basicModuleContent[$s] )* RBRACE
            {
            root_0 = (Object)adaptor.nil();

            SERVICE13=(Token)input.LT(1);
            match(input,SERVICE,FOLLOW_SERVICE_in_service423); 
            SERVICE13_tree = (Object)adaptor.create(SERVICE13);
            adaptor.addChild(root_0, SERVICE13_tree);

            IDENTIFIER14=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_service425); 
            IDENTIFIER14_tree = (Object)adaptor.create(IDENTIFIER14);
            adaptor.addChild(root_0, IDENTIFIER14_tree);

             retval.s = reg.get(IDENTIFIER14.getText()); 
            LBRACE15=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_service431); 
            LBRACE15_tree = (Object)adaptor.create(LBRACE15);
            adaptor.addChild(root_0, LBRACE15_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:103:10: ( basicModuleContent[$s] )*
            loop4:
            do {
                int alt4=2;
                int LA4_0 = input.LA(1);

                if ( (LA4_0==EXPOSE||(LA4_0>=REPLACE && LA4_0<=REQUIRE)||(LA4_0>=TYPES && LA4_0<=IDENTIFIER)||(LA4_0>=DIGIT && LA4_0<=37)||(LA4_0>=39 && LA4_0<=45)) ) {
                    alt4=1;
                }


                switch (alt4) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:103:12: basicModuleContent[$s]
            	    {
            	    pushFollow(FOLLOW_basicModuleContent_in_service435);
            	    basicModuleContent16=basicModuleContent(retval.s);
            	    _fsp--;

            	    adaptor.addChild(root_0, basicModuleContent16.getTree());

            	    }
            	    break;

            	default :
            	    break loop4;
                }
            } while (true);

            RBRACE17=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_service441); 
            RBRACE17_tree = (Object)adaptor.create(RBRACE17);
            adaptor.addChild(root_0, RBRACE17_tree);

             retval.s.initialized = true; 

            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end service

    public static class basicModuleContent_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start basicModuleContent
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:108:0: basicModuleContent[ ServiceInterface s ] : ( require | expose | declarations | types | namedPart[$s] | replace[$s] | NEWLINE );
    public final basicModuleContent_return basicModuleContent(ServiceInterface s) throws RecognitionException {
        basicModuleContent_return retval = new basicModuleContent_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token NEWLINE24=null;
        require_return require18 = null;

        expose_return expose19 = null;

        declarations_return declarations20 = null;

        types_return types21 = null;

        namedPart_return namedPart22 = null;

        replace_return replace23 = null;


        Object NEWLINE24_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:108:42: ( require | expose | declarations | types | namedPart[$s] | replace[$s] | NEWLINE )
            int alt5=7;
            switch ( input.LA(1) ) {
            case REQUIRE:
                {
                alt5=1;
                }
                break;
            case EXPOSE:
                {
                alt5=2;
                }
                break;
            case COMBINE:
            case STATIC:
            case EXTERN:
            case CONST:
            case HEXPREFIX:
            case RESTRICT:
            case DIGIT:
            case LPARENTHESIS:
            case RPARENTHESIS:
            case PPCONTINUE:
            case LETTER:
            case SPECIAL:
            case WS:
            case COMMENT:
            case ML_COMMENT:
            case 34:
            case 35:
            case 36:
            case 37:
            case 39:
            case 40:
            case 41:
            case 42:
            case 43:
            case 44:
            case 45:
                {
                alt5=3;
                }
                break;
            case TYPES:
                {
                int LA5_4 = input.LA(2);

                if ( ((LA5_4>=SERVICE && LA5_4<=IDENTIFIER)||(LA5_4>=DIGIT && LA5_4<=37)||(LA5_4>=39 && LA5_4<=45)) ) {
                    alt5=3;
                }
                else if ( (LA5_4==LBRACE) ) {
                    alt5=4;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("108:0: basicModuleContent[ ServiceInterface s ] : ( require | expose | declarations | types | namedPart[$s] | replace[$s] | NEWLINE );", 5, 4, input);

                    throw nvae;
                }
                }
                break;
            case IDENTIFIER:
                {
                int LA5_5 = input.LA(2);

                if ( (LA5_5==LBRACE) ) {
                    alt5=5;
                }
                else if ( ((LA5_5>=SERVICE && LA5_5<=IDENTIFIER)||(LA5_5>=DIGIT && LA5_5<=37)||(LA5_5>=39 && LA5_5<=45)) ) {
                    alt5=3;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("108:0: basicModuleContent[ ServiceInterface s ] : ( require | expose | declarations | types | namedPart[$s] | replace[$s] | NEWLINE );", 5, 5, input);

                    throw nvae;
                }
                }
                break;
            case REPLACE:
                {
                alt5=6;
                }
                break;
            case NEWLINE:
                {
                alt5=7;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("108:0: basicModuleContent[ ServiceInterface s ] : ( require | expose | declarations | types | namedPart[$s] | replace[$s] | NEWLINE );", 5, 0, input);

                throw nvae;
            }

            switch (alt5) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:109:4: require
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_require_in_basicModuleContent459);
                    require18=require();
                    _fsp--;

                    adaptor.addChild(root_0, require18.getTree());
                     s.requirements.add(require18.service); 

                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:110:7: expose
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_expose_in_basicModuleContent472);
                    expose19=expose();
                    _fsp--;

                    adaptor.addChild(root_0, expose19.getTree());
                     s.pointcuts = expose19.pointcuts; 

                    }
                    break;
                case 3 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:111:7: declarations
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_declarations_in_basicModuleContent485);
                    declarations20=declarations();
                    _fsp--;

                    adaptor.addChild(root_0, declarations20.getTree());
                     s.declarations.add(input.toString(declarations20.start,declarations20.stop)); 

                    }
                    break;
                case 4 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:113:7: types
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_types_in_basicModuleContent500);
                    types21=types();
                    _fsp--;

                    adaptor.addChild(root_0, types21.getTree());
                     s.typesSection = types21.content; 

                    }
                    break;
                case 5 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:114:7: namedPart[$s]
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_namedPart_in_basicModuleContent513);
                    namedPart22=namedPart(s);
                    _fsp--;

                    adaptor.addChild(root_0, namedPart22.getTree());

                    }
                    break;
                case 6 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:115:7: replace[$s]
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_replace_in_basicModuleContent522);
                    replace23=replace(s);
                    _fsp--;

                    adaptor.addChild(root_0, replace23.getTree());

                    }
                    break;
                case 7 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:116:7: NEWLINE
                    {
                    root_0 = (Object)adaptor.nil();

                    NEWLINE24=(Token)input.LT(1);
                    match(input,NEWLINE,FOLLOW_NEWLINE_in_basicModuleContent531); 
                    NEWLINE24_tree = (Object)adaptor.create(NEWLINE24);
                    adaptor.addChild(root_0, NEWLINE24_tree);


                    }
                    break;

            }
            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end basicModuleContent

    public static class combinationContent_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start combinationContent
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:119:0: combinationContent[Combination c] : ( require | advice | startup | shutdown | preprocessor | variable | function | NEWLINE );
    public final combinationContent_return combinationContent(Combination c) throws RecognitionException {
        combinationContent_return retval = new combinationContent_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token NEWLINE32=null;
        require_return require25 = null;

        advice_return advice26 = null;

        startup_return startup27 = null;

        shutdown_return shutdown28 = null;

        preprocessor_return preprocessor29 = null;

        variable_return variable30 = null;

        function_return function31 = null;


        Object NEWLINE32_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:119:35: ( require | advice | startup | shutdown | preprocessor | variable | function | NEWLINE )
            int alt6=8;
            alt6 = dfa6.predict(input);
            switch (alt6) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:120:3: require
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_require_in_combinationContent543);
                    require25=require();
                    _fsp--;

                    adaptor.addChild(root_0, require25.getTree());
                     c.requirements.add(require25.service); 

                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:121:5: advice
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_advice_in_combinationContent561);
                    advice26=advice();
                    _fsp--;

                    adaptor.addChild(root_0, advice26.getTree());
                     c.advices.add(advice26.adv); 

                    }
                    break;
                case 3 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:122:5: startup
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_startup_in_combinationContent578);
                    startup27=startup();
                    _fsp--;

                    adaptor.addChild(root_0, startup27.getTree());

                    }
                    break;
                case 4 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:123:5: shutdown
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_shutdown_in_combinationContent584);
                    shutdown28=shutdown();
                    _fsp--;

                    adaptor.addChild(root_0, shutdown28.getTree());

                    }
                    break;
                case 5 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:124:5: preprocessor
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_preprocessor_in_combinationContent590);
                    preprocessor29=preprocessor();
                    _fsp--;

                    adaptor.addChild(root_0, preprocessor29.getTree());
                     c.preprocessor.add(input.toString(preprocessor29.start,preprocessor29.stop)); 

                    }
                    break;
                case 6 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:125:5: variable
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_variable_in_combinationContent601);
                    variable30=variable();
                    _fsp--;

                    adaptor.addChild(root_0, variable30.getTree());
                     c.variables.add(variable30.var); 

                    }
                    break;
                case 7 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:126:5: function
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_function_in_combinationContent616);
                    function31=function();
                    _fsp--;

                    adaptor.addChild(root_0, function31.getTree());
                     c.functions.add(function31.func); 

                    }
                    break;
                case 8 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:127:5: NEWLINE
                    {
                    root_0 = (Object)adaptor.nil();

                    NEWLINE32=(Token)input.LT(1);
                    match(input,NEWLINE,FOLLOW_NEWLINE_in_combinationContent631); 
                    NEWLINE32_tree = (Object)adaptor.create(NEWLINE32);
                    adaptor.addChild(root_0, NEWLINE32_tree);


                    }
                    break;

            }
            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end combinationContent

    public static class literalValue_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start literalValue
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:130:0: literalValue : ( IDENTIFIER | ( DIGIT )+ | hexValue );
    public final literalValue_return literalValue() throws RecognitionException {
        literalValue_return retval = new literalValue_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token IDENTIFIER33=null;
        Token DIGIT34=null;
        hexValue_return hexValue35 = null;


        Object IDENTIFIER33_tree=null;
        Object DIGIT34_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:130:13: ( IDENTIFIER | ( DIGIT )+ | hexValue )
            int alt8=3;
            switch ( input.LA(1) ) {
            case IDENTIFIER:
                {
                alt8=1;
                }
                break;
            case DIGIT:
                {
                alt8=2;
                }
                break;
            case HEXPREFIX:
                {
                alt8=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("130:0: literalValue : ( IDENTIFIER | ( DIGIT )+ | hexValue );", 8, 0, input);

                throw nvae;
            }

            switch (alt8) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:131:3: IDENTIFIER
                    {
                    root_0 = (Object)adaptor.nil();

                    IDENTIFIER33=(Token)input.LT(1);
                    match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_literalValue641); 
                    IDENTIFIER33_tree = (Object)adaptor.create(IDENTIFIER33);
                    adaptor.addChild(root_0, IDENTIFIER33_tree);


                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:131:16: ( DIGIT )+
                    {
                    root_0 = (Object)adaptor.nil();

                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:131:16: ( DIGIT )+
                    int cnt7=0;
                    loop7:
                    do {
                        int alt7=2;
                        int LA7_0 = input.LA(1);

                        if ( (LA7_0==DIGIT) ) {
                            alt7=1;
                        }


                        switch (alt7) {
                    	case 1 :
                    	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:131:16: DIGIT
                    	    {
                    	    DIGIT34=(Token)input.LT(1);
                    	    match(input,DIGIT,FOLLOW_DIGIT_in_literalValue645); 
                    	    DIGIT34_tree = (Object)adaptor.create(DIGIT34);
                    	    adaptor.addChild(root_0, DIGIT34_tree);


                    	    }
                    	    break;

                    	default :
                    	    if ( cnt7 >= 1 ) break loop7;
                                EarlyExitException eee =
                                    new EarlyExitException(7, input);
                                throw eee;
                        }
                        cnt7++;
                    } while (true);


                    }
                    break;
                case 3 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:131:25: hexValue
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_hexValue_in_literalValue650);
                    hexValue35=hexValue();
                    _fsp--;

                    adaptor.addChild(root_0, hexValue35.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end literalValue

    public static class variable_return extends ParserRuleReturnScope {
        public Variable var;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start variable
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:134:0: variable returns [ Variable var ] : ( STATIC | EXTERN )? typeRef IDENTIFIER ( '[' arrDim= literalValue ']' )? ( '=' val= literalValue )? ';' ;
    public final variable_return variable() throws RecognitionException {
        variable_return retval = new variable_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token STATIC36=null;
        Token EXTERN37=null;
        Token IDENTIFIER39=null;
        Token char_literal40=null;
        Token char_literal41=null;
        Token char_literal42=null;
        Token char_literal43=null;
        literalValue_return arrDim = null;

        literalValue_return val = null;

        typeRef_return typeRef38 = null;


        Object STATIC36_tree=null;
        Object EXTERN37_tree=null;
        Object IDENTIFIER39_tree=null;
        Object char_literal40_tree=null;
        Object char_literal41_tree=null;
        Object char_literal42_tree=null;
        Object char_literal43_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:134:34: ( ( STATIC | EXTERN )? typeRef IDENTIFIER ( '[' arrDim= literalValue ']' )? ( '=' val= literalValue )? ';' )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:135:3: ( STATIC | EXTERN )? typeRef IDENTIFIER ( '[' arrDim= literalValue ']' )? ( '=' val= literalValue )? ';'
            {
            root_0 = (Object)adaptor.nil();

             retval.var = new Variable(); 
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:136:3: ( STATIC | EXTERN )?
            int alt9=3;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==STATIC) ) {
                alt9=1;
            }
            else if ( (LA9_0==EXTERN) ) {
                alt9=2;
            }
            switch (alt9) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:136:4: STATIC
                    {
                    STATIC36=(Token)input.LT(1);
                    match(input,STATIC,FOLLOW_STATIC_in_variable669); 
                    STATIC36_tree = (Object)adaptor.create(STATIC36);
                    adaptor.addChild(root_0, STATIC36_tree);

                     retval.var.isStatic = true; 

                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:136:38: EXTERN
                    {
                    EXTERN37=(Token)input.LT(1);
                    match(input,EXTERN,FOLLOW_EXTERN_in_variable674); 
                    EXTERN37_tree = (Object)adaptor.create(EXTERN37);
                    adaptor.addChild(root_0, EXTERN37_tree);

                     retval.var.isExtern = true; 

                    }
                    break;

            }

            pushFollow(FOLLOW_typeRef_in_variable682);
            typeRef38=typeRef();
            _fsp--;

            adaptor.addChild(root_0, typeRef38.getTree());
             retval.var.type = typeRef38.ref; 
            IDENTIFIER39=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_variable693); 
            IDENTIFIER39_tree = (Object)adaptor.create(IDENTIFIER39);
            adaptor.addChild(root_0, IDENTIFIER39_tree);

             retval.var.name = IDENTIFIER39.getText(); 
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:139:3: ( '[' arrDim= literalValue ']' )?
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==35) ) {
                alt10=1;
            }
            switch (alt10) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:139:4: '[' arrDim= literalValue ']'
                    {
                    char_literal40=(Token)input.LT(1);
                    match(input,35,FOLLOW_35_in_variable701); 
                    char_literal40_tree = (Object)adaptor.create(char_literal40);
                    adaptor.addChild(root_0, char_literal40_tree);

                    pushFollow(FOLLOW_literalValue_in_variable705);
                    arrDim=literalValue();
                    _fsp--;

                    adaptor.addChild(root_0, arrDim.getTree());
                    char_literal41=(Token)input.LT(1);
                    match(input,36,FOLLOW_36_in_variable707); 
                    char_literal41_tree = (Object)adaptor.create(char_literal41);
                    adaptor.addChild(root_0, char_literal41_tree);

                     retval.var.arrayDim = input.toString(arrDim.start,arrDim.stop); 

                    }
                    break;

            }

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:140:3: ( '=' val= literalValue )?
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( (LA11_0==37) ) {
                alt11=1;
            }
            switch (alt11) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:140:5: '=' val= literalValue
                    {
                    char_literal42=(Token)input.LT(1);
                    match(input,37,FOLLOW_37_in_variable717); 
                    char_literal42_tree = (Object)adaptor.create(char_literal42);
                    adaptor.addChild(root_0, char_literal42_tree);

                    pushFollow(FOLLOW_literalValue_in_variable721);
                    val=literalValue();
                    _fsp--;

                    adaptor.addChild(root_0, val.getTree());
                     retval.var.value = input.toString(val.start,val.stop); 

                    }
                    break;

            }

            char_literal43=(Token)input.LT(1);
            match(input,38,FOLLOW_38_in_variable729); 
            char_literal43_tree = (Object)adaptor.create(char_literal43);
            adaptor.addChild(root_0, char_literal43_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end variable

    public static class typeRef_return extends ParserRuleReturnScope {
        public TypeRef ref;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start typeRef
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:144:0: typeRef returns [ TypeRef ref ] : ( CONST )? IDENTIFIER ( '*' )* ( RESTRICT )? ( CONST )? ;
    public final typeRef_return typeRef() throws RecognitionException {
        typeRef_return retval = new typeRef_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token CONST44=null;
        Token IDENTIFIER45=null;
        Token char_literal46=null;
        Token RESTRICT47=null;
        Token CONST48=null;

        Object CONST44_tree=null;
        Object IDENTIFIER45_tree=null;
        Object char_literal46_tree=null;
        Object RESTRICT47_tree=null;
        Object CONST48_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:144:32: ( ( CONST )? IDENTIFIER ( '*' )* ( RESTRICT )? ( CONST )? )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:145:3: ( CONST )? IDENTIFIER ( '*' )* ( RESTRICT )? ( CONST )?
            {
            root_0 = (Object)adaptor.nil();

             retval.ref = new TypeRef(); 
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:146:3: ( CONST )?
            int alt12=2;
            int LA12_0 = input.LA(1);

            if ( (LA12_0==CONST) ) {
                alt12=1;
            }
            switch (alt12) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:146:4: CONST
                    {
                    CONST44=(Token)input.LT(1);
                    match(input,CONST,FOLLOW_CONST_in_typeRef748); 
                    CONST44_tree = (Object)adaptor.create(CONST44);
                    adaptor.addChild(root_0, CONST44_tree);

                     retval.ref.constQ = true; 

                    }
                    break;

            }

            IDENTIFIER45=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_typeRef756); 
            IDENTIFIER45_tree = (Object)adaptor.create(IDENTIFIER45);
            adaptor.addChild(root_0, IDENTIFIER45_tree);

             retval.ref.name = IDENTIFIER45.getText(); 
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:148:3: ( '*' )*
            loop13:
            do {
                int alt13=2;
                int LA13_0 = input.LA(1);

                if ( (LA13_0==39) ) {
                    alt13=1;
                }


                switch (alt13) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:148:4: '*'
            	    {
            	    char_literal46=(Token)input.LT(1);
            	    match(input,39,FOLLOW_39_in_typeRef763); 
            	    char_literal46_tree = (Object)adaptor.create(char_literal46);
            	    adaptor.addChild(root_0, char_literal46_tree);

            	     retval.ref.incPtr(); 

            	    }
            	    break;

            	default :
            	    break loop13;
                }
            } while (true);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:149:3: ( RESTRICT )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==RESTRICT) ) {
                alt14=1;
            }
            switch (alt14) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:149:4: RESTRICT
                    {
                    RESTRICT47=(Token)input.LT(1);
                    match(input,RESTRICT,FOLLOW_RESTRICT_in_typeRef773); 
                    RESTRICT47_tree = (Object)adaptor.create(RESTRICT47);
                    adaptor.addChild(root_0, RESTRICT47_tree);

                     retval.ref.restrictQ = true; 

                    }
                    break;

            }

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:150:3: ( CONST )?
            int alt15=2;
            int LA15_0 = input.LA(1);

            if ( (LA15_0==CONST) ) {
                alt15=1;
            }
            switch (alt15) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:150:4: CONST
                    {
                    CONST48=(Token)input.LT(1);
                    match(input,CONST,FOLLOW_CONST_in_typeRef782); 
                    CONST48_tree = (Object)adaptor.create(CONST48);
                    adaptor.addChild(root_0, CONST48_tree);

                     retval.ref.constQ2 = true; 

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end typeRef

    public static class hexValue_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start hexValue
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:153:0: hexValue : HEXPREFIX ( DIGIT | 'a' .. 'f' | 'A' .. 'F' )+ ;
    public final hexValue_return hexValue() throws RecognitionException {
        hexValue_return retval = new hexValue_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token HEXPREFIX49=null;
        Token set50=null;

        Object HEXPREFIX49_tree=null;
        Object set50_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:153:9: ( HEXPREFIX ( DIGIT | 'a' .. 'f' | 'A' .. 'F' )+ )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:154:3: HEXPREFIX ( DIGIT | 'a' .. 'f' | 'A' .. 'F' )+
            {
            root_0 = (Object)adaptor.nil();

            HEXPREFIX49=(Token)input.LT(1);
            match(input,HEXPREFIX,FOLLOW_HEXPREFIX_in_hexValue796); 
            HEXPREFIX49_tree = (Object)adaptor.create(HEXPREFIX49);
            adaptor.addChild(root_0, HEXPREFIX49_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:154:13: ( DIGIT | 'a' .. 'f' | 'A' .. 'F' )+
            int cnt16=0;
            loop16:
            do {
                int alt16=2;
                int LA16_0 = input.LA(1);

                if ( (LA16_0==DIGIT) ) {
                    alt16=1;
                }


                switch (alt16) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:
            	    {
            	    set50=(Token)input.LT(1);
            	    if ( input.LA(1)==DIGIT ) {
            	        input.consume();
            	        adaptor.addChild(root_0, adaptor.create(set50));
            	        errorRecovery=false;
            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_hexValue798);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt16 >= 1 ) break loop16;
                        EarlyExitException eee =
                            new EarlyExitException(16, input);
                        throw eee;
                }
                cnt16++;
            } while (true);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end hexValue

    public static class function_return extends ParserRuleReturnScope {
        public Function func;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start function
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:157:0: function returns [ Function func ] : ( STATIC | EXTERN )? returnType= typeRef name= IDENTIFIER LPARENTHESIS (paramType= typeRef (paramName= IDENTIFIER )? ( ',' moreParam= typeRef (moreName= IDENTIFIER )? )* )? RPARENTHESIS ( content | ';' ) ;
    public final function_return function() throws RecognitionException {
        function_return retval = new function_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token name=null;
        Token paramName=null;
        Token moreName=null;
        Token STATIC51=null;
        Token EXTERN52=null;
        Token LPARENTHESIS53=null;
        Token char_literal54=null;
        Token RPARENTHESIS55=null;
        Token char_literal57=null;
        typeRef_return returnType = null;

        typeRef_return paramType = null;

        typeRef_return moreParam = null;

        content_return content56 = null;


        Object name_tree=null;
        Object paramName_tree=null;
        Object moreName_tree=null;
        Object STATIC51_tree=null;
        Object EXTERN52_tree=null;
        Object LPARENTHESIS53_tree=null;
        Object char_literal54_tree=null;
        Object RPARENTHESIS55_tree=null;
        Object char_literal57_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:157:35: ( ( STATIC | EXTERN )? returnType= typeRef name= IDENTIFIER LPARENTHESIS (paramType= typeRef (paramName= IDENTIFIER )? ( ',' moreParam= typeRef (moreName= IDENTIFIER )? )* )? RPARENTHESIS ( content | ';' ) )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:158:3: ( STATIC | EXTERN )? returnType= typeRef name= IDENTIFIER LPARENTHESIS (paramType= typeRef (paramName= IDENTIFIER )? ( ',' moreParam= typeRef (moreName= IDENTIFIER )? )* )? RPARENTHESIS ( content | ';' )
            {
            root_0 = (Object)adaptor.nil();

             retval.func = new Function(retval, parsedFile); 
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:159:3: ( STATIC | EXTERN )?
            int alt17=3;
            int LA17_0 = input.LA(1);

            if ( (LA17_0==STATIC) ) {
                alt17=1;
            }
            else if ( (LA17_0==EXTERN) ) {
                alt17=2;
            }
            switch (alt17) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:159:4: STATIC
                    {
                    STATIC51=(Token)input.LT(1);
                    match(input,STATIC,FOLLOW_STATIC_in_function832); 
                    STATIC51_tree = (Object)adaptor.create(STATIC51);
                    adaptor.addChild(root_0, STATIC51_tree);

                     retval.func.isStatic = true; 

                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:159:39: EXTERN
                    {
                    EXTERN52=(Token)input.LT(1);
                    match(input,EXTERN,FOLLOW_EXTERN_in_function837); 
                    EXTERN52_tree = (Object)adaptor.create(EXTERN52);
                    adaptor.addChild(root_0, EXTERN52_tree);

                    retval.func.isExtern = true; 

                    }
                    break;

            }

            pushFollow(FOLLOW_typeRef_in_function847);
            returnType=typeRef();
            _fsp--;

            adaptor.addChild(root_0, returnType.getTree());
            name=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_function851); 
            name_tree = (Object)adaptor.create(name);
            adaptor.addChild(root_0, name_tree);

             retval.func.name = name.getText();
                retval.func.returnType = returnType.ref;
              
            LPARENTHESIS53=(Token)input.LT(1);
            match(input,LPARENTHESIS,FOLLOW_LPARENTHESIS_in_function860); 
            LPARENTHESIS53_tree = (Object)adaptor.create(LPARENTHESIS53);
            adaptor.addChild(root_0, LPARENTHESIS53_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:165:5: (paramType= typeRef (paramName= IDENTIFIER )? ( ',' moreParam= typeRef (moreName= IDENTIFIER )? )* )?
            int alt21=2;
            int LA21_0 = input.LA(1);

            if ( (LA21_0==CONST||LA21_0==IDENTIFIER) ) {
                alt21=1;
            }
            switch (alt21) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:165:6: paramType= typeRef (paramName= IDENTIFIER )? ( ',' moreParam= typeRef (moreName= IDENTIFIER )? )*
                    {
                    pushFollow(FOLLOW_typeRef_in_function869);
                    paramType=typeRef();
                    _fsp--;

                    adaptor.addChild(root_0, paramType.getTree());
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:165:33: (paramName= IDENTIFIER )?
                    int alt18=2;
                    int LA18_0 = input.LA(1);

                    if ( (LA18_0==IDENTIFIER) ) {
                        alt18=1;
                    }
                    switch (alt18) {
                        case 1 :
                            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:165:33: paramName= IDENTIFIER
                            {
                            paramName=(Token)input.LT(1);
                            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_function873); 
                            paramName_tree = (Object)adaptor.create(paramName);
                            adaptor.addChild(root_0, paramName_tree);


                            }
                            break;

                    }

                    retval.func.addParam((paramName != null)?paramName.getText():null, paramType.ref);
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:166:7: ( ',' moreParam= typeRef (moreName= IDENTIFIER )? )*
                    loop20:
                    do {
                        int alt20=2;
                        int LA20_0 = input.LA(1);

                        if ( (LA20_0==34) ) {
                            alt20=1;
                        }


                        switch (alt20) {
                    	case 1 :
                    	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:166:8: ',' moreParam= typeRef (moreName= IDENTIFIER )?
                    	    {
                    	    char_literal54=(Token)input.LT(1);
                    	    match(input,34,FOLLOW_34_in_function887); 
                    	    char_literal54_tree = (Object)adaptor.create(char_literal54);
                    	    adaptor.addChild(root_0, char_literal54_tree);

                    	    pushFollow(FOLLOW_typeRef_in_function891);
                    	    moreParam=typeRef();
                    	    _fsp--;

                    	    adaptor.addChild(root_0, moreParam.getTree());
                    	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:166:38: (moreName= IDENTIFIER )?
                    	    int alt19=2;
                    	    int LA19_0 = input.LA(1);

                    	    if ( (LA19_0==IDENTIFIER) ) {
                    	        alt19=1;
                    	    }
                    	    switch (alt19) {
                    	        case 1 :
                    	            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:166:38: moreName= IDENTIFIER
                    	            {
                    	            moreName=(Token)input.LT(1);
                    	            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_function895); 
                    	            moreName_tree = (Object)adaptor.create(moreName);
                    	            adaptor.addChild(root_0, moreName_tree);


                    	            }
                    	            break;

                    	    }

                    	    retval.func.addParam((moreName != null)?moreName.getText():null, moreParam.ref);

                    	    }
                    	    break;

                    	default :
                    	    break loop20;
                        }
                    } while (true);


                    }
                    break;

            }

            RPARENTHESIS55=(Token)input.LT(1);
            match(input,RPARENTHESIS,FOLLOW_RPARENTHESIS_in_function919); 
            RPARENTHESIS55_tree = (Object)adaptor.create(RPARENTHESIS55);
            adaptor.addChild(root_0, RPARENTHESIS55_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:170:3: ( content | ';' )
            int alt22=2;
            int LA22_0 = input.LA(1);

            if ( (LA22_0==LBRACE) ) {
                alt22=1;
            }
            else if ( (LA22_0==38) ) {
                alt22=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("170:3: ( content | ';' )", 22, 0, input);

                throw nvae;
            }
            switch (alt22) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:170:4: content
                    {
                    pushFollow(FOLLOW_content_in_function924);
                    content56=content();
                    _fsp--;

                    adaptor.addChild(root_0, content56.getTree());
                     retval.func.body = content56.content; 

                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:170:48: ';'
                    {
                    char_literal57=(Token)input.LT(1);
                    match(input,38,FOLLOW_38_in_function929); 
                    char_literal57_tree = (Object)adaptor.create(char_literal57);
                    adaptor.addChild(root_0, char_literal57_tree);

                     retval.func.isDecl = true; 

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end function

    public static class namedPart_return extends ParserRuleReturnScope {
        public ServiceInterface m;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start namedPart
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:173:0: namedPart[ServiceInterface s] returns [ ServiceInterface m ] : IDENTIFIER LBRACE ( basicModuleContent[$m] )* RBRACE ;
    public final namedPart_return namedPart(ServiceInterface s) throws RecognitionException {
        namedPart_return retval = new namedPart_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token IDENTIFIER58=null;
        Token LBRACE59=null;
        Token RBRACE61=null;
        basicModuleContent_return basicModuleContent60 = null;


        Object IDENTIFIER58_tree=null;
        Object LBRACE59_tree=null;
        Object RBRACE61_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:173:62: ( IDENTIFIER LBRACE ( basicModuleContent[$m] )* RBRACE )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:174:3: IDENTIFIER LBRACE ( basicModuleContent[$m] )* RBRACE
            {
            root_0 = (Object)adaptor.nil();

            IDENTIFIER58=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_namedPart948); 
            IDENTIFIER58_tree = (Object)adaptor.create(IDENTIFIER58);
            adaptor.addChild(root_0, IDENTIFIER58_tree);

             QualifiedIdentifier qid = new QualifiedIdentifier(((ServiceModule)s).name, IDENTIFIER58.getText()); 
              						 retval.m = new ServiceInterface(); 
              						 retval.m.partName = qid;
              						 s.parts.put(qid, retval.m); 
              			     
            LBRACE59=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_namedPart954); 
            LBRACE59_tree = (Object)adaptor.create(LBRACE59);
            adaptor.addChild(root_0, LBRACE59_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:179:9: ( basicModuleContent[$m] )*
            loop23:
            do {
                int alt23=2;
                int LA23_0 = input.LA(1);

                if ( (LA23_0==EXPOSE||(LA23_0>=REPLACE && LA23_0<=REQUIRE)||(LA23_0>=TYPES && LA23_0<=IDENTIFIER)||(LA23_0>=DIGIT && LA23_0<=37)||(LA23_0>=39 && LA23_0<=45)) ) {
                    alt23=1;
                }


                switch (alt23) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:179:11: basicModuleContent[$m]
            	    {
            	    pushFollow(FOLLOW_basicModuleContent_in_namedPart958);
            	    basicModuleContent60=basicModuleContent(retval.m);
            	    _fsp--;

            	    adaptor.addChild(root_0, basicModuleContent60.getTree());

            	    }
            	    break;

            	default :
            	    break loop23;
                }
            } while (true);

            RBRACE61=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_namedPart964); 
            RBRACE61_tree = (Object)adaptor.create(RBRACE61);
            adaptor.addChild(root_0, RBRACE61_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end namedPart

    public static class replace_return extends ParserRuleReturnScope {
        public ServiceInterface m;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start replace
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:182:0: replace[ ServiceInterface s ] returns [ ServiceInterface m ] : REPLACE id= qualifiedIdentifier LBRACE ( basicModuleContent[$m] )* RBRACE ;
    public final replace_return replace(ServiceInterface s) throws RecognitionException {
        replace_return retval = new replace_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token REPLACE62=null;
        Token LBRACE63=null;
        Token RBRACE65=null;
        qualifiedIdentifier_return id = null;

        basicModuleContent_return basicModuleContent64 = null;


        Object REPLACE62_tree=null;
        Object LBRACE63_tree=null;
        Object RBRACE65_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:182:62: ( REPLACE id= qualifiedIdentifier LBRACE ( basicModuleContent[$m] )* RBRACE )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:183:2: REPLACE id= qualifiedIdentifier LBRACE ( basicModuleContent[$m] )* RBRACE
            {
            root_0 = (Object)adaptor.nil();

            REPLACE62=(Token)input.LT(1);
            match(input,REPLACE,FOLLOW_REPLACE_in_replace979); 
            REPLACE62_tree = (Object)adaptor.create(REPLACE62);
            adaptor.addChild(root_0, REPLACE62_tree);

            pushFollow(FOLLOW_qualifiedIdentifier_in_replace983);
            id=qualifiedIdentifier();
            _fsp--;

            adaptor.addChild(root_0, id.getTree());
             retval.m = new ServiceInterface(); 
            	  retval.m.partName = id.QId;
            	  s.replacements.put(id.QId, retval.m); 
              
            LBRACE63=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_replace990); 
            LBRACE63_tree = (Object)adaptor.create(LBRACE63);
            adaptor.addChild(root_0, LBRACE63_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:188:9: ( basicModuleContent[$m] )*
            loop24:
            do {
                int alt24=2;
                int LA24_0 = input.LA(1);

                if ( (LA24_0==EXPOSE||(LA24_0>=REPLACE && LA24_0<=REQUIRE)||(LA24_0>=TYPES && LA24_0<=IDENTIFIER)||(LA24_0>=DIGIT && LA24_0<=37)||(LA24_0>=39 && LA24_0<=45)) ) {
                    alt24=1;
                }


                switch (alt24) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:188:11: basicModuleContent[$m]
            	    {
            	    pushFollow(FOLLOW_basicModuleContent_in_replace994);
            	    basicModuleContent64=basicModuleContent(retval.m);
            	    _fsp--;

            	    adaptor.addChild(root_0, basicModuleContent64.getTree());

            	    }
            	    break;

            	default :
            	    break loop24;
                }
            } while (true);

            RBRACE65=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_replace1000); 
            RBRACE65_tree = (Object)adaptor.create(RBRACE65);
            adaptor.addChild(root_0, RBRACE65_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end replace

    public static class advice_return extends ParserRuleReturnScope {
        public Advice adv;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start advice
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:191:0: advice returns [Advice adv] : ADVICE adviceHeader content ;
    public final advice_return advice() throws RecognitionException {
        advice_return retval = new advice_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token ADVICE66=null;
        adviceHeader_return adviceHeader67 = null;

        content_return content68 = null;


        Object ADVICE66_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:191:28: ( ADVICE adviceHeader content )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:192:2: ADVICE adviceHeader content
            {
            root_0 = (Object)adaptor.nil();

            ADVICE66=(Token)input.LT(1);
            match(input,ADVICE,FOLLOW_ADVICE_in_advice1013); 
            ADVICE66_tree = (Object)adaptor.create(ADVICE66);
            adaptor.addChild(root_0, ADVICE66_tree);

            pushFollow(FOLLOW_adviceHeader_in_advice1015);
            adviceHeader67=adviceHeader();
            _fsp--;

            adaptor.addChild(root_0, adviceHeader67.getTree());
            pushFollow(FOLLOW_content_in_advice1017);
            content68=content();
            _fsp--;

            adaptor.addChild(root_0, content68.getTree());
             retval.adv = new Advice(retval, parsedFile);
                retval.adv.header = input.toString(adviceHeader67.start,adviceHeader67.stop);
                retval.adv.content = content68.content;
              

            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end advice

    public static class adviceHeader_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start adviceHeader
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:199:0: adviceHeader : (~ ( LBRACE | RBRACE | ';' ) )+ ;
    public final adviceHeader_return adviceHeader() throws RecognitionException {
        adviceHeader_return retval = new adviceHeader_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set69=null;

        Object set69_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:199:14: ( (~ ( LBRACE | RBRACE | ';' ) )+ )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:200:3: (~ ( LBRACE | RBRACE | ';' ) )+
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:200:3: (~ ( LBRACE | RBRACE | ';' ) )+
            int cnt25=0;
            loop25:
            do {
                int alt25=2;
                int LA25_0 = input.LA(1);

                if ( ((LA25_0>=SERVICE && LA25_0<=IDENTIFIER)||(LA25_0>=DIGIT && LA25_0<=37)||(LA25_0>=39 && LA25_0<=45)) ) {
                    alt25=1;
                }


                switch (alt25) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:200:5: ~ ( LBRACE | RBRACE | ';' )
            	    {
            	    set69=(Token)input.LT(1);
            	    if ( (input.LA(1)>=SERVICE && input.LA(1)<=IDENTIFIER)||(input.LA(1)>=DIGIT && input.LA(1)<=37)||(input.LA(1)>=39 && input.LA(1)<=45) ) {
            	        input.consume();
            	        adaptor.addChild(root_0, adaptor.create(set69));
            	        errorRecovery=false;
            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_adviceHeader1034);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt25 >= 1 ) break loop25;
                        EarlyExitException eee =
                            new EarlyExitException(25, input);
                        throw eee;
                }
                cnt25++;
            } while (true);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end adviceHeader

    public static class declarations_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start declarations
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:203:0: declarations : ( preprocessor | declaration );
    public final declarations_return declarations() throws RecognitionException {
        declarations_return retval = new declarations_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        preprocessor_return preprocessor70 = null;

        declaration_return declaration71 = null;



        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:203:14: ( preprocessor | declaration )
            int alt26=2;
            int LA26_0 = input.LA(1);

            if ( (LA26_0==44) ) {
                alt26=1;
            }
            else if ( ((LA26_0>=TYPES && LA26_0<=RESTRICT)||LA26_0==IDENTIFIER||(LA26_0>=DIGIT && LA26_0<=37)||(LA26_0>=39 && LA26_0<=43)||LA26_0==45) ) {
                alt26=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("203:0: declarations : ( preprocessor | declaration );", 26, 0, input);

                throw nvae;
            }
            switch (alt26) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:204:2: preprocessor
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_preprocessor_in_declarations1058);
                    preprocessor70=preprocessor();
                    _fsp--;

                    adaptor.addChild(root_0, preprocessor70.getTree());

                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:204:17: declaration
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_declaration_in_declarations1062);
                    declaration71=declaration();
                    _fsp--;

                    adaptor.addChild(root_0, declaration71.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end declarations

    public static class preprocessor_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start preprocessor
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:207:0: preprocessor : '#' ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )* (~ ( PPCONTINUE | NEWLINE ) )* NEWLINE ;
    public final preprocessor_return preprocessor() throws RecognitionException {
        preprocessor_return retval = new preprocessor_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token char_literal72=null;
        Token set73=null;
        Token PPCONTINUE74=null;
        Token set75=null;
        Token NEWLINE76=null;

        Object char_literal72_tree=null;
        Object set73_tree=null;
        Object PPCONTINUE74_tree=null;
        Object set75_tree=null;
        Object NEWLINE76_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:207:14: ( '#' ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )* (~ ( PPCONTINUE | NEWLINE ) )* NEWLINE )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:208:3: '#' ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )* (~ ( PPCONTINUE | NEWLINE ) )* NEWLINE
            {
            root_0 = (Object)adaptor.nil();

            char_literal72=(Token)input.LT(1);
            match(input,44,FOLLOW_44_in_preprocessor1073); 
            char_literal72_tree = (Object)adaptor.create(char_literal72);
            adaptor.addChild(root_0, char_literal72_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:209:3: ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )*
            loop28:
            do {
                int alt28=2;
                alt28 = dfa28.predict(input);
                switch (alt28) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:209:4: (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE
            	    {
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:209:4: (~ ( PPCONTINUE | NEWLINE ) )*
            	    loop27:
            	    do {
            	        int alt27=2;
            	        int LA27_0 = input.LA(1);

            	        if ( ((LA27_0>=SERVICE && LA27_0<=RESTRICT)||(LA27_0>=IDENTIFIER && LA27_0<=RPARENTHESIS)||(LA27_0>=LETTER && LA27_0<=45)) ) {
            	            alt27=1;
            	        }


            	        switch (alt27) {
            	    	case 1 :
            	    	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:209:5: ~ ( PPCONTINUE | NEWLINE )
            	    	    {
            	    	    set73=(Token)input.LT(1);
            	    	    if ( (input.LA(1)>=SERVICE && input.LA(1)<=RESTRICT)||(input.LA(1)>=IDENTIFIER && input.LA(1)<=RPARENTHESIS)||(input.LA(1)>=LETTER && input.LA(1)<=45) ) {
            	    	        input.consume();
            	    	        adaptor.addChild(root_0, adaptor.create(set73));
            	    	        errorRecovery=false;
            	    	    }
            	    	    else {
            	    	        MismatchedSetException mse =
            	    	            new MismatchedSetException(null,input);
            	    	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_preprocessor1079);    throw mse;
            	    	    }


            	    	    }
            	    	    break;

            	    	default :
            	    	    break loop27;
            	        }
            	    } while (true);

            	    PPCONTINUE74=(Token)input.LT(1);
            	    match(input,PPCONTINUE,FOLLOW_PPCONTINUE_in_preprocessor1092); 
            	    PPCONTINUE74_tree = (Object)adaptor.create(PPCONTINUE74);
            	    adaptor.addChild(root_0, PPCONTINUE74_tree);


            	    }
            	    break;

            	default :
            	    break loop28;
                }
            } while (true);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:210:3: (~ ( PPCONTINUE | NEWLINE ) )*
            loop29:
            do {
                int alt29=2;
                int LA29_0 = input.LA(1);

                if ( ((LA29_0>=SERVICE && LA29_0<=RESTRICT)||(LA29_0>=IDENTIFIER && LA29_0<=RPARENTHESIS)||(LA29_0>=LETTER && LA29_0<=45)) ) {
                    alt29=1;
                }


                switch (alt29) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:210:4: ~ ( PPCONTINUE | NEWLINE )
            	    {
            	    set75=(Token)input.LT(1);
            	    if ( (input.LA(1)>=SERVICE && input.LA(1)<=RESTRICT)||(input.LA(1)>=IDENTIFIER && input.LA(1)<=RPARENTHESIS)||(input.LA(1)>=LETTER && input.LA(1)<=45) ) {
            	        input.consume();
            	        adaptor.addChild(root_0, adaptor.create(set75));
            	        errorRecovery=false;
            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_preprocessor1099);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop29;
                }
            } while (true);

            NEWLINE76=(Token)input.LT(1);
            match(input,NEWLINE,FOLLOW_NEWLINE_in_preprocessor1114); 
            NEWLINE76_tree = (Object)adaptor.create(NEWLINE76);
            adaptor.addChild(root_0, NEWLINE76_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end preprocessor

    public static class declaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start declaration
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:214:0: declaration : (~ ( '#' | NEWLINE | LBRACE | RBRACE | ';' | SERVICE | STARTUP | SHUTDOWN | EXPOSE | ADVICE | POINTCUT | REQUIRE | BOOT | FOR | REPLACE ) ) (~ ( LBRACE | RBRACE | ';' ) )+ ( content ( ';' )? | ';' ) ;
    public final declaration_return declaration() throws RecognitionException {
        declaration_return retval = new declaration_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set77=null;
        Token set78=null;
        Token char_literal80=null;
        Token char_literal81=null;
        content_return content79 = null;


        Object set77_tree=null;
        Object set78_tree=null;
        Object char_literal80_tree=null;
        Object char_literal81_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:214:13: ( (~ ( '#' | NEWLINE | LBRACE | RBRACE | ';' | SERVICE | STARTUP | SHUTDOWN | EXPOSE | ADVICE | POINTCUT | REQUIRE | BOOT | FOR | REPLACE ) ) (~ ( LBRACE | RBRACE | ';' ) )+ ( content ( ';' )? | ';' ) )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:215:2: (~ ( '#' | NEWLINE | LBRACE | RBRACE | ';' | SERVICE | STARTUP | SHUTDOWN | EXPOSE | ADVICE | POINTCUT | REQUIRE | BOOT | FOR | REPLACE ) ) (~ ( LBRACE | RBRACE | ';' ) )+ ( content ( ';' )? | ';' )
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:215:2: (~ ( '#' | NEWLINE | LBRACE | RBRACE | ';' | SERVICE | STARTUP | SHUTDOWN | EXPOSE | ADVICE | POINTCUT | REQUIRE | BOOT | FOR | REPLACE ) )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:215:3: ~ ( '#' | NEWLINE | LBRACE | RBRACE | ';' | SERVICE | STARTUP | SHUTDOWN | EXPOSE | ADVICE | POINTCUT | REQUIRE | BOOT | FOR | REPLACE )
            {
            set77=(Token)input.LT(1);
            if ( (input.LA(1)>=TYPES && input.LA(1)<=RESTRICT)||input.LA(1)==IDENTIFIER||(input.LA(1)>=DIGIT && input.LA(1)<=37)||(input.LA(1)>=39 && input.LA(1)<=43)||input.LA(1)==45 ) {
                input.consume();
                adaptor.addChild(root_0, adaptor.create(set77));
                errorRecovery=false;
            }
            else {
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recoverFromMismatchedSet(input,mse,FOLLOW_set_in_declaration1125);    throw mse;
            }


            }

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:218:2: (~ ( LBRACE | RBRACE | ';' ) )+
            int cnt30=0;
            loop30:
            do {
                int alt30=2;
                int LA30_0 = input.LA(1);

                if ( ((LA30_0>=SERVICE && LA30_0<=IDENTIFIER)||(LA30_0>=DIGIT && LA30_0<=37)||(LA30_0>=39 && LA30_0<=45)) ) {
                    alt30=1;
                }


                switch (alt30) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:218:4: ~ ( LBRACE | RBRACE | ';' )
            	    {
            	    set78=(Token)input.LT(1);
            	    if ( (input.LA(1)>=SERVICE && input.LA(1)<=IDENTIFIER)||(input.LA(1)>=DIGIT && input.LA(1)<=37)||(input.LA(1)>=39 && input.LA(1)<=45) ) {
            	        input.consume();
            	        adaptor.addChild(root_0, adaptor.create(set78));
            	        errorRecovery=false;
            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_declaration1197);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt30 >= 1 ) break loop30;
                        EarlyExitException eee =
                            new EarlyExitException(30, input);
                        throw eee;
                }
                cnt30++;
            } while (true);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:219:2: ( content ( ';' )? | ';' )
            int alt32=2;
            int LA32_0 = input.LA(1);

            if ( (LA32_0==LBRACE) ) {
                alt32=1;
            }
            else if ( (LA32_0==38) ) {
                alt32=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("219:2: ( content ( ';' )? | ';' )", 32, 0, input);

                throw nvae;
            }
            switch (alt32) {
                case 1 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:219:3: content ( ';' )?
                    {
                    pushFollow(FOLLOW_content_in_declaration1215);
                    content79=content();
                    _fsp--;

                    adaptor.addChild(root_0, content79.getTree());
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:219:11: ( ';' )?
                    int alt31=2;
                    int LA31_0 = input.LA(1);

                    if ( (LA31_0==38) ) {
                        alt31=1;
                    }
                    switch (alt31) {
                        case 1 :
                            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:219:11: ';'
                            {
                            char_literal80=(Token)input.LT(1);
                            match(input,38,FOLLOW_38_in_declaration1217); 
                            char_literal80_tree = (Object)adaptor.create(char_literal80);
                            adaptor.addChild(root_0, char_literal80_tree);


                            }
                            break;

                    }


                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:219:18: ';'
                    {
                    char_literal81=(Token)input.LT(1);
                    match(input,38,FOLLOW_38_in_declaration1222); 
                    char_literal81_tree = (Object)adaptor.create(char_literal81);
                    adaptor.addChild(root_0, char_literal81_tree);


                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end declaration

    public static class contentcontent_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start contentcontent
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:222:0: contentcontent : ( content | (~ ( LBRACE | RBRACE ) )+ )* ;
    public final contentcontent_return contentcontent() throws RecognitionException {
        contentcontent_return retval = new contentcontent_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set83=null;
        content_return content82 = null;


        Object set83_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:222:15: ( ( content | (~ ( LBRACE | RBRACE ) )+ )* )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:223:2: ( content | (~ ( LBRACE | RBRACE ) )+ )*
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:223:2: ( content | (~ ( LBRACE | RBRACE ) )+ )*
            loop34:
            do {
                int alt34=3;
                int LA34_0 = input.LA(1);

                if ( (LA34_0==LBRACE) ) {
                    alt34=1;
                }
                else if ( ((LA34_0>=SERVICE && LA34_0<=IDENTIFIER)||(LA34_0>=DIGIT && LA34_0<=45)) ) {
                    alt34=2;
                }


                switch (alt34) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:223:3: content
            	    {
            	    pushFollow(FOLLOW_content_in_contentcontent1234);
            	    content82=content();
            	    _fsp--;

            	    adaptor.addChild(root_0, content82.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:223:13: (~ ( LBRACE | RBRACE ) )+
            	    {
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:223:13: (~ ( LBRACE | RBRACE ) )+
            	    int cnt33=0;
            	    loop33:
            	    do {
            	        int alt33=2;
            	        int LA33_0 = input.LA(1);

            	        if ( ((LA33_0>=SERVICE && LA33_0<=IDENTIFIER)||(LA33_0>=DIGIT && LA33_0<=45)) ) {
            	            alt33=1;
            	        }


            	        switch (alt33) {
            	    	case 1 :
            	    	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:223:14: ~ ( LBRACE | RBRACE )
            	    	    {
            	    	    set83=(Token)input.LT(1);
            	    	    if ( (input.LA(1)>=SERVICE && input.LA(1)<=IDENTIFIER)||(input.LA(1)>=DIGIT && input.LA(1)<=45) ) {
            	    	        input.consume();
            	    	        adaptor.addChild(root_0, adaptor.create(set83));
            	    	        errorRecovery=false;
            	    	    }
            	    	    else {
            	    	        MismatchedSetException mse =
            	    	            new MismatchedSetException(null,input);
            	    	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_contentcontent1239);    throw mse;
            	    	    }


            	    	    }
            	    	    break;

            	    	default :
            	    	    if ( cnt33 >= 1 ) break loop33;
            	                EarlyExitException eee =
            	                    new EarlyExitException(33, input);
            	                throw eee;
            	        }
            	        cnt33++;
            	    } while (true);


            	    }
            	    break;

            	default :
            	    break loop34;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end contentcontent

    public static class content_return extends ParserRuleReturnScope {
        public String content;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start content
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:225:0: content returns [String content] : LBRACE contentcontent RBRACE ;
    public final content_return content() throws RecognitionException {
        content_return retval = new content_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token LBRACE84=null;
        Token RBRACE86=null;
        contentcontent_return contentcontent85 = null;


        Object LBRACE84_tree=null;
        Object RBRACE86_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:225:33: ( LBRACE contentcontent RBRACE )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:226:3: LBRACE contentcontent RBRACE
            {
            root_0 = (Object)adaptor.nil();

            LBRACE84=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_content1264); 
            LBRACE84_tree = (Object)adaptor.create(LBRACE84);
            adaptor.addChild(root_0, LBRACE84_tree);

            pushFollow(FOLLOW_contentcontent_in_content1267);
            contentcontent85=contentcontent();
            _fsp--;

            adaptor.addChild(root_0, contentcontent85.getTree());
             retval.content = input.toString(contentcontent85.start,contentcontent85.stop); 
            RBRACE86=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_content1273); 
            RBRACE86_tree = (Object)adaptor.create(RBRACE86);
            adaptor.addChild(root_0, RBRACE86_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end content

    public static class types_return extends ParserRuleReturnScope {
        public String content;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start types
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:232:0: types returns [String content] : TYPES c= content ;
    public final types_return types() throws RecognitionException {
        types_return retval = new types_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token TYPES87=null;
        content_return c = null;


        Object TYPES87_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:232:31: ( TYPES c= content )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:233:2: TYPES c= content
            {
            root_0 = (Object)adaptor.nil();

            TYPES87=(Token)input.LT(1);
            match(input,TYPES,FOLLOW_TYPES_in_types1286); 
            TYPES87_tree = (Object)adaptor.create(TYPES87);
            adaptor.addChild(root_0, TYPES87_tree);

            pushFollow(FOLLOW_content_in_types1290);
            c=content();
            _fsp--;

            adaptor.addChild(root_0, c.getTree());
             retval.content = c.content; 

            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end types

    public static class startup_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start startup
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:235:0: startup : STARTUP ( LBRACE ( expose | advice | boot )* RBRACE ) ;
    public final startup_return startup() throws RecognitionException {
        startup_return retval = new startup_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token STARTUP88=null;
        Token LBRACE89=null;
        Token RBRACE93=null;
        expose_return expose90 = null;

        advice_return advice91 = null;

        boot_return boot92 = null;


        Object STARTUP88_tree=null;
        Object LBRACE89_tree=null;
        Object RBRACE93_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:236:3: ( STARTUP ( LBRACE ( expose | advice | boot )* RBRACE ) )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:236:5: STARTUP ( LBRACE ( expose | advice | boot )* RBRACE )
            {
            root_0 = (Object)adaptor.nil();

            STARTUP88=(Token)input.LT(1);
            match(input,STARTUP,FOLLOW_STARTUP_in_startup1302); 
            STARTUP88_tree = (Object)adaptor.create(STARTUP88);
            adaptor.addChild(root_0, STARTUP88_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:237:2: ( LBRACE ( expose | advice | boot )* RBRACE )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:237:3: LBRACE ( expose | advice | boot )* RBRACE
            {
            LBRACE89=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_startup1306); 
            LBRACE89_tree = (Object)adaptor.create(LBRACE89);
            adaptor.addChild(root_0, LBRACE89_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:237:10: ( expose | advice | boot )*
            loop35:
            do {
                int alt35=4;
                switch ( input.LA(1) ) {
                case EXPOSE:
                    {
                    alt35=1;
                    }
                    break;
                case ADVICE:
                    {
                    alt35=2;
                    }
                    break;
                case BOOT:
                    {
                    alt35=3;
                    }
                    break;

                }

                switch (alt35) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:237:11: expose
            	    {
            	    pushFollow(FOLLOW_expose_in_startup1309);
            	    expose90=expose();
            	    _fsp--;

            	    adaptor.addChild(root_0, expose90.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:237:20: advice
            	    {
            	    pushFollow(FOLLOW_advice_in_startup1313);
            	    advice91=advice();
            	    _fsp--;

            	    adaptor.addChild(root_0, advice91.getTree());

            	    }
            	    break;
            	case 3 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:237:29: boot
            	    {
            	    pushFollow(FOLLOW_boot_in_startup1317);
            	    boot92=boot();
            	    _fsp--;

            	    adaptor.addChild(root_0, boot92.getTree());

            	    }
            	    break;

            	default :
            	    break loop35;
                }
            } while (true);

            RBRACE93=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_startup1322); 
            RBRACE93_tree = (Object)adaptor.create(RBRACE93);
            adaptor.addChild(root_0, RBRACE93_tree);


            }


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end startup

    public static class shutdown_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start shutdown
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:239:0: shutdown : SHUTDOWN ( LBRACE ( expose | advice )* RBRACE ) ;
    public final shutdown_return shutdown() throws RecognitionException {
        shutdown_return retval = new shutdown_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token SHUTDOWN94=null;
        Token LBRACE95=null;
        Token RBRACE98=null;
        expose_return expose96 = null;

        advice_return advice97 = null;


        Object SHUTDOWN94_tree=null;
        Object LBRACE95_tree=null;
        Object RBRACE98_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:240:3: ( SHUTDOWN ( LBRACE ( expose | advice )* RBRACE ) )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:240:5: SHUTDOWN ( LBRACE ( expose | advice )* RBRACE )
            {
            root_0 = (Object)adaptor.nil();

            SHUTDOWN94=(Token)input.LT(1);
            match(input,SHUTDOWN,FOLLOW_SHUTDOWN_in_shutdown1333); 
            SHUTDOWN94_tree = (Object)adaptor.create(SHUTDOWN94);
            adaptor.addChild(root_0, SHUTDOWN94_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:241:2: ( LBRACE ( expose | advice )* RBRACE )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:241:3: LBRACE ( expose | advice )* RBRACE
            {
            LBRACE95=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_shutdown1337); 
            LBRACE95_tree = (Object)adaptor.create(LBRACE95);
            adaptor.addChild(root_0, LBRACE95_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:241:10: ( expose | advice )*
            loop36:
            do {
                int alt36=3;
                int LA36_0 = input.LA(1);

                if ( (LA36_0==EXPOSE) ) {
                    alt36=1;
                }
                else if ( (LA36_0==ADVICE) ) {
                    alt36=2;
                }


                switch (alt36) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:241:11: expose
            	    {
            	    pushFollow(FOLLOW_expose_in_shutdown1340);
            	    expose96=expose();
            	    _fsp--;

            	    adaptor.addChild(root_0, expose96.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:241:20: advice
            	    {
            	    pushFollow(FOLLOW_advice_in_shutdown1344);
            	    advice97=advice();
            	    _fsp--;

            	    adaptor.addChild(root_0, advice97.getTree());

            	    }
            	    break;

            	default :
            	    break loop36;
                }
            } while (true);

            RBRACE98=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_shutdown1348); 
            RBRACE98_tree = (Object)adaptor.create(RBRACE98);
            adaptor.addChild(root_0, RBRACE98_tree);


            }


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end shutdown

    public static class boot_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start boot
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:243:0: boot : BOOT (~ ( LBRACE | RBRACE | ';' ) )+ ';' ;
    public final boot_return boot() throws RecognitionException {
        boot_return retval = new boot_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token BOOT99=null;
        Token set100=null;
        Token char_literal101=null;

        Object BOOT99_tree=null;
        Object set100_tree=null;
        Object char_literal101_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:243:6: ( BOOT (~ ( LBRACE | RBRACE | ';' ) )+ ';' )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:244:2: BOOT (~ ( LBRACE | RBRACE | ';' ) )+ ';'
            {
            root_0 = (Object)adaptor.nil();

            BOOT99=(Token)input.LT(1);
            match(input,BOOT,FOLLOW_BOOT_in_boot1360); 
            BOOT99_tree = (Object)adaptor.create(BOOT99);
            adaptor.addChild(root_0, BOOT99_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:245:2: (~ ( LBRACE | RBRACE | ';' ) )+
            int cnt37=0;
            loop37:
            do {
                int alt37=2;
                int LA37_0 = input.LA(1);

                if ( ((LA37_0>=SERVICE && LA37_0<=IDENTIFIER)||(LA37_0>=DIGIT && LA37_0<=37)||(LA37_0>=39 && LA37_0<=45)) ) {
                    alt37=1;
                }


                switch (alt37) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:245:4: ~ ( LBRACE | RBRACE | ';' )
            	    {
            	    set100=(Token)input.LT(1);
            	    if ( (input.LA(1)>=SERVICE && input.LA(1)<=IDENTIFIER)||(input.LA(1)>=DIGIT && input.LA(1)<=37)||(input.LA(1)>=39 && input.LA(1)<=45) ) {
            	        input.consume();
            	        adaptor.addChild(root_0, adaptor.create(set100));
            	        errorRecovery=false;
            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_boot1365);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt37 >= 1 ) break loop37;
                        EarlyExitException eee =
                            new EarlyExitException(37, input);
                        throw eee;
                }
                cnt37++;
            } while (true);

            char_literal101=(Token)input.LT(1);
            match(input,38,FOLLOW_38_in_boot1382); 
            char_literal101_tree = (Object)adaptor.create(char_literal101);
            adaptor.addChild(root_0, char_literal101_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end boot

    public static class expose_return extends ParserRuleReturnScope {
        public List<String> pointcuts;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start expose
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:249:0: expose returns [List<String> pointcuts] : EXPOSE ( NEWLINE )* LBRACE ( NEWLINE )* ( pointcut )* RBRACE ;
    public final expose_return expose() throws RecognitionException {
        expose_return retval = new expose_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token EXPOSE102=null;
        Token NEWLINE103=null;
        Token LBRACE104=null;
        Token NEWLINE105=null;
        Token RBRACE107=null;
        pointcut_return pointcut106 = null;


        Object EXPOSE102_tree=null;
        Object NEWLINE103_tree=null;
        Object LBRACE104_tree=null;
        Object NEWLINE105_tree=null;
        Object RBRACE107_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:249:41: ( EXPOSE ( NEWLINE )* LBRACE ( NEWLINE )* ( pointcut )* RBRACE )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:250:1: EXPOSE ( NEWLINE )* LBRACE ( NEWLINE )* ( pointcut )* RBRACE
            {
            root_0 = (Object)adaptor.nil();

             retval.pointcuts = new ArrayList<String>(); 
            EXPOSE102=(Token)input.LT(1);
            match(input,EXPOSE,FOLLOW_EXPOSE_in_expose1400); 
            EXPOSE102_tree = (Object)adaptor.create(EXPOSE102);
            adaptor.addChild(root_0, EXPOSE102_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:251:10: ( NEWLINE )*
            loop38:
            do {
                int alt38=2;
                int LA38_0 = input.LA(1);

                if ( (LA38_0==NEWLINE) ) {
                    alt38=1;
                }


                switch (alt38) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:251:10: NEWLINE
            	    {
            	    NEWLINE103=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_expose1402); 
            	    NEWLINE103_tree = (Object)adaptor.create(NEWLINE103);
            	    adaptor.addChild(root_0, NEWLINE103_tree);


            	    }
            	    break;

            	default :
            	    break loop38;
                }
            } while (true);

            LBRACE104=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_expose1405); 
            LBRACE104_tree = (Object)adaptor.create(LBRACE104);
            adaptor.addChild(root_0, LBRACE104_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:251:26: ( NEWLINE )*
            loop39:
            do {
                int alt39=2;
                int LA39_0 = input.LA(1);

                if ( (LA39_0==NEWLINE) ) {
                    alt39=1;
                }


                switch (alt39) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:251:26: NEWLINE
            	    {
            	    NEWLINE105=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_expose1407); 
            	    NEWLINE105_tree = (Object)adaptor.create(NEWLINE105);
            	    adaptor.addChild(root_0, NEWLINE105_tree);


            	    }
            	    break;

            	default :
            	    break loop39;
                }
            } while (true);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:252:2: ( pointcut )*
            loop40:
            do {
                int alt40=2;
                int LA40_0 = input.LA(1);

                if ( (LA40_0==POINTCUT) ) {
                    alt40=1;
                }


                switch (alt40) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:252:4: pointcut
            	    {
            	    pushFollow(FOLLOW_pointcut_in_expose1414);
            	    pointcut106=pointcut();
            	    _fsp--;

            	    adaptor.addChild(root_0, pointcut106.getTree());
            	    retval.pointcuts.add(input.toString(pointcut106.start,pointcut106.stop)); 

            	    }
            	    break;

            	default :
            	    break loop40;
                }
            } while (true);

            RBRACE107=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_expose1423); 
            RBRACE107_tree = (Object)adaptor.create(RBRACE107);
            adaptor.addChild(root_0, RBRACE107_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end expose

    public static class require_return extends ParserRuleReturnScope {
        public ServiceModule service;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start require
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:257:0: require returns [ ServiceModule service ] : REQUIRE IDENTIFIER ';' ;
    public final require_return require() throws RecognitionException {
        require_return retval = new require_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token REQUIRE108=null;
        Token IDENTIFIER109=null;
        Token char_literal110=null;

        Object REQUIRE108_tree=null;
        Object IDENTIFIER109_tree=null;
        Object char_literal110_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:257:43: ( REQUIRE IDENTIFIER ';' )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:258:2: REQUIRE IDENTIFIER ';'
            {
            root_0 = (Object)adaptor.nil();

            REQUIRE108=(Token)input.LT(1);
            match(input,REQUIRE,FOLLOW_REQUIRE_in_require1438); 
            REQUIRE108_tree = (Object)adaptor.create(REQUIRE108);
            adaptor.addChild(root_0, REQUIRE108_tree);

            IDENTIFIER109=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_require1440); 
            IDENTIFIER109_tree = (Object)adaptor.create(IDENTIFIER109);
            adaptor.addChild(root_0, IDENTIFIER109_tree);

             retval.service = reg.get(IDENTIFIER109.getText()); 
            char_literal110=(Token)input.LT(1);
            match(input,38,FOLLOW_38_in_require1446); 
            char_literal110_tree = (Object)adaptor.create(char_literal110);
            adaptor.addChild(root_0, char_literal110_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end require

    public static class pointcut_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start pointcut
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:261:0: pointcut : POINTCUT (~ ( ';' ) )* ';' ( NEWLINE )* ;
    public final pointcut_return pointcut() throws RecognitionException {
        pointcut_return retval = new pointcut_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token POINTCUT111=null;
        Token set112=null;
        Token char_literal113=null;
        Token NEWLINE114=null;

        Object POINTCUT111_tree=null;
        Object set112_tree=null;
        Object char_literal113_tree=null;
        Object NEWLINE114_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:261:10: ( POINTCUT (~ ( ';' ) )* ';' ( NEWLINE )* )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:262:2: POINTCUT (~ ( ';' ) )* ';' ( NEWLINE )*
            {
            root_0 = (Object)adaptor.nil();

            POINTCUT111=(Token)input.LT(1);
            match(input,POINTCUT,FOLLOW_POINTCUT_in_pointcut1456); 
            POINTCUT111_tree = (Object)adaptor.create(POINTCUT111);
            adaptor.addChild(root_0, POINTCUT111_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:263:2: (~ ( ';' ) )*
            loop41:
            do {
                int alt41=2;
                int LA41_0 = input.LA(1);

                if ( ((LA41_0>=SERVICE && LA41_0<=37)||(LA41_0>=39 && LA41_0<=45)) ) {
                    alt41=1;
                }


                switch (alt41) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:263:3: ~ ( ';' )
            	    {
            	    set112=(Token)input.LT(1);
            	    if ( (input.LA(1)>=SERVICE && input.LA(1)<=37)||(input.LA(1)>=39 && input.LA(1)<=45) ) {
            	        input.consume();
            	        adaptor.addChild(root_0, adaptor.create(set112));
            	        errorRecovery=false;
            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_pointcut1461);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop41;
                }
            } while (true);

            char_literal113=(Token)input.LT(1);
            match(input,38,FOLLOW_38_in_pointcut1469); 
            char_literal113_tree = (Object)adaptor.create(char_literal113);
            adaptor.addChild(root_0, char_literal113_tree);

            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:264:6: ( NEWLINE )*
            loop42:
            do {
                int alt42=2;
                int LA42_0 = input.LA(1);

                if ( (LA42_0==NEWLINE) ) {
                    alt42=1;
                }


                switch (alt42) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:264:6: NEWLINE
            	    {
            	    NEWLINE114=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_pointcut1471); 
            	    NEWLINE114_tree = (Object)adaptor.create(NEWLINE114);
            	    adaptor.addChild(root_0, NEWLINE114_tree);


            	    }
            	    break;

            	default :
            	    break loop42;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end pointcut

    public static class qualifiedIdentifier_return extends ParserRuleReturnScope {
        public QualifiedIdentifier QId;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start qualifiedIdentifier
    // /VMADL.j/src/de/sm/vmadl/Vmadl.g:273:0: qualifiedIdentifier returns [ QualifiedIdentifier QId ] : module= IDENTIFIER '.' name= IDENTIFIER ;
    public final qualifiedIdentifier_return qualifiedIdentifier() throws RecognitionException {
        qualifiedIdentifier_return retval = new qualifiedIdentifier_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token module=null;
        Token name=null;
        Token char_literal115=null;

        Object module_tree=null;
        Object name_tree=null;
        Object char_literal115_tree=null;

        try {
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:273:57: (module= IDENTIFIER '.' name= IDENTIFIER )
            // /VMADL.j/src/de/sm/vmadl/Vmadl.g:274:2: module= IDENTIFIER '.' name= IDENTIFIER
            {
            root_0 = (Object)adaptor.nil();

            module=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_qualifiedIdentifier1493); 
            module_tree = (Object)adaptor.create(module);
            adaptor.addChild(root_0, module_tree);

            char_literal115=(Token)input.LT(1);
            match(input,45,FOLLOW_45_in_qualifiedIdentifier1495); 
            char_literal115_tree = (Object)adaptor.create(char_literal115);
            adaptor.addChild(root_0, char_literal115_tree);

            name=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_qualifiedIdentifier1499); 
            name_tree = (Object)adaptor.create(name);
            adaptor.addChild(root_0, name_tree);

             retval.QId = new QualifiedIdentifier(module.getText(), name.getText()); 

            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end qualifiedIdentifier


    protected DFA6 dfa6 = new DFA6(this);
    protected DFA28 dfa28 = new DFA28(this);
    static final String DFA6_eotS =
        "\21\uffff";
    static final String DFA6_eofS =
        "\21\uffff";
    static final String DFA6_minS =
        "\1\5\5\uffff\2\22\1\26\1\22\1\uffff\2\22\1\26\1\32\2\uffff";
    static final String DFA6_maxS =
        "\1\54\5\uffff\3\26\1\47\1\uffff\1\47\2\26\1\46\2\uffff";
    static final String DFA6_acceptS =
        "\1\uffff\1\1\1\2\1\3\1\4\1\5\4\uffff\1\10\4\uffff\1\7\1\6";
    static final String DFA6_specialS =
        "\21\uffff}>";
    static final String[] DFA6_transitionS = {
            "\1\3\1\4\1\uffff\1\2\2\uffff\1\1\4\uffff\1\6\1\7\1\10\2\uffff"+
            "\1\12\1\11\25\uffff\1\5",
            "",
            "",
            "",
            "",
            "",
            "\1\10\3\uffff\1\11",
            "\1\10\3\uffff\1\11",
            "\1\11",
            "\1\15\1\uffff\1\14\1\uffff\1\16\20\uffff\1\13",
            "",
            "\1\15\1\uffff\1\14\1\uffff\1\16\20\uffff\1\13",
            "\1\15\3\uffff\1\16",
            "\1\16",
            "\1\17\10\uffff\1\20\1\uffff\2\20",
            "",
            ""
    };

    static final short[] DFA6_eot = DFA.unpackEncodedString(DFA6_eotS);
    static final short[] DFA6_eof = DFA.unpackEncodedString(DFA6_eofS);
    static final char[] DFA6_min = DFA.unpackEncodedStringToUnsignedChars(DFA6_minS);
    static final char[] DFA6_max = DFA.unpackEncodedStringToUnsignedChars(DFA6_maxS);
    static final short[] DFA6_accept = DFA.unpackEncodedString(DFA6_acceptS);
    static final short[] DFA6_special = DFA.unpackEncodedString(DFA6_specialS);
    static final short[][] DFA6_transition;

    static {
        int numStates = DFA6_transitionS.length;
        DFA6_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA6_transition[i] = DFA.unpackEncodedString(DFA6_transitionS[i]);
        }
    }

    class DFA6 extends DFA {

        public DFA6(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 6;
            this.eot = DFA6_eot;
            this.eof = DFA6_eof;
            this.min = DFA6_min;
            this.max = DFA6_max;
            this.accept = DFA6_accept;
            this.special = DFA6_special;
            this.transition = DFA6_transition;
        }
        public String getDescription() {
            return "119:0: combinationContent[Combination c] : ( require | advice | startup | shutdown | preprocessor | variable | function | NEWLINE );";
        }
    }
    static final String DFA28_eotS =
        "\4\uffff";
    static final String DFA28_eofS =
        "\4\uffff";
    static final String DFA28_minS =
        "\2\4\2\uffff";
    static final String DFA28_maxS =
        "\2\55\2\uffff";
    static final String DFA28_acceptS =
        "\2\uffff\1\2\1\1";
    static final String DFA28_specialS =
        "\4\uffff}>";
    static final String[] DFA28_transitionS = {
            "\21\1\1\2\6\1\1\3\21\1",
            "\21\1\1\2\6\1\1\3\21\1",
            "",
            ""
    };

    static final short[] DFA28_eot = DFA.unpackEncodedString(DFA28_eotS);
    static final short[] DFA28_eof = DFA.unpackEncodedString(DFA28_eofS);
    static final char[] DFA28_min = DFA.unpackEncodedStringToUnsignedChars(DFA28_minS);
    static final char[] DFA28_max = DFA.unpackEncodedStringToUnsignedChars(DFA28_maxS);
    static final short[] DFA28_accept = DFA.unpackEncodedString(DFA28_acceptS);
    static final short[] DFA28_special = DFA.unpackEncodedString(DFA28_specialS);
    static final short[][] DFA28_transition;

    static {
        int numStates = DFA28_transitionS.length;
        DFA28_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA28_transition[i] = DFA.unpackEncodedString(DFA28_transitionS[i]);
        }
    }

    class DFA28 extends DFA {

        public DFA28(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 28;
            this.eot = DFA28_eot;
            this.eof = DFA28_eof;
            this.min = DFA28_min;
            this.max = DFA28_max;
            this.accept = DFA28_accept;
            this.special = DFA28_special;
            this.transition = DFA28_transition;
        }
        public String getDescription() {
            return "()* loopback of 209:3: ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )*";
        }
    }
 

    public static final BitSet FOLLOW_NEWLINE_in_architecture303 = new BitSet(new long[]{0x0000000000208010L});
    public static final BitSet FOLLOW_service_in_architecture313 = new BitSet(new long[]{0x0000000000208010L});
    public static final BitSet FOLLOW_combination_in_architecture324 = new BitSet(new long[]{0x0000000000208010L});
    public static final BitSet FOLLOW_EOF_in_architecture336 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NEWLINE_in_interaction349 = new BitSet(new long[]{0x0000000000208000L});
    public static final BitSet FOLLOW_combination_in_interaction354 = new BitSet(new long[]{0x0000000000208000L});
    public static final BitSet FOLLOW_EOF_in_interaction359 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COMBINE_in_combination374 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_combination378 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_34_in_combination380 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_combination384 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_LBRACE_in_combination393 = new BitSet(new long[]{0x0000100001670960L});
    public static final BitSet FOLLOW_combinationContent_in_combination397 = new BitSet(new long[]{0x0000100001670960L});
    public static final BitSet FOLLOW_RBRACE_in_combination403 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SERVICE_in_service423 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_service425 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_LBRACE_in_service431 = new BitSet(new long[]{0x00003FBFFF7FCC80L});
    public static final BitSet FOLLOW_basicModuleContent_in_service435 = new BitSet(new long[]{0x00003FBFFF7FCC80L});
    public static final BitSet FOLLOW_RBRACE_in_service441 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_require_in_basicModuleContent459 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expose_in_basicModuleContent472 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_declarations_in_basicModuleContent485 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_types_in_basicModuleContent500 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_namedPart_in_basicModuleContent513 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_replace_in_basicModuleContent522 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NEWLINE_in_basicModuleContent531 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_require_in_combinationContent543 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_advice_in_combinationContent561 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_startup_in_combinationContent578 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_shutdown_in_combinationContent584 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_preprocessor_in_combinationContent590 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variable_in_combinationContent601 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_function_in_combinationContent616 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NEWLINE_in_combinationContent631 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENTIFIER_in_literalValue641 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DIGIT_in_literalValue645 = new BitSet(new long[]{0x0000000002000002L});
    public static final BitSet FOLLOW_hexValue_in_literalValue650 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STATIC_in_variable669 = new BitSet(new long[]{0x0000000000440000L});
    public static final BitSet FOLLOW_EXTERN_in_variable674 = new BitSet(new long[]{0x0000000000440000L});
    public static final BitSet FOLLOW_typeRef_in_variable682 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_variable693 = new BitSet(new long[]{0x0000006800000000L});
    public static final BitSet FOLLOW_35_in_variable701 = new BitSet(new long[]{0x0000000002480000L});
    public static final BitSet FOLLOW_literalValue_in_variable705 = new BitSet(new long[]{0x0000001000000000L});
    public static final BitSet FOLLOW_36_in_variable707 = new BitSet(new long[]{0x0000006000000000L});
    public static final BitSet FOLLOW_37_in_variable717 = new BitSet(new long[]{0x0000000002480000L});
    public static final BitSet FOLLOW_literalValue_in_variable721 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_38_in_variable729 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CONST_in_typeRef748 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_typeRef756 = new BitSet(new long[]{0x0000008000140002L});
    public static final BitSet FOLLOW_39_in_typeRef763 = new BitSet(new long[]{0x0000008000140002L});
    public static final BitSet FOLLOW_RESTRICT_in_typeRef773 = new BitSet(new long[]{0x0000000000040002L});
    public static final BitSet FOLLOW_CONST_in_typeRef782 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_HEXPREFIX_in_hexValue796 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_set_in_hexValue798 = new BitSet(new long[]{0x0000000002000002L});
    public static final BitSet FOLLOW_STATIC_in_function832 = new BitSet(new long[]{0x0000000000440000L});
    public static final BitSet FOLLOW_EXTERN_in_function837 = new BitSet(new long[]{0x0000000000440000L});
    public static final BitSet FOLLOW_typeRef_in_function847 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_function851 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_LPARENTHESIS_in_function860 = new BitSet(new long[]{0x0000000008440000L});
    public static final BitSet FOLLOW_typeRef_in_function869 = new BitSet(new long[]{0x0000000408400000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_function873 = new BitSet(new long[]{0x0000000408000000L});
    public static final BitSet FOLLOW_34_in_function887 = new BitSet(new long[]{0x0000000000440000L});
    public static final BitSet FOLLOW_typeRef_in_function891 = new BitSet(new long[]{0x0000000408400000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_function895 = new BitSet(new long[]{0x0000000408000000L});
    public static final BitSet FOLLOW_RPARENTHESIS_in_function919 = new BitSet(new long[]{0x0000004000800000L});
    public static final BitSet FOLLOW_content_in_function924 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_38_in_function929 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENTIFIER_in_namedPart948 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_LBRACE_in_namedPart954 = new BitSet(new long[]{0x00003FBFFF7FCC80L});
    public static final BitSet FOLLOW_basicModuleContent_in_namedPart958 = new BitSet(new long[]{0x00003FBFFF7FCC80L});
    public static final BitSet FOLLOW_RBRACE_in_namedPart964 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REPLACE_in_replace979 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_qualifiedIdentifier_in_replace983 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_LBRACE_in_replace990 = new BitSet(new long[]{0x00003FBFFF7FCC80L});
    public static final BitSet FOLLOW_basicModuleContent_in_replace994 = new BitSet(new long[]{0x00003FBFFF7FCC80L});
    public static final BitSet FOLLOW_RBRACE_in_replace1000 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ADVICE_in_advice1013 = new BitSet(new long[]{0x00003FBFFE7FFFF0L});
    public static final BitSet FOLLOW_adviceHeader_in_advice1015 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_content_in_advice1017 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_adviceHeader1034 = new BitSet(new long[]{0x00003FBFFE7FFFF2L});
    public static final BitSet FOLLOW_preprocessor_in_declarations1058 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_declaration_in_declarations1062 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_44_in_preprocessor1073 = new BitSet(new long[]{0x00003FFFFFFFFFF0L});
    public static final BitSet FOLLOW_set_in_preprocessor1079 = new BitSet(new long[]{0x00003FFFFFDFFFF0L});
    public static final BitSet FOLLOW_PPCONTINUE_in_preprocessor1092 = new BitSet(new long[]{0x00003FFFFFFFFFF0L});
    public static final BitSet FOLLOW_set_in_preprocessor1099 = new BitSet(new long[]{0x00003FFFEFFFFFF0L});
    public static final BitSet FOLLOW_NEWLINE_in_preprocessor1114 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_declaration1125 = new BitSet(new long[]{0x00003FBFFE7FFFF0L});
    public static final BitSet FOLLOW_set_in_declaration1197 = new BitSet(new long[]{0x00003FFFFEFFFFF0L});
    public static final BitSet FOLLOW_content_in_declaration1215 = new BitSet(new long[]{0x0000004000000002L});
    public static final BitSet FOLLOW_38_in_declaration1217 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_38_in_declaration1222 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_content_in_contentcontent1234 = new BitSet(new long[]{0x00003FFFFEFFFFF2L});
    public static final BitSet FOLLOW_set_in_contentcontent1239 = new BitSet(new long[]{0x00003FFFFEFFFFF2L});
    public static final BitSet FOLLOW_LBRACE_in_content1264 = new BitSet(new long[]{0x00003FFFFFFFFFF0L});
    public static final BitSet FOLLOW_contentcontent_in_content1267 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_RBRACE_in_content1273 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TYPES_in_types1286 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_content_in_types1290 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STARTUP_in_startup1302 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_LBRACE_in_startup1306 = new BitSet(new long[]{0x0000000001001180L});
    public static final BitSet FOLLOW_expose_in_startup1309 = new BitSet(new long[]{0x0000000001001180L});
    public static final BitSet FOLLOW_advice_in_startup1313 = new BitSet(new long[]{0x0000000001001180L});
    public static final BitSet FOLLOW_boot_in_startup1317 = new BitSet(new long[]{0x0000000001001180L});
    public static final BitSet FOLLOW_RBRACE_in_startup1322 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SHUTDOWN_in_shutdown1333 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_LBRACE_in_shutdown1337 = new BitSet(new long[]{0x0000000001000180L});
    public static final BitSet FOLLOW_expose_in_shutdown1340 = new BitSet(new long[]{0x0000000001000180L});
    public static final BitSet FOLLOW_advice_in_shutdown1344 = new BitSet(new long[]{0x0000000001000180L});
    public static final BitSet FOLLOW_RBRACE_in_shutdown1348 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_BOOT_in_boot1360 = new BitSet(new long[]{0x00003FBFFE7FFFF0L});
    public static final BitSet FOLLOW_set_in_boot1365 = new BitSet(new long[]{0x00003FFFFE7FFFF0L});
    public static final BitSet FOLLOW_38_in_boot1382 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EXPOSE_in_expose1400 = new BitSet(new long[]{0x0000000000A00000L});
    public static final BitSet FOLLOW_NEWLINE_in_expose1402 = new BitSet(new long[]{0x0000000000A00000L});
    public static final BitSet FOLLOW_LBRACE_in_expose1405 = new BitSet(new long[]{0x0000000001200200L});
    public static final BitSet FOLLOW_NEWLINE_in_expose1407 = new BitSet(new long[]{0x0000000001200200L});
    public static final BitSet FOLLOW_pointcut_in_expose1414 = new BitSet(new long[]{0x0000000001000200L});
    public static final BitSet FOLLOW_RBRACE_in_expose1423 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REQUIRE_in_require1438 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_require1440 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_38_in_require1446 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_POINTCUT_in_pointcut1456 = new BitSet(new long[]{0x00003FFFFFFFFFF0L});
    public static final BitSet FOLLOW_set_in_pointcut1461 = new BitSet(new long[]{0x00003FFFFFFFFFF0L});
    public static final BitSet FOLLOW_38_in_pointcut1469 = new BitSet(new long[]{0x0000000000200002L});
    public static final BitSet FOLLOW_NEWLINE_in_pointcut1471 = new BitSet(new long[]{0x0000000000200002L});
    public static final BitSet FOLLOW_IDENTIFIER_in_qualifiedIdentifier1493 = new BitSet(new long[]{0x0000200000000000L});
    public static final BitSet FOLLOW_45_in_qualifiedIdentifier1495 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_qualifiedIdentifier1499 = new BitSet(new long[]{0x0000000000000002L});

}