package de.sm.vmadl.elements;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.antlr.runtime.ParserRuleReturnScope;

public class ArchitectureElement extends LanguageElement {
	
	public ArchitectureElement(ParserRuleReturnScope prrs, File file) {
		super(prrs, file);
		requirements = new ArrayList<ServiceModule>();
	}

	/**
	 * List of modules this module does require.
	 */
	public List<ServiceModule> requirements;

}
