package de.sm.vmadl.elements;

import java.io.File;

public class ServiceModule extends ServiceInterface {

	/**
	 * This field is used to remember whether the module was already initialized completely.
	 * Is false if this module has been created to satisfy a require statement.
	 */
	public boolean initialized = false;
	
	/**
	 * Name of the service.
	 */
	public QualifiedIdentifier name;
	
	/**
	 * The file where this module has been defined in.
	 */
	public File file;
}
