#ifndef THREAD_H_
#define THREAD_H_

#include <vmobjects/OOObject.h>

extern "C" {

/** Waites for the Thread to finish an destroys it*/
void _Thread_join(pVMObject object, pVMFrame frame);
/** Sets the scheduling priority of the embedded thread*/
void _Thread_priority_(pVMObject object, pVMFrame frame);

/** Releases the processing time of the Objects pthread for some time */
void Thread_yield(pVMObject object, pVMFrame frame);
/** Returns the current Thread object running */
void Thread_current(pVMObject object, pVMFrame frame);

}

#endif /*THREAD_H_*/
