/* 
 * Delay.c
 *  
 * Wait Support for CSOM
 * 
 * by Martin Beck and Jan Klimke
 * 
 * created 2007-06-12
 */

#include "Delay.h"

#include <vmobjects/VMFrame.h>
#include <vmobjects/VMInteger.h>

#include <unistd.h>
#include <stdio.h>

extern "C" {

void _Delay_wait(pVMObject object, pVMFrame frame){
	pVMObject self = SEND(frame, pop);
	pVMInteger integer =(pVMInteger) SEND((pVMObject)self, get_field, 1);
	usleep(SEND(integer, get_embedded_integer)*1000);
    SEND(frame, push, self);
}

}
