#include <module.Image>

bool _VMString_serialize_data(void* _self) {	
	pVMString self = (pVMString) _self;
	if (self->embedded_string) {
		if (!Image_store_byte_sequence(SEND(self->embedded_string, size), 
			                       SEND(self->embedded_string, chars)))
			return false;
	}
	
	return SUPER(VMObject, _self, serialize_data);
}

bool _VMString_deserialize_data(void* _self) {
	pVMString self = (pVMString) _self;

	if (self->embedded_string) {
		char* charRet = (char*)Image_load_byte_sequence(NULL, true);
		
		if (!charRet) 
			return false;
		self->embedded_string = String_new(charRet);
	}
	
	return SUPER(VMObject, _self, deserialize_data);
}
