#include <module.Image>

bool _VMSymbol_serialize_data(void* _self) {	
	pVMSymbol self = (pVMSymbol) _self;

	if (self->embedded_string) {
		if (!Image_store_byte_sequence(SEND(self->embedded_string, size), 
			                       SEND(self->embedded_string, chars)))
			return false;
	}
	
	return SUPER(VMObject, _self, serialize_data);
}

bool _VMSymbol_deserialize_data(void* _self) {
	pVMSymbol self = (pVMSymbol) _self;

	char* charRet;

	if (self->embedded_string) {
		charRet = (char*)Image_load_byte_sequence(NULL, true);
		
		if (!charRet) 
			return false;

        SEND(self, set_string, String_new(charRet));
	}

	self->plain_string = NULL;
	
	return SUPER(VMObject, self, deserialize_data);
}
