// $ANTLR 3.0.1 CSimple__.g 2008-07-27 23:12:08

  package de.sm.csimple;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

public class CSimpleLexer extends Lexer {
    public static final int RBRACE=16;
    public static final int STATIC=6;
    public static final int LETTER=20;
    public static final int CONST=9;
    public static final int TYPEDEF=4;
    public static final int LBRACE=15;
    public static final int EXTERN=8;
    public static final int STRUCT=5;
    public static final int T29=29;
    public static final int T28=28;
    public static final int T27=27;
    public static final int T26=26;
    public static final int T25=25;
    public static final int Tokens=36;
    public static final int T24=24;
    public static final int EOF=-1;
    public static final int ML_COMMENT=23;
    public static final int QUOTE=13;
    public static final int WS=21;
    public static final int NEWLINE=12;
    public static final int PPCONTINUE=18;
    public static final int SPECIAL=19;
    public static final int IDENTIFIER=14;
    public static final int INLINE=7;
    public static final int DIGIT=17;
    public static final int T34=34;
    public static final int COMMENT=22;
    public static final int T33=33;
    public static final int T35=35;
    public static final int T30=30;
    public static final int HEXPREFIX=11;
    public static final int ATTR=10;
    public static final int T32=32;
    public static final int T31=31;

      private int lineCount = 0;
      
      public int getLineCount() {
        return lineCount;
      }

    public CSimpleLexer() {;} 
    public CSimpleLexer(CharStream input) {
        super(input);
    }
    public String getGrammarFileName() { return "CSimple__.g"; }

    // $ANTLR start TYPEDEF
    public final void mTYPEDEF() throws RecognitionException {
        try {
            int _type = TYPEDEF;
            // CSimple__.g:17:9: ( 'typedef' )
            // CSimple__.g:17:11: 'typedef'
            {
            match("typedef"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end TYPEDEF

    // $ANTLR start STRUCT
    public final void mSTRUCT() throws RecognitionException {
        try {
            int _type = STRUCT;
            // CSimple__.g:18:8: ( 'struct' )
            // CSimple__.g:18:10: 'struct'
            {
            match("struct"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end STRUCT

    // $ANTLR start STATIC
    public final void mSTATIC() throws RecognitionException {
        try {
            int _type = STATIC;
            // CSimple__.g:19:8: ( 'static' )
            // CSimple__.g:19:10: 'static'
            {
            match("static"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end STATIC

    // $ANTLR start INLINE
    public final void mINLINE() throws RecognitionException {
        try {
            int _type = INLINE;
            // CSimple__.g:20:8: ( 'inline' )
            // CSimple__.g:20:10: 'inline'
            {
            match("inline"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end INLINE

    // $ANTLR start EXTERN
    public final void mEXTERN() throws RecognitionException {
        try {
            int _type = EXTERN;
            // CSimple__.g:21:8: ( 'extern' )
            // CSimple__.g:21:10: 'extern'
            {
            match("extern"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end EXTERN

    // $ANTLR start CONST
    public final void mCONST() throws RecognitionException {
        try {
            int _type = CONST;
            // CSimple__.g:22:7: ( 'const' )
            // CSimple__.g:22:9: 'const'
            {
            match("const"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end CONST

    // $ANTLR start ATTR
    public final void mATTR() throws RecognitionException {
        try {
            int _type = ATTR;
            // CSimple__.g:23:6: ( '__attribute__' )
            // CSimple__.g:23:8: '__attribute__'
            {
            match("__attribute__"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end ATTR

    // $ANTLR start HEXPREFIX
    public final void mHEXPREFIX() throws RecognitionException {
        try {
            int _type = HEXPREFIX;
            // CSimple__.g:24:11: ( '0x' )
            // CSimple__.g:24:13: '0x'
            {
            match("0x"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end HEXPREFIX

    // $ANTLR start T24
    public final void mT24() throws RecognitionException {
        try {
            int _type = T24;
            // CSimple__.g:25:5: ( '[' )
            // CSimple__.g:25:7: '['
            {
            match('['); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T24

    // $ANTLR start T25
    public final void mT25() throws RecognitionException {
        try {
            int _type = T25;
            // CSimple__.g:26:5: ( ']' )
            // CSimple__.g:26:7: ']'
            {
            match(']'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T25

    // $ANTLR start T26
    public final void mT26() throws RecognitionException {
        try {
            int _type = T26;
            // CSimple__.g:27:5: ( '=' )
            // CSimple__.g:27:7: '='
            {
            match('='); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T26

    // $ANTLR start T27
    public final void mT27() throws RecognitionException {
        try {
            int _type = T27;
            // CSimple__.g:28:5: ( ';' )
            // CSimple__.g:28:7: ';'
            {
            match(';'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T27

    // $ANTLR start T28
    public final void mT28() throws RecognitionException {
        try {
            int _type = T28;
            // CSimple__.g:29:5: ( '#' )
            // CSimple__.g:29:7: '#'
            {
            match('#'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T28

    // $ANTLR start T29
    public final void mT29() throws RecognitionException {
        try {
            int _type = T29;
            // CSimple__.g:30:5: ( '(' )
            // CSimple__.g:30:7: '('
            {
            match('('); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T29

    // $ANTLR start T30
    public final void mT30() throws RecognitionException {
        try {
            int _type = T30;
            // CSimple__.g:31:5: ( ')' )
            // CSimple__.g:31:7: ')'
            {
            match(')'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T30

    // $ANTLR start T31
    public final void mT31() throws RecognitionException {
        try {
            int _type = T31;
            // CSimple__.g:32:5: ( '*' )
            // CSimple__.g:32:7: '*'
            {
            match('*'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T31

    // $ANTLR start T32
    public final void mT32() throws RecognitionException {
        try {
            int _type = T32;
            // CSimple__.g:33:5: ( 'a' )
            // CSimple__.g:33:7: 'a'
            {
            match('a'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T32

    // $ANTLR start T33
    public final void mT33() throws RecognitionException {
        try {
            int _type = T33;
            // CSimple__.g:34:5: ( 'f' )
            // CSimple__.g:34:7: 'f'
            {
            match('f'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T33

    // $ANTLR start T34
    public final void mT34() throws RecognitionException {
        try {
            int _type = T34;
            // CSimple__.g:35:5: ( 'A' )
            // CSimple__.g:35:7: 'A'
            {
            match('A'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T34

    // $ANTLR start T35
    public final void mT35() throws RecognitionException {
        try {
            int _type = T35;
            // CSimple__.g:36:5: ( 'F' )
            // CSimple__.g:36:7: 'F'
            {
            match('F'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T35

    // $ANTLR start SPECIAL
    public final void mSPECIAL() throws RecognitionException {
        try {
            int _type = SPECIAL;
            // CSimple__.g:149:9: ( '(' | ')' | ':' | '=' | '.' | '*' | '+' | '%' | '#' | '/' | '\\\\' | '^' | '?' | '@' | '$' | '_' | ';' | ',' | '|' | '&' | '-' | '<' | '>' | '[' | ']' | '!' | '\\'' | '~' )
            // CSimple__.g:
            {
            if ( input.LA(1)=='!'||(input.LA(1)>='#' && input.LA(1)<='/')||(input.LA(1)>=':' && input.LA(1)<='@')||(input.LA(1)>='[' && input.LA(1)<='_')||input.LA(1)=='|'||input.LA(1)=='~' ) {
                input.consume();

            }
            else {
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recover(mse);    throw mse;
            }


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end SPECIAL

    // $ANTLR start IDENTIFIER
    public final void mIDENTIFIER() throws RecognitionException {
        try {
            int _type = IDENTIFIER;
            // CSimple__.g:152:12: ( ( LETTER | '_' ) ( DIGIT | LETTER | '_' )* )
            // CSimple__.g:152:14: ( LETTER | '_' ) ( DIGIT | LETTER | '_' )*
            {
            if ( (input.LA(1)>='A' && input.LA(1)<='Z')||input.LA(1)=='_'||(input.LA(1)>='a' && input.LA(1)<='z') ) {
                input.consume();

            }
            else {
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recover(mse);    throw mse;
            }

            // CSimple__.g:152:29: ( DIGIT | LETTER | '_' )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( ((LA1_0>='0' && LA1_0<='9')||(LA1_0>='A' && LA1_0<='Z')||LA1_0=='_'||(LA1_0>='a' && LA1_0<='z')) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // CSimple__.g:
            	    {
            	    if ( (input.LA(1)>='0' && input.LA(1)<='9')||(input.LA(1)>='A' && input.LA(1)<='Z')||input.LA(1)=='_'||(input.LA(1)>='a' && input.LA(1)<='z') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recover(mse);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end IDENTIFIER

    // $ANTLR start DIGIT
    public final void mDIGIT() throws RecognitionException {
        try {
            int _type = DIGIT;
            // CSimple__.g:155:5: ( '0' .. '9' )
            // CSimple__.g:155:10: '0' .. '9'
            {
            matchRange('0','9'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end DIGIT

    // $ANTLR start LETTER
    public final void mLETTER() throws RecognitionException {
        try {
            // CSimple__.g:158:5: ( 'a' .. 'z' | 'A' .. 'Z' )
            // CSimple__.g:
            {
            if ( (input.LA(1)>='A' && input.LA(1)<='Z')||(input.LA(1)>='a' && input.LA(1)<='z') ) {
                input.consume();

            }
            else {
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recover(mse);    throw mse;
            }


            }

        }
        finally {
        }
    }
    // $ANTLR end LETTER

    // $ANTLR start PPCONTINUE
    public final void mPPCONTINUE() throws RecognitionException {
        try {
            int _type = PPCONTINUE;
            // CSimple__.g:162:11: ( '\\\\' NEWLINE )
            // CSimple__.g:162:13: '\\\\' NEWLINE
            {
            match('\\'); 
            mNEWLINE(); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end PPCONTINUE

    // $ANTLR start NEWLINE
    public final void mNEWLINE() throws RecognitionException {
        try {
            int _type = NEWLINE;
            // CSimple__.g:165:3: ( ( '\\r' )? '\\n' )
            // CSimple__.g:165:5: ( '\\r' )? '\\n'
            {
            // CSimple__.g:165:5: ( '\\r' )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0=='\r') ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // CSimple__.g:165:5: '\\r'
                    {
                    match('\r'); 

                    }
                    break;

            }

            match('\n'); 
             lineCount++; 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end NEWLINE

    // $ANTLR start WS
    public final void mWS() throws RecognitionException {
        try {
            int _type = WS;
            // CSimple__.g:171:3: ( ( ' ' | '\\t' )+ )
            // CSimple__.g:171:5: ( ' ' | '\\t' )+
            {
            // CSimple__.g:171:5: ( ' ' | '\\t' )+
            int cnt3=0;
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( (LA3_0=='\t'||LA3_0==' ') ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // CSimple__.g:
            	    {
            	    if ( input.LA(1)=='\t'||input.LA(1)==' ' ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recover(mse);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt3 >= 1 ) break loop3;
                        EarlyExitException eee =
                            new EarlyExitException(3, input);
                        throw eee;
                }
                cnt3++;
            } while (true);

             channel=HIDDEN; 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end WS

    // $ANTLR start COMMENT
    public final void mCOMMENT() throws RecognitionException {
        try {
            int _type = COMMENT;
            // CSimple__.g:176:3: ( '//' (~ ( '\\n' | '\\r' ) )* NEWLINE )
            // CSimple__.g:176:5: '//' (~ ( '\\n' | '\\r' ) )* NEWLINE
            {
            match("//"); 

            // CSimple__.g:176:10: (~ ( '\\n' | '\\r' ) )*
            loop4:
            do {
                int alt4=2;
                int LA4_0 = input.LA(1);

                if ( ((LA4_0>='\u0000' && LA4_0<='\t')||(LA4_0>='\u000B' && LA4_0<='\f')||(LA4_0>='\u000E' && LA4_0<='\uFFFE')) ) {
                    alt4=1;
                }


                switch (alt4) {
            	case 1 :
            	    // CSimple__.g:176:11: ~ ( '\\n' | '\\r' )
            	    {
            	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='\t')||(input.LA(1)>='\u000B' && input.LA(1)<='\f')||(input.LA(1)>='\u000E' && input.LA(1)<='\uFFFE') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recover(mse);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop4;
                }
            } while (true);

            mNEWLINE(); 
             channel=HIDDEN; 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end COMMENT

    // $ANTLR start ML_COMMENT
    public final void mML_COMMENT() throws RecognitionException {
        try {
            int _type = ML_COMMENT;
            // CSimple__.g:182:3: ( '/*' ( options {greedy=false; } : . )* '*/' )
            // CSimple__.g:182:5: '/*' ( options {greedy=false; } : . )* '*/'
            {
            match("/*"); 

            // CSimple__.g:182:10: ( options {greedy=false; } : . )*
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);

                if ( (LA5_0=='*') ) {
                    int LA5_1 = input.LA(2);

                    if ( (LA5_1=='/') ) {
                        alt5=2;
                    }
                    else if ( ((LA5_1>='\u0000' && LA5_1<='.')||(LA5_1>='0' && LA5_1<='\uFFFE')) ) {
                        alt5=1;
                    }


                }
                else if ( ((LA5_0>='\u0000' && LA5_0<=')')||(LA5_0>='+' && LA5_0<='\uFFFE')) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    // CSimple__.g:182:37: .
            	    {
            	    matchAny(); 

            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);

            match("*/"); 

             channel=HIDDEN; 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end ML_COMMENT

    // $ANTLR start QUOTE
    public final void mQUOTE() throws RecognitionException {
        try {
            int _type = QUOTE;
            // CSimple__.g:186:8: ( '\"' )
            // CSimple__.g:186:10: '\"'
            {
            match('\"'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end QUOTE

    // $ANTLR start LBRACE
    public final void mLBRACE() throws RecognitionException {
        try {
            int _type = LBRACE;
            // CSimple__.g:187:8: ( '{' )
            // CSimple__.g:187:10: '{'
            {
            match('{'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end LBRACE

    // $ANTLR start RBRACE
    public final void mRBRACE() throws RecognitionException {
        try {
            int _type = RBRACE;
            // CSimple__.g:188:8: ( '}' )
            // CSimple__.g:188:10: '}'
            {
            match('}'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end RBRACE

    public void mTokens() throws RecognitionException {
        // CSimple__.g:1:8: ( TYPEDEF | STRUCT | STATIC | INLINE | EXTERN | CONST | ATTR | HEXPREFIX | T24 | T25 | T26 | T27 | T28 | T29 | T30 | T31 | T32 | T33 | T34 | T35 | SPECIAL | IDENTIFIER | DIGIT | PPCONTINUE | NEWLINE | WS | COMMENT | ML_COMMENT | QUOTE | LBRACE | RBRACE )
        int alt6=31;
        switch ( input.LA(1) ) {
        case 't':
            {
            int LA6_1 = input.LA(2);

            if ( (LA6_1=='y') ) {
                int LA6_30 = input.LA(3);

                if ( (LA6_30=='p') ) {
                    int LA6_52 = input.LA(4);

                    if ( (LA6_52=='e') ) {
                        int LA6_59 = input.LA(5);

                        if ( (LA6_59=='d') ) {
                            int LA6_66 = input.LA(6);

                            if ( (LA6_66=='e') ) {
                                int LA6_73 = input.LA(7);

                                if ( (LA6_73=='f') ) {
                                    int LA6_80 = input.LA(8);

                                    if ( ((LA6_80>='0' && LA6_80<='9')||(LA6_80>='A' && LA6_80<='Z')||LA6_80=='_'||(LA6_80>='a' && LA6_80<='z')) ) {
                                        alt6=22;
                                    }
                                    else {
                                        alt6=1;}
                                }
                                else {
                                    alt6=22;}
                            }
                            else {
                                alt6=22;}
                        }
                        else {
                            alt6=22;}
                    }
                    else {
                        alt6=22;}
                }
                else {
                    alt6=22;}
            }
            else {
                alt6=22;}
            }
            break;
        case 's':
            {
            int LA6_2 = input.LA(2);

            if ( (LA6_2=='t') ) {
                switch ( input.LA(3) ) {
                case 'r':
                    {
                    int LA6_53 = input.LA(4);

                    if ( (LA6_53=='u') ) {
                        int LA6_60 = input.LA(5);

                        if ( (LA6_60=='c') ) {
                            int LA6_67 = input.LA(6);

                            if ( (LA6_67=='t') ) {
                                int LA6_74 = input.LA(7);

                                if ( ((LA6_74>='0' && LA6_74<='9')||(LA6_74>='A' && LA6_74<='Z')||LA6_74=='_'||(LA6_74>='a' && LA6_74<='z')) ) {
                                    alt6=22;
                                }
                                else {
                                    alt6=2;}
                            }
                            else {
                                alt6=22;}
                        }
                        else {
                            alt6=22;}
                    }
                    else {
                        alt6=22;}
                    }
                    break;
                case 'a':
                    {
                    int LA6_54 = input.LA(4);

                    if ( (LA6_54=='t') ) {
                        int LA6_61 = input.LA(5);

                        if ( (LA6_61=='i') ) {
                            int LA6_68 = input.LA(6);

                            if ( (LA6_68=='c') ) {
                                int LA6_75 = input.LA(7);

                                if ( ((LA6_75>='0' && LA6_75<='9')||(LA6_75>='A' && LA6_75<='Z')||LA6_75=='_'||(LA6_75>='a' && LA6_75<='z')) ) {
                                    alt6=22;
                                }
                                else {
                                    alt6=3;}
                            }
                            else {
                                alt6=22;}
                        }
                        else {
                            alt6=22;}
                    }
                    else {
                        alt6=22;}
                    }
                    break;
                default:
                    alt6=22;}

            }
            else {
                alt6=22;}
            }
            break;
        case 'i':
            {
            int LA6_3 = input.LA(2);

            if ( (LA6_3=='n') ) {
                int LA6_32 = input.LA(3);

                if ( (LA6_32=='l') ) {
                    int LA6_55 = input.LA(4);

                    if ( (LA6_55=='i') ) {
                        int LA6_62 = input.LA(5);

                        if ( (LA6_62=='n') ) {
                            int LA6_69 = input.LA(6);

                            if ( (LA6_69=='e') ) {
                                int LA6_76 = input.LA(7);

                                if ( ((LA6_76>='0' && LA6_76<='9')||(LA6_76>='A' && LA6_76<='Z')||LA6_76=='_'||(LA6_76>='a' && LA6_76<='z')) ) {
                                    alt6=22;
                                }
                                else {
                                    alt6=4;}
                            }
                            else {
                                alt6=22;}
                        }
                        else {
                            alt6=22;}
                    }
                    else {
                        alt6=22;}
                }
                else {
                    alt6=22;}
            }
            else {
                alt6=22;}
            }
            break;
        case 'e':
            {
            int LA6_4 = input.LA(2);

            if ( (LA6_4=='x') ) {
                int LA6_33 = input.LA(3);

                if ( (LA6_33=='t') ) {
                    int LA6_56 = input.LA(4);

                    if ( (LA6_56=='e') ) {
                        int LA6_63 = input.LA(5);

                        if ( (LA6_63=='r') ) {
                            int LA6_70 = input.LA(6);

                            if ( (LA6_70=='n') ) {
                                int LA6_77 = input.LA(7);

                                if ( ((LA6_77>='0' && LA6_77<='9')||(LA6_77>='A' && LA6_77<='Z')||LA6_77=='_'||(LA6_77>='a' && LA6_77<='z')) ) {
                                    alt6=22;
                                }
                                else {
                                    alt6=5;}
                            }
                            else {
                                alt6=22;}
                        }
                        else {
                            alt6=22;}
                    }
                    else {
                        alt6=22;}
                }
                else {
                    alt6=22;}
            }
            else {
                alt6=22;}
            }
            break;
        case 'c':
            {
            int LA6_5 = input.LA(2);

            if ( (LA6_5=='o') ) {
                int LA6_34 = input.LA(3);

                if ( (LA6_34=='n') ) {
                    int LA6_57 = input.LA(4);

                    if ( (LA6_57=='s') ) {
                        int LA6_64 = input.LA(5);

                        if ( (LA6_64=='t') ) {
                            int LA6_71 = input.LA(6);

                            if ( ((LA6_71>='0' && LA6_71<='9')||(LA6_71>='A' && LA6_71<='Z')||LA6_71=='_'||(LA6_71>='a' && LA6_71<='z')) ) {
                                alt6=22;
                            }
                            else {
                                alt6=6;}
                        }
                        else {
                            alt6=22;}
                    }
                    else {
                        alt6=22;}
                }
                else {
                    alt6=22;}
            }
            else {
                alt6=22;}
            }
            break;
        case '_':
            {
            switch ( input.LA(2) ) {
            case '_':
                {
                int LA6_35 = input.LA(3);

                if ( (LA6_35=='a') ) {
                    int LA6_58 = input.LA(4);

                    if ( (LA6_58=='t') ) {
                        int LA6_65 = input.LA(5);

                        if ( (LA6_65=='t') ) {
                            int LA6_72 = input.LA(6);

                            if ( (LA6_72=='r') ) {
                                int LA6_79 = input.LA(7);

                                if ( (LA6_79=='i') ) {
                                    int LA6_85 = input.LA(8);

                                    if ( (LA6_85=='b') ) {
                                        int LA6_87 = input.LA(9);

                                        if ( (LA6_87=='u') ) {
                                            int LA6_88 = input.LA(10);

                                            if ( (LA6_88=='t') ) {
                                                int LA6_89 = input.LA(11);

                                                if ( (LA6_89=='e') ) {
                                                    int LA6_90 = input.LA(12);

                                                    if ( (LA6_90=='_') ) {
                                                        int LA6_91 = input.LA(13);

                                                        if ( (LA6_91=='_') ) {
                                                            int LA6_92 = input.LA(14);

                                                            if ( ((LA6_92>='0' && LA6_92<='9')||(LA6_92>='A' && LA6_92<='Z')||LA6_92=='_'||(LA6_92>='a' && LA6_92<='z')) ) {
                                                                alt6=22;
                                                            }
                                                            else {
                                                                alt6=7;}
                                                        }
                                                        else {
                                                            alt6=22;}
                                                    }
                                                    else {
                                                        alt6=22;}
                                                }
                                                else {
                                                    alt6=22;}
                                            }
                                            else {
                                                alt6=22;}
                                        }
                                        else {
                                            alt6=22;}
                                    }
                                    else {
                                        alt6=22;}
                                }
                                else {
                                    alt6=22;}
                            }
                            else {
                                alt6=22;}
                        }
                        else {
                            alt6=22;}
                    }
                    else {
                        alt6=22;}
                }
                else {
                    alt6=22;}
                }
                break;
            case '0':
            case '1':
            case '2':
            case '3':
            case '4':
            case '5':
            case '6':
            case '7':
            case '8':
            case '9':
            case 'A':
            case 'B':
            case 'C':
            case 'D':
            case 'E':
            case 'F':
            case 'G':
            case 'H':
            case 'I':
            case 'J':
            case 'K':
            case 'L':
            case 'M':
            case 'N':
            case 'O':
            case 'P':
            case 'Q':
            case 'R':
            case 'S':
            case 'T':
            case 'U':
            case 'V':
            case 'W':
            case 'X':
            case 'Y':
            case 'Z':
            case 'a':
            case 'b':
            case 'c':
            case 'd':
            case 'e':
            case 'f':
            case 'g':
            case 'h':
            case 'i':
            case 'j':
            case 'k':
            case 'l':
            case 'm':
            case 'n':
            case 'o':
            case 'p':
            case 'q':
            case 'r':
            case 's':
            case 't':
            case 'u':
            case 'v':
            case 'w':
            case 'x':
            case 'y':
            case 'z':
                {
                alt6=22;
                }
                break;
            default:
                alt6=21;}

            }
            break;
        case '0':
            {
            int LA6_7 = input.LA(2);

            if ( (LA6_7=='x') ) {
                alt6=8;
            }
            else {
                alt6=23;}
            }
            break;
        case '[':
            {
            alt6=9;
            }
            break;
        case ']':
            {
            alt6=10;
            }
            break;
        case '=':
            {
            alt6=11;
            }
            break;
        case ';':
            {
            alt6=12;
            }
            break;
        case '#':
            {
            alt6=13;
            }
            break;
        case '(':
            {
            alt6=14;
            }
            break;
        case ')':
            {
            alt6=15;
            }
            break;
        case '*':
            {
            alt6=16;
            }
            break;
        case 'a':
            {
            int LA6_16 = input.LA(2);

            if ( ((LA6_16>='0' && LA6_16<='9')||(LA6_16>='A' && LA6_16<='Z')||LA6_16=='_'||(LA6_16>='a' && LA6_16<='z')) ) {
                alt6=22;
            }
            else {
                alt6=17;}
            }
            break;
        case 'f':
            {
            int LA6_17 = input.LA(2);

            if ( ((LA6_17>='0' && LA6_17<='9')||(LA6_17>='A' && LA6_17<='Z')||LA6_17=='_'||(LA6_17>='a' && LA6_17<='z')) ) {
                alt6=22;
            }
            else {
                alt6=18;}
            }
            break;
        case 'A':
            {
            int LA6_18 = input.LA(2);

            if ( ((LA6_18>='0' && LA6_18<='9')||(LA6_18>='A' && LA6_18<='Z')||LA6_18=='_'||(LA6_18>='a' && LA6_18<='z')) ) {
                alt6=22;
            }
            else {
                alt6=19;}
            }
            break;
        case 'F':
            {
            int LA6_19 = input.LA(2);

            if ( ((LA6_19>='0' && LA6_19<='9')||(LA6_19>='A' && LA6_19<='Z')||LA6_19=='_'||(LA6_19>='a' && LA6_19<='z')) ) {
                alt6=22;
            }
            else {
                alt6=20;}
            }
            break;
        case '\\':
            {
            int LA6_20 = input.LA(2);

            if ( (LA6_20=='\n'||LA6_20=='\r') ) {
                alt6=24;
            }
            else {
                alt6=21;}
            }
            break;
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'b':
        case 'd':
        case 'g':
        case 'h':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 'r':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':
            {
            alt6=22;
            }
            break;
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
            {
            alt6=23;
            }
            break;
        case '/':
            {
            switch ( input.LA(2) ) {
            case '*':
                {
                alt6=28;
                }
                break;
            case '/':
                {
                alt6=27;
                }
                break;
            default:
                alt6=21;}

            }
            break;
        case '\n':
        case '\r':
            {
            alt6=25;
            }
            break;
        case '\t':
        case ' ':
            {
            alt6=26;
            }
            break;
        case '!':
        case '$':
        case '%':
        case '&':
        case '\'':
        case '+':
        case ',':
        case '-':
        case '.':
        case ':':
        case '<':
        case '>':
        case '?':
        case '@':
        case '^':
        case '|':
        case '~':
            {
            alt6=21;
            }
            break;
        case '\"':
            {
            alt6=29;
            }
            break;
        case '{':
            {
            alt6=30;
            }
            break;
        case '}':
            {
            alt6=31;
            }
            break;
        default:
            NoViableAltException nvae =
                new NoViableAltException("1:1: Tokens : ( TYPEDEF | STRUCT | STATIC | INLINE | EXTERN | CONST | ATTR | HEXPREFIX | T24 | T25 | T26 | T27 | T28 | T29 | T30 | T31 | T32 | T33 | T34 | T35 | SPECIAL | IDENTIFIER | DIGIT | PPCONTINUE | NEWLINE | WS | COMMENT | ML_COMMENT | QUOTE | LBRACE | RBRACE );", 6, 0, input);

            throw nvae;
        }

        switch (alt6) {
            case 1 :
                // CSimple__.g:1:10: TYPEDEF
                {
                mTYPEDEF(); 

                }
                break;
            case 2 :
                // CSimple__.g:1:18: STRUCT
                {
                mSTRUCT(); 

                }
                break;
            case 3 :
                // CSimple__.g:1:25: STATIC
                {
                mSTATIC(); 

                }
                break;
            case 4 :
                // CSimple__.g:1:32: INLINE
                {
                mINLINE(); 

                }
                break;
            case 5 :
                // CSimple__.g:1:39: EXTERN
                {
                mEXTERN(); 

                }
                break;
            case 6 :
                // CSimple__.g:1:46: CONST
                {
                mCONST(); 

                }
                break;
            case 7 :
                // CSimple__.g:1:52: ATTR
                {
                mATTR(); 

                }
                break;
            case 8 :
                // CSimple__.g:1:57: HEXPREFIX
                {
                mHEXPREFIX(); 

                }
                break;
            case 9 :
                // CSimple__.g:1:67: T24
                {
                mT24(); 

                }
                break;
            case 10 :
                // CSimple__.g:1:71: T25
                {
                mT25(); 

                }
                break;
            case 11 :
                // CSimple__.g:1:75: T26
                {
                mT26(); 

                }
                break;
            case 12 :
                // CSimple__.g:1:79: T27
                {
                mT27(); 

                }
                break;
            case 13 :
                // CSimple__.g:1:83: T28
                {
                mT28(); 

                }
                break;
            case 14 :
                // CSimple__.g:1:87: T29
                {
                mT29(); 

                }
                break;
            case 15 :
                // CSimple__.g:1:91: T30
                {
                mT30(); 

                }
                break;
            case 16 :
                // CSimple__.g:1:95: T31
                {
                mT31(); 

                }
                break;
            case 17 :
                // CSimple__.g:1:99: T32
                {
                mT32(); 

                }
                break;
            case 18 :
                // CSimple__.g:1:103: T33
                {
                mT33(); 

                }
                break;
            case 19 :
                // CSimple__.g:1:107: T34
                {
                mT34(); 

                }
                break;
            case 20 :
                // CSimple__.g:1:111: T35
                {
                mT35(); 

                }
                break;
            case 21 :
                // CSimple__.g:1:115: SPECIAL
                {
                mSPECIAL(); 

                }
                break;
            case 22 :
                // CSimple__.g:1:123: IDENTIFIER
                {
                mIDENTIFIER(); 

                }
                break;
            case 23 :
                // CSimple__.g:1:134: DIGIT
                {
                mDIGIT(); 

                }
                break;
            case 24 :
                // CSimple__.g:1:140: PPCONTINUE
                {
                mPPCONTINUE(); 

                }
                break;
            case 25 :
                // CSimple__.g:1:151: NEWLINE
                {
                mNEWLINE(); 

                }
                break;
            case 26 :
                // CSimple__.g:1:159: WS
                {
                mWS(); 

                }
                break;
            case 27 :
                // CSimple__.g:1:162: COMMENT
                {
                mCOMMENT(); 

                }
                break;
            case 28 :
                // CSimple__.g:1:170: ML_COMMENT
                {
                mML_COMMENT(); 

                }
                break;
            case 29 :
                // CSimple__.g:1:181: QUOTE
                {
                mQUOTE(); 

                }
                break;
            case 30 :
                // CSimple__.g:1:187: LBRACE
                {
                mLBRACE(); 

                }
                break;
            case 31 :
                // CSimple__.g:1:194: RBRACE
                {
                mRBRACE(); 

                }
                break;

        }

    }


 

}