// $ANTLR 3.0.1 /VMADL.j/src/de/sm/csimple/CSimple.g 2008-08-03 13:41:24

  package de.sm.csimple;
  
  import java.io.File;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

import org.antlr.runtime.tree.*;

public class CSimpleParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "TYPEDEF", "STRUCT", "STATIC", "INLINE", "EXTERN", "CONST", "MINUS", "ATTR", "HEXPREFIX", "NEWLINE", "QUOTE", "IDENTIFIER", "LBRACE", "RBRACE", "DIGIT", "PPCONTINUE", "SPECIAL", "LETTER", "WS", "COMMENT", "ML_COMMENT", "'['", "']'", "'='", "';'", "'#'", "'('", "')'", "'*'", "'a'", "'f'", "'A'", "'F'"
    };
    public static final int RBRACE=17;
    public static final int LETTER=21;
    public static final int STATIC=6;
    public static final int CONST=9;
    public static final int TYPEDEF=4;
    public static final int LBRACE=16;
    public static final int EXTERN=8;
    public static final int STRUCT=5;
    public static final int MINUS=10;
    public static final int EOF=-1;
    public static final int ML_COMMENT=24;
    public static final int QUOTE=14;
    public static final int WS=22;
    public static final int NEWLINE=13;
    public static final int PPCONTINUE=19;
    public static final int SPECIAL=20;
    public static final int IDENTIFIER=15;
    public static final int INLINE=7;
    public static final int DIGIT=18;
    public static final int COMMENT=23;
    public static final int ATTR=11;
    public static final int HEXPREFIX=12;

        public CSimpleParser(TokenStream input) {
            super(input);
            ruleMemo = new HashMap[67+1];
         }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "/VMADL.j/src/de/sm/csimple/CSimple.g"; }


    	private List<String> functions = new ArrayList<String>();
    	
    	public List<String> getFuntions() {
    		return functions;
    	}
    	
    	private File parsedFile;
      
      /**
      * Make like error reporting for parser errors allows to benefit
      * from IDE make integration.
      */
      @Override
      public void reportError(RecognitionException re) {
        String errorMsg = "";
        if (parsedFile != null) {
          errorMsg += parsedFile.getAbsolutePath();
        }
        
        errorMsg += ":" + re.line + ": warning: Non critical parse error, file is ignored: ";
        System.err.print(errorMsg);
        super.reportError(re);
      }
      
      /**
      * Set the file which is actually parsed.
      * Is used to be able to generate meaningful error messages.
      * Is not used for parsing at all.
      */
      public void setParsedFile(File file) {
        parsedFile = file;
      }
      
      private int preprocessorCount = 0;
      private int typedefCount = 0;
      private int structCount = 0;
      private int functionSigCount = 0;
      private int functionCount = 0;
      private int variableCount = 0;
      
      public int getPreprocessorCount() {
        return preprocessorCount;
      }
      
      public int getTypedefCount() {
        return typedefCount;
      }
      
      public int getStructCount() {
        return structCount;
      }
      
      public int getFunctionSigCount() {
        return functionSigCount;
      }
      
      public int getFunctionCount() {
        return functionCount;
      }
      
      public int getVariableCount() {
        return variableCount;
      }


    public static class definitions_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start definitions
    // /VMADL.j/src/de/sm/csimple/CSimple.g:109:0: definitions : ( typedefinition | struct | function | preprocessor | variable | NEWLINE | externDef )* EOF ;
    public final definitions_return definitions() throws RecognitionException {
        definitions_return retval = new definitions_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token NEWLINE6=null;
        Token EOF8=null;
        typedefinition_return typedefinition1 = null;

        struct_return struct2 = null;

        function_return function3 = null;

        preprocessor_return preprocessor4 = null;

        variable_return variable5 = null;

        externDef_return externDef7 = null;


        Object NEWLINE6_tree=null;
        Object EOF8_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:109:12: ( ( typedefinition | struct | function | preprocessor | variable | NEWLINE | externDef )* EOF )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:110:2: ( typedefinition | struct | function | preprocessor | variable | NEWLINE | externDef )* EOF
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/csimple/CSimple.g:110:2: ( typedefinition | struct | function | preprocessor | variable | NEWLINE | externDef )*
            loop1:
            do {
                int alt1=8;
                switch ( input.LA(1) ) {
                case TYPEDEF:
                    {
                    alt1=1;
                    }
                    break;
                case STRUCT:
                    {
                    int LA1_3 = input.LA(2);

                    if ( (synpred2()) ) {
                        alt1=2;
                    }
                    else if ( (synpred3()) ) {
                        alt1=3;
                    }
                    else if ( (synpred5()) ) {
                        alt1=5;
                    }


                    }
                    break;
                case IDENTIFIER:
                    {
                    int LA1_4 = input.LA(2);

                    if ( (synpred2()) ) {
                        alt1=2;
                    }
                    else if ( (synpred3()) ) {
                        alt1=3;
                    }
                    else if ( (synpred5()) ) {
                        alt1=5;
                    }


                    }
                    break;
                case EXTERN:
                    {
                    int LA1_5 = input.LA(2);

                    if ( (synpred3()) ) {
                        alt1=3;
                    }
                    else if ( (synpred5()) ) {
                        alt1=5;
                    }
                    else if ( (synpred7()) ) {
                        alt1=7;
                    }


                    }
                    break;
                case INLINE:
                    {
                    alt1=3;
                    }
                    break;
                case CONST:
                    {
                    int LA1_7 = input.LA(2);

                    if ( (synpred3()) ) {
                        alt1=3;
                    }
                    else if ( (synpred5()) ) {
                        alt1=5;
                    }


                    }
                    break;
                case 29:
                    {
                    alt1=4;
                    }
                    break;
                case NEWLINE:
                    {
                    alt1=6;
                    }
                    break;
                case STATIC:
                    {
                    int LA1_10 = input.LA(2);

                    if ( (synpred3()) ) {
                        alt1=3;
                    }
                    else if ( (synpred5()) ) {
                        alt1=5;
                    }


                    }
                    break;

                }

                switch (alt1) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:110:3: typedefinition
            	    {
            	    pushFollow(FOLLOW_typedefinition_in_definitions192);
            	    typedefinition1=typedefinition();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, typedefinition1.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:110:20: struct
            	    {
            	    pushFollow(FOLLOW_struct_in_definitions196);
            	    struct2=struct();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, struct2.getTree());

            	    }
            	    break;
            	case 3 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:110:29: function
            	    {
            	    pushFollow(FOLLOW_function_in_definitions200);
            	    function3=function();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, function3.getTree());

            	    }
            	    break;
            	case 4 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:110:40: preprocessor
            	    {
            	    pushFollow(FOLLOW_preprocessor_in_definitions204);
            	    preprocessor4=preprocessor();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, preprocessor4.getTree());

            	    }
            	    break;
            	case 5 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:110:55: variable
            	    {
            	    pushFollow(FOLLOW_variable_in_definitions208);
            	    variable5=variable();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, variable5.getTree());

            	    }
            	    break;
            	case 6 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:110:66: NEWLINE
            	    {
            	    NEWLINE6=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_definitions212); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    NEWLINE6_tree = (Object)adaptor.create(NEWLINE6);
            	    adaptor.addChild(root_0, NEWLINE6_tree);
            	    }

            	    }
            	    break;
            	case 7 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:110:76: externDef
            	    {
            	    pushFollow(FOLLOW_externDef_in_definitions216);
            	    externDef7=externDef();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, externDef7.getTree());

            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            EOF8=(Token)input.LT(1);
            match(input,EOF,FOLLOW_EOF_in_definitions222); if (failed) return retval;
            if ( backtracking==0 ) {
            EOF8_tree = (Object)adaptor.create(EOF8);
            adaptor.addChild(root_0, EOF8_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end definitions

    public static class externDef_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start externDef
    // /VMADL.j/src/de/sm/csimple/CSimple.g:114:0: externDef : EXTERN QUOTE IDENTIFIER QUOTE LBRACE ( typedefinition | struct | function | preprocessor | variable | NEWLINE )* RBRACE ;
    public final externDef_return externDef() throws RecognitionException {
        externDef_return retval = new externDef_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token EXTERN9=null;
        Token QUOTE10=null;
        Token IDENTIFIER11=null;
        Token QUOTE12=null;
        Token LBRACE13=null;
        Token NEWLINE19=null;
        Token RBRACE20=null;
        typedefinition_return typedefinition14 = null;

        struct_return struct15 = null;

        function_return function16 = null;

        preprocessor_return preprocessor17 = null;

        variable_return variable18 = null;


        Object EXTERN9_tree=null;
        Object QUOTE10_tree=null;
        Object IDENTIFIER11_tree=null;
        Object QUOTE12_tree=null;
        Object LBRACE13_tree=null;
        Object NEWLINE19_tree=null;
        Object RBRACE20_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:114:10: ( EXTERN QUOTE IDENTIFIER QUOTE LBRACE ( typedefinition | struct | function | preprocessor | variable | NEWLINE )* RBRACE )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:115:3: EXTERN QUOTE IDENTIFIER QUOTE LBRACE ( typedefinition | struct | function | preprocessor | variable | NEWLINE )* RBRACE
            {
            root_0 = (Object)adaptor.nil();

            EXTERN9=(Token)input.LT(1);
            match(input,EXTERN,FOLLOW_EXTERN_in_externDef232); if (failed) return retval;
            if ( backtracking==0 ) {
            EXTERN9_tree = (Object)adaptor.create(EXTERN9);
            adaptor.addChild(root_0, EXTERN9_tree);
            }
            QUOTE10=(Token)input.LT(1);
            match(input,QUOTE,FOLLOW_QUOTE_in_externDef234); if (failed) return retval;
            if ( backtracking==0 ) {
            QUOTE10_tree = (Object)adaptor.create(QUOTE10);
            adaptor.addChild(root_0, QUOTE10_tree);
            }
            IDENTIFIER11=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_externDef236); if (failed) return retval;
            if ( backtracking==0 ) {
            IDENTIFIER11_tree = (Object)adaptor.create(IDENTIFIER11);
            adaptor.addChild(root_0, IDENTIFIER11_tree);
            }
            QUOTE12=(Token)input.LT(1);
            match(input,QUOTE,FOLLOW_QUOTE_in_externDef238); if (failed) return retval;
            if ( backtracking==0 ) {
            QUOTE12_tree = (Object)adaptor.create(QUOTE12);
            adaptor.addChild(root_0, QUOTE12_tree);
            }
            LBRACE13=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_externDef243); if (failed) return retval;
            if ( backtracking==0 ) {
            LBRACE13_tree = (Object)adaptor.create(LBRACE13);
            adaptor.addChild(root_0, LBRACE13_tree);
            }
            // /VMADL.j/src/de/sm/csimple/CSimple.g:117:3: ( typedefinition | struct | function | preprocessor | variable | NEWLINE )*
            loop2:
            do {
                int alt2=7;
                switch ( input.LA(1) ) {
                case TYPEDEF:
                    {
                    alt2=1;
                    }
                    break;
                case STRUCT:
                    {
                    int LA2_3 = input.LA(2);

                    if ( (synpred9()) ) {
                        alt2=2;
                    }
                    else if ( (synpred10()) ) {
                        alt2=3;
                    }
                    else if ( (synpred12()) ) {
                        alt2=5;
                    }


                    }
                    break;
                case IDENTIFIER:
                    {
                    int LA2_4 = input.LA(2);

                    if ( (synpred9()) ) {
                        alt2=2;
                    }
                    else if ( (synpred10()) ) {
                        alt2=3;
                    }
                    else if ( (synpred12()) ) {
                        alt2=5;
                    }


                    }
                    break;
                case STATIC:
                case EXTERN:
                    {
                    int LA2_5 = input.LA(2);

                    if ( (synpred10()) ) {
                        alt2=3;
                    }
                    else if ( (synpred12()) ) {
                        alt2=5;
                    }


                    }
                    break;
                case INLINE:
                    {
                    alt2=3;
                    }
                    break;
                case CONST:
                    {
                    int LA2_7 = input.LA(2);

                    if ( (synpred10()) ) {
                        alt2=3;
                    }
                    else if ( (synpred12()) ) {
                        alt2=5;
                    }


                    }
                    break;
                case 29:
                    {
                    alt2=4;
                    }
                    break;
                case NEWLINE:
                    {
                    alt2=6;
                    }
                    break;

                }

                switch (alt2) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:117:4: typedefinition
            	    {
            	    pushFollow(FOLLOW_typedefinition_in_externDef248);
            	    typedefinition14=typedefinition();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, typedefinition14.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:117:21: struct
            	    {
            	    pushFollow(FOLLOW_struct_in_externDef252);
            	    struct15=struct();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, struct15.getTree());

            	    }
            	    break;
            	case 3 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:117:30: function
            	    {
            	    pushFollow(FOLLOW_function_in_externDef256);
            	    function16=function();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, function16.getTree());

            	    }
            	    break;
            	case 4 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:117:41: preprocessor
            	    {
            	    pushFollow(FOLLOW_preprocessor_in_externDef260);
            	    preprocessor17=preprocessor();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, preprocessor17.getTree());

            	    }
            	    break;
            	case 5 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:117:56: variable
            	    {
            	    pushFollow(FOLLOW_variable_in_externDef264);
            	    variable18=variable();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, variable18.getTree());

            	    }
            	    break;
            	case 6 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:117:67: NEWLINE
            	    {
            	    NEWLINE19=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_externDef268); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    NEWLINE19_tree = (Object)adaptor.create(NEWLINE19);
            	    adaptor.addChild(root_0, NEWLINE19_tree);
            	    }

            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

            RBRACE20=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_externDef275); if (failed) return retval;
            if ( backtracking==0 ) {
            RBRACE20_tree = (Object)adaptor.create(RBRACE20);
            adaptor.addChild(root_0, RBRACE20_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end externDef

    public static class literalValue_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start literalValue
    // /VMADL.j/src/de/sm/csimple/CSimple.g:121:0: literalValue : ( IDENTIFIER | ( MINUS )? ( DIGIT )+ | hexValue | content | '\"' (~ ( '\"' ) )* '\"' );
    public final literalValue_return literalValue() throws RecognitionException {
        literalValue_return retval = new literalValue_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token IDENTIFIER21=null;
        Token MINUS22=null;
        Token DIGIT23=null;
        Token char_literal26=null;
        Token set27=null;
        Token char_literal28=null;
        hexValue_return hexValue24 = null;

        content_return content25 = null;


        Object IDENTIFIER21_tree=null;
        Object MINUS22_tree=null;
        Object DIGIT23_tree=null;
        Object char_literal26_tree=null;
        Object set27_tree=null;
        Object char_literal28_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:121:13: ( IDENTIFIER | ( MINUS )? ( DIGIT )+ | hexValue | content | '\"' (~ ( '\"' ) )* '\"' )
            int alt6=5;
            switch ( input.LA(1) ) {
            case IDENTIFIER:
                {
                alt6=1;
                }
                break;
            case MINUS:
            case DIGIT:
                {
                alt6=2;
                }
                break;
            case HEXPREFIX:
                {
                alt6=3;
                }
                break;
            case LBRACE:
                {
                alt6=4;
                }
                break;
            case QUOTE:
                {
                alt6=5;
                }
                break;
            default:
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("121:0: literalValue : ( IDENTIFIER | ( MINUS )? ( DIGIT )+ | hexValue | content | '\"' (~ ( '\"' ) )* '\"' );", 6, 0, input);

                throw nvae;
            }

            switch (alt6) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:122:2: IDENTIFIER
                    {
                    root_0 = (Object)adaptor.nil();

                    IDENTIFIER21=(Token)input.LT(1);
                    match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_literalValue284); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IDENTIFIER21_tree = (Object)adaptor.create(IDENTIFIER21);
                    adaptor.addChild(root_0, IDENTIFIER21_tree);
                    }

                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:122:15: ( MINUS )? ( DIGIT )+
                    {
                    root_0 = (Object)adaptor.nil();

                    // /VMADL.j/src/de/sm/csimple/CSimple.g:122:15: ( MINUS )?
                    int alt3=2;
                    int LA3_0 = input.LA(1);

                    if ( (LA3_0==MINUS) ) {
                        alt3=1;
                    }
                    switch (alt3) {
                        case 1 :
                            // /VMADL.j/src/de/sm/csimple/CSimple.g:0:0: MINUS
                            {
                            MINUS22=(Token)input.LT(1);
                            match(input,MINUS,FOLLOW_MINUS_in_literalValue288); if (failed) return retval;
                            if ( backtracking==0 ) {
                            MINUS22_tree = (Object)adaptor.create(MINUS22);
                            adaptor.addChild(root_0, MINUS22_tree);
                            }

                            }
                            break;

                    }

                    // /VMADL.j/src/de/sm/csimple/CSimple.g:122:22: ( DIGIT )+
                    int cnt4=0;
                    loop4:
                    do {
                        int alt4=2;
                        int LA4_0 = input.LA(1);

                        if ( (LA4_0==DIGIT) ) {
                            alt4=1;
                        }


                        switch (alt4) {
                    	case 1 :
                    	    // /VMADL.j/src/de/sm/csimple/CSimple.g:0:0: DIGIT
                    	    {
                    	    DIGIT23=(Token)input.LT(1);
                    	    match(input,DIGIT,FOLLOW_DIGIT_in_literalValue291); if (failed) return retval;
                    	    if ( backtracking==0 ) {
                    	    DIGIT23_tree = (Object)adaptor.create(DIGIT23);
                    	    adaptor.addChild(root_0, DIGIT23_tree);
                    	    }

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt4 >= 1 ) break loop4;
                    	    if (backtracking>0) {failed=true; return retval;}
                                EarlyExitException eee =
                                    new EarlyExitException(4, input);
                                throw eee;
                        }
                        cnt4++;
                    } while (true);


                    }
                    break;
                case 3 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:122:31: hexValue
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_hexValue_in_literalValue296);
                    hexValue24=hexValue();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, hexValue24.getTree());

                    }
                    break;
                case 4 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:122:42: content
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_content_in_literalValue300);
                    content25=content();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, content25.getTree());

                    }
                    break;
                case 5 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:123:2: '\"' (~ ( '\"' ) )* '\"'
                    {
                    root_0 = (Object)adaptor.nil();

                    char_literal26=(Token)input.LT(1);
                    match(input,QUOTE,FOLLOW_QUOTE_in_literalValue305); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal26_tree = (Object)adaptor.create(char_literal26);
                    adaptor.addChild(root_0, char_literal26_tree);
                    }
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:123:6: (~ ( '\"' ) )*
                    loop5:
                    do {
                        int alt5=2;
                        int LA5_0 = input.LA(1);

                        if ( ((LA5_0>=TYPEDEF && LA5_0<=NEWLINE)||(LA5_0>=IDENTIFIER && LA5_0<=36)) ) {
                            alt5=1;
                        }


                        switch (alt5) {
                    	case 1 :
                    	    // /VMADL.j/src/de/sm/csimple/CSimple.g:0:0: ~ ( '\"' )
                    	    {
                    	    set27=(Token)input.LT(1);
                    	    if ( (input.LA(1)>=TYPEDEF && input.LA(1)<=NEWLINE)||(input.LA(1)>=IDENTIFIER && input.LA(1)<=36) ) {
                    	        input.consume();
                    	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set27));
                    	        errorRecovery=false;failed=false;
                    	    }
                    	    else {
                    	        if (backtracking>0) {failed=true; return retval;}
                    	        MismatchedSetException mse =
                    	            new MismatchedSetException(null,input);
                    	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_literalValue307);    throw mse;
                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop5;
                        }
                    } while (true);

                    char_literal28=(Token)input.LT(1);
                    match(input,QUOTE,FOLLOW_QUOTE_in_literalValue313); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal28_tree = (Object)adaptor.create(char_literal28);
                    adaptor.addChild(root_0, char_literal28_tree);
                    }

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end literalValue

    public static class variable_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start variable
    // /VMADL.j/src/de/sm/csimple/CSimple.g:126:0: variable : ( STATIC | EXTERN )? typeRef IDENTIFIER ( '[' ( literalValue )? ']' )? ( '=' literalValue )? ';' ;
    public final variable_return variable() throws RecognitionException {
        variable_return retval = new variable_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set29=null;
        Token IDENTIFIER31=null;
        Token char_literal32=null;
        Token char_literal34=null;
        Token char_literal35=null;
        Token char_literal37=null;
        typeRef_return typeRef30 = null;

        literalValue_return literalValue33 = null;

        literalValue_return literalValue36 = null;


        Object set29_tree=null;
        Object IDENTIFIER31_tree=null;
        Object char_literal32_tree=null;
        Object char_literal34_tree=null;
        Object char_literal35_tree=null;
        Object char_literal37_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:126:9: ( ( STATIC | EXTERN )? typeRef IDENTIFIER ( '[' ( literalValue )? ']' )? ( '=' literalValue )? ';' )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:127:2: ( STATIC | EXTERN )? typeRef IDENTIFIER ( '[' ( literalValue )? ']' )? ( '=' literalValue )? ';'
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/csimple/CSimple.g:127:2: ( STATIC | EXTERN )?
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==STATIC||LA7_0==EXTERN) ) {
                alt7=1;
            }
            switch (alt7) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:
                    {
                    set29=(Token)input.LT(1);
                    if ( input.LA(1)==STATIC||input.LA(1)==EXTERN ) {
                        input.consume();
                        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set29));
                        errorRecovery=false;failed=false;
                    }
                    else {
                        if (backtracking>0) {failed=true; return retval;}
                        MismatchedSetException mse =
                            new MismatchedSetException(null,input);
                        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_variable322);    throw mse;
                    }


                    }
                    break;

            }

            pushFollow(FOLLOW_typeRef_in_variable332);
            typeRef30=typeRef();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, typeRef30.getTree());
            IDENTIFIER31=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_variable337); if (failed) return retval;
            if ( backtracking==0 ) {
            IDENTIFIER31_tree = (Object)adaptor.create(IDENTIFIER31);
            adaptor.addChild(root_0, IDENTIFIER31_tree);
            }
            // /VMADL.j/src/de/sm/csimple/CSimple.g:130:2: ( '[' ( literalValue )? ']' )?
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==25) ) {
                alt9=1;
            }
            switch (alt9) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:130:3: '[' ( literalValue )? ']'
                    {
                    char_literal32=(Token)input.LT(1);
                    match(input,25,FOLLOW_25_in_variable342); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal32_tree = (Object)adaptor.create(char_literal32);
                    adaptor.addChild(root_0, char_literal32_tree);
                    }
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:130:7: ( literalValue )?
                    int alt8=2;
                    int LA8_0 = input.LA(1);

                    if ( (LA8_0==MINUS||LA8_0==HEXPREFIX||(LA8_0>=QUOTE && LA8_0<=LBRACE)||LA8_0==DIGIT) ) {
                        alt8=1;
                    }
                    switch (alt8) {
                        case 1 :
                            // /VMADL.j/src/de/sm/csimple/CSimple.g:130:8: literalValue
                            {
                            pushFollow(FOLLOW_literalValue_in_variable345);
                            literalValue33=literalValue();
                            _fsp--;
                            if (failed) return retval;
                            if ( backtracking==0 ) adaptor.addChild(root_0, literalValue33.getTree());

                            }
                            break;

                    }

                    char_literal34=(Token)input.LT(1);
                    match(input,26,FOLLOW_26_in_variable349); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal34_tree = (Object)adaptor.create(char_literal34);
                    adaptor.addChild(root_0, char_literal34_tree);
                    }

                    }
                    break;

            }

            // /VMADL.j/src/de/sm/csimple/CSimple.g:131:2: ( '=' literalValue )?
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==27) ) {
                alt10=1;
            }
            switch (alt10) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:131:4: '=' literalValue
                    {
                    char_literal35=(Token)input.LT(1);
                    match(input,27,FOLLOW_27_in_variable356); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal35_tree = (Object)adaptor.create(char_literal35);
                    adaptor.addChild(root_0, char_literal35_tree);
                    }
                    pushFollow(FOLLOW_literalValue_in_variable358);
                    literalValue36=literalValue();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, literalValue36.getTree());

                    }
                    break;

            }

            char_literal37=(Token)input.LT(1);
            match(input,28,FOLLOW_28_in_variable364); if (failed) return retval;
            if ( backtracking==0 ) {
            char_literal37_tree = (Object)adaptor.create(char_literal37);
            adaptor.addChild(root_0, char_literal37_tree);
            }
            if ( backtracking==0 ) {
               variableCount++; 
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end variable

    public static class preprocessor_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start preprocessor
    // /VMADL.j/src/de/sm/csimple/CSimple.g:136:0: preprocessor : '#' ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )* (~ ( PPCONTINUE | NEWLINE ) )* NEWLINE ;
    public final preprocessor_return preprocessor() throws RecognitionException {
        preprocessor_return retval = new preprocessor_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token char_literal38=null;
        Token set39=null;
        Token PPCONTINUE40=null;
        Token set41=null;
        Token NEWLINE42=null;

        Object char_literal38_tree=null;
        Object set39_tree=null;
        Object PPCONTINUE40_tree=null;
        Object set41_tree=null;
        Object NEWLINE42_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:136:14: ( '#' ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )* (~ ( PPCONTINUE | NEWLINE ) )* NEWLINE )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:137:3: '#' ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )* (~ ( PPCONTINUE | NEWLINE ) )* NEWLINE
            {
            root_0 = (Object)adaptor.nil();

            char_literal38=(Token)input.LT(1);
            match(input,29,FOLLOW_29_in_preprocessor378); if (failed) return retval;
            if ( backtracking==0 ) {
            char_literal38_tree = (Object)adaptor.create(char_literal38);
            adaptor.addChild(root_0, char_literal38_tree);
            }
            // /VMADL.j/src/de/sm/csimple/CSimple.g:138:3: ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )*
            loop12:
            do {
                int alt12=2;
                alt12 = dfa12.predict(input);
                switch (alt12) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:138:4: (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE
            	    {
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:138:4: (~ ( PPCONTINUE | NEWLINE ) )*
            	    loop11:
            	    do {
            	        int alt11=2;
            	        int LA11_0 = input.LA(1);

            	        if ( ((LA11_0>=TYPEDEF && LA11_0<=HEXPREFIX)||(LA11_0>=QUOTE && LA11_0<=DIGIT)||(LA11_0>=SPECIAL && LA11_0<=36)) ) {
            	            alt11=1;
            	        }


            	        switch (alt11) {
            	    	case 1 :
            	    	    // /VMADL.j/src/de/sm/csimple/CSimple.g:138:5: ~ ( PPCONTINUE | NEWLINE )
            	    	    {
            	    	    set39=(Token)input.LT(1);
            	    	    if ( (input.LA(1)>=TYPEDEF && input.LA(1)<=HEXPREFIX)||(input.LA(1)>=QUOTE && input.LA(1)<=DIGIT)||(input.LA(1)>=SPECIAL && input.LA(1)<=36) ) {
            	    	        input.consume();
            	    	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set39));
            	    	        errorRecovery=false;failed=false;
            	    	    }
            	    	    else {
            	    	        if (backtracking>0) {failed=true; return retval;}
            	    	        MismatchedSetException mse =
            	    	            new MismatchedSetException(null,input);
            	    	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_preprocessor384);    throw mse;
            	    	    }


            	    	    }
            	    	    break;

            	    	default :
            	    	    break loop11;
            	        }
            	    } while (true);

            	    PPCONTINUE40=(Token)input.LT(1);
            	    match(input,PPCONTINUE,FOLLOW_PPCONTINUE_in_preprocessor397); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    PPCONTINUE40_tree = (Object)adaptor.create(PPCONTINUE40);
            	    adaptor.addChild(root_0, PPCONTINUE40_tree);
            	    }

            	    }
            	    break;

            	default :
            	    break loop12;
                }
            } while (true);

            // /VMADL.j/src/de/sm/csimple/CSimple.g:139:3: (~ ( PPCONTINUE | NEWLINE ) )*
            loop13:
            do {
                int alt13=2;
                int LA13_0 = input.LA(1);

                if ( ((LA13_0>=TYPEDEF && LA13_0<=HEXPREFIX)||(LA13_0>=QUOTE && LA13_0<=DIGIT)||(LA13_0>=SPECIAL && LA13_0<=36)) ) {
                    alt13=1;
                }


                switch (alt13) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:139:4: ~ ( PPCONTINUE | NEWLINE )
            	    {
            	    set41=(Token)input.LT(1);
            	    if ( (input.LA(1)>=TYPEDEF && input.LA(1)<=HEXPREFIX)||(input.LA(1)>=QUOTE && input.LA(1)<=DIGIT)||(input.LA(1)>=SPECIAL && input.LA(1)<=36) ) {
            	        input.consume();
            	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set41));
            	        errorRecovery=false;failed=false;
            	    }
            	    else {
            	        if (backtracking>0) {failed=true; return retval;}
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_preprocessor404);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop13;
                }
            } while (true);

            NEWLINE42=(Token)input.LT(1);
            match(input,NEWLINE,FOLLOW_NEWLINE_in_preprocessor422); if (failed) return retval;
            if ( backtracking==0 ) {
            NEWLINE42_tree = (Object)adaptor.create(NEWLINE42);
            adaptor.addChild(root_0, NEWLINE42_tree);
            }
            if ( backtracking==0 ) {
               preprocessorCount++; 
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end preprocessor

    public static class typedefinition_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start typedefinition
    // /VMADL.j/src/de/sm/csimple/CSimple.g:145:0: typedefinition : TYPEDEF def ;
    public final typedefinition_return typedefinition() throws RecognitionException {
        typedefinition_return retval = new typedefinition_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token TYPEDEF43=null;
        def_return def44 = null;


        Object TYPEDEF43_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:145:15: ( TYPEDEF def )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:146:2: TYPEDEF def
            {
            root_0 = (Object)adaptor.nil();

            TYPEDEF43=(Token)input.LT(1);
            match(input,TYPEDEF,FOLLOW_TYPEDEF_in_typedefinition437); if (failed) return retval;
            if ( backtracking==0 ) {
            TYPEDEF43_tree = (Object)adaptor.create(TYPEDEF43);
            adaptor.addChild(root_0, TYPEDEF43_tree);
            }
            pushFollow(FOLLOW_def_in_typedefinition439);
            def44=def();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, def44.getTree());
            if ( backtracking==0 ) {
               typedefCount++; 
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end typedefinition

    public static class struct_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start struct
    // /VMADL.j/src/de/sm/csimple/CSimple.g:150:0: struct : ( STRUCT def | ( IDENTIFIER '(' IDENTIFIER ')' content ';' ) );
    public final struct_return struct() throws RecognitionException {
        struct_return retval = new struct_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token STRUCT45=null;
        Token IDENTIFIER47=null;
        Token char_literal48=null;
        Token IDENTIFIER49=null;
        Token char_literal50=null;
        Token char_literal52=null;
        def_return def46 = null;

        content_return content51 = null;


        Object STRUCT45_tree=null;
        Object IDENTIFIER47_tree=null;
        Object char_literal48_tree=null;
        Object IDENTIFIER49_tree=null;
        Object char_literal50_tree=null;
        Object char_literal52_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:150:7: ( STRUCT def | ( IDENTIFIER '(' IDENTIFIER ')' content ';' ) )
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==STRUCT) ) {
                alt14=1;
            }
            else if ( (LA14_0==IDENTIFIER) ) {
                alt14=2;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("150:0: struct : ( STRUCT def | ( IDENTIFIER '(' IDENTIFIER ')' content ';' ) );", 14, 0, input);

                throw nvae;
            }
            switch (alt14) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:151:2: STRUCT def
                    {
                    root_0 = (Object)adaptor.nil();

                    STRUCT45=(Token)input.LT(1);
                    match(input,STRUCT,FOLLOW_STRUCT_in_struct451); if (failed) return retval;
                    if ( backtracking==0 ) {
                    STRUCT45_tree = (Object)adaptor.create(STRUCT45);
                    adaptor.addChild(root_0, STRUCT45_tree);
                    }
                    pushFollow(FOLLOW_def_in_struct453);
                    def46=def();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, def46.getTree());

                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:152:4: ( IDENTIFIER '(' IDENTIFIER ')' content ';' )
                    {
                    root_0 = (Object)adaptor.nil();

                    // /VMADL.j/src/de/sm/csimple/CSimple.g:152:4: ( IDENTIFIER '(' IDENTIFIER ')' content ';' )
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:152:5: IDENTIFIER '(' IDENTIFIER ')' content ';'
                    {
                    IDENTIFIER47=(Token)input.LT(1);
                    match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_struct459); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IDENTIFIER47_tree = (Object)adaptor.create(IDENTIFIER47);
                    adaptor.addChild(root_0, IDENTIFIER47_tree);
                    }
                    char_literal48=(Token)input.LT(1);
                    match(input,30,FOLLOW_30_in_struct461); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal48_tree = (Object)adaptor.create(char_literal48);
                    adaptor.addChild(root_0, char_literal48_tree);
                    }
                    IDENTIFIER49=(Token)input.LT(1);
                    match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_struct463); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IDENTIFIER49_tree = (Object)adaptor.create(IDENTIFIER49);
                    adaptor.addChild(root_0, IDENTIFIER49_tree);
                    }
                    char_literal50=(Token)input.LT(1);
                    match(input,31,FOLLOW_31_in_struct465); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal50_tree = (Object)adaptor.create(char_literal50);
                    adaptor.addChild(root_0, char_literal50_tree);
                    }
                    pushFollow(FOLLOW_content_in_struct467);
                    content51=content();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, content51.getTree());
                    char_literal52=(Token)input.LT(1);
                    match(input,28,FOLLOW_28_in_struct469); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal52_tree = (Object)adaptor.create(char_literal52);
                    adaptor.addChild(root_0, char_literal52_tree);
                    }

                    }

                    if ( backtracking==0 ) {
                       structCount++; 
                    }

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end struct

    public static class def_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start def
    // /VMADL.j/src/de/sm/csimple/CSimple.g:156:0: def : ( content | ~ ( ';' | LBRACE ) )* ';' ;
    public final def_return def() throws RecognitionException {
        def_return retval = new def_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set54=null;
        Token char_literal55=null;
        content_return content53 = null;


        Object set54_tree=null;
        Object char_literal55_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:156:4: ( ( content | ~ ( ';' | LBRACE ) )* ';' )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:157:2: ( content | ~ ( ';' | LBRACE ) )* ';'
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/csimple/CSimple.g:157:2: ( content | ~ ( ';' | LBRACE ) )*
            loop15:
            do {
                int alt15=3;
                int LA15_0 = input.LA(1);

                if ( (LA15_0==LBRACE) ) {
                    alt15=1;
                }
                else if ( ((LA15_0>=TYPEDEF && LA15_0<=IDENTIFIER)||(LA15_0>=RBRACE && LA15_0<=27)||(LA15_0>=29 && LA15_0<=36)) ) {
                    alt15=2;
                }


                switch (alt15) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:157:3: content
            	    {
            	    pushFollow(FOLLOW_content_in_def484);
            	    content53=content();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, content53.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:157:13: ~ ( ';' | LBRACE )
            	    {
            	    set54=(Token)input.LT(1);
            	    if ( (input.LA(1)>=TYPEDEF && input.LA(1)<=IDENTIFIER)||(input.LA(1)>=RBRACE && input.LA(1)<=27)||(input.LA(1)>=29 && input.LA(1)<=36) ) {
            	        input.consume();
            	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set54));
            	        errorRecovery=false;failed=false;
            	    }
            	    else {
            	        if (backtracking>0) {failed=true; return retval;}
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_def488);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop15;
                }
            } while (true);

            char_literal55=(Token)input.LT(1);
            match(input,28,FOLLOW_28_in_def500); if (failed) return retval;
            if ( backtracking==0 ) {
            char_literal55_tree = (Object)adaptor.create(char_literal55);
            adaptor.addChild(root_0, char_literal55_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end def

    public static class function_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start function
    // /VMADL.j/src/de/sm/csimple/CSimple.g:161:0: function : ( STATIC | EXTERN )? ( INLINE )? returnType= typeRef (name= typeRef | '(' '*' name= typeRef ')' ) '(' (~ ( ')' ) )* ')' ( content | ( ATTR '(' '(' IDENTIFIER ')' ')' )? ';' ) ;
    public final function_return function() throws RecognitionException {
        function_return retval = new function_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set56=null;
        Token INLINE57=null;
        Token char_literal58=null;
        Token char_literal59=null;
        Token char_literal60=null;
        Token char_literal61=null;
        Token set62=null;
        Token char_literal63=null;
        Token ATTR65=null;
        Token char_literal66=null;
        Token char_literal67=null;
        Token IDENTIFIER68=null;
        Token char_literal69=null;
        Token char_literal70=null;
        Token char_literal71=null;
        typeRef_return returnType = null;

        typeRef_return name = null;

        content_return content64 = null;


        Object set56_tree=null;
        Object INLINE57_tree=null;
        Object char_literal58_tree=null;
        Object char_literal59_tree=null;
        Object char_literal60_tree=null;
        Object char_literal61_tree=null;
        Object set62_tree=null;
        Object char_literal63_tree=null;
        Object ATTR65_tree=null;
        Object char_literal66_tree=null;
        Object char_literal67_tree=null;
        Object IDENTIFIER68_tree=null;
        Object char_literal69_tree=null;
        Object char_literal70_tree=null;
        Object char_literal71_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:161:9: ( ( STATIC | EXTERN )? ( INLINE )? returnType= typeRef (name= typeRef | '(' '*' name= typeRef ')' ) '(' (~ ( ')' ) )* ')' ( content | ( ATTR '(' '(' IDENTIFIER ')' ')' )? ';' ) )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:162:2: ( STATIC | EXTERN )? ( INLINE )? returnType= typeRef (name= typeRef | '(' '*' name= typeRef ')' ) '(' (~ ( ')' ) )* ')' ( content | ( ATTR '(' '(' IDENTIFIER ')' ')' )? ';' )
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/csimple/CSimple.g:162:2: ( STATIC | EXTERN )?
            int alt16=2;
            int LA16_0 = input.LA(1);

            if ( (LA16_0==STATIC||LA16_0==EXTERN) ) {
                alt16=1;
            }
            switch (alt16) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:
                    {
                    set56=(Token)input.LT(1);
                    if ( input.LA(1)==STATIC||input.LA(1)==EXTERN ) {
                        input.consume();
                        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set56));
                        errorRecovery=false;failed=false;
                    }
                    else {
                        if (backtracking>0) {failed=true; return retval;}
                        MismatchedSetException mse =
                            new MismatchedSetException(null,input);
                        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_function509);    throw mse;
                    }


                    }
                    break;

            }

            // /VMADL.j/src/de/sm/csimple/CSimple.g:162:21: ( INLINE )?
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( (LA17_0==INLINE) ) {
                alt17=1;
            }
            switch (alt17) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:162:22: INLINE
                    {
                    INLINE57=(Token)input.LT(1);
                    match(input,INLINE,FOLLOW_INLINE_in_function519); if (failed) return retval;
                    if ( backtracking==0 ) {
                    INLINE57_tree = (Object)adaptor.create(INLINE57);
                    adaptor.addChild(root_0, INLINE57_tree);
                    }

                    }
                    break;

            }

            pushFollow(FOLLOW_typeRef_in_function526);
            returnType=typeRef();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, returnType.getTree());
            // /VMADL.j/src/de/sm/csimple/CSimple.g:165:2: (name= typeRef | '(' '*' name= typeRef ')' )
            int alt18=2;
            int LA18_0 = input.LA(1);

            if ( (LA18_0==STRUCT||LA18_0==CONST||LA18_0==IDENTIFIER) ) {
                alt18=1;
            }
            else if ( (LA18_0==30) ) {
                alt18=2;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("165:2: (name= typeRef | '(' '*' name= typeRef ')' )", 18, 0, input);

                throw nvae;
            }
            switch (alt18) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:165:5: name= typeRef
                    {
                    pushFollow(FOLLOW_typeRef_in_function537);
                    name=typeRef();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, name.getTree());

                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:166:5: '(' '*' name= typeRef ')'
                    {
                    char_literal58=(Token)input.LT(1);
                    match(input,30,FOLLOW_30_in_function546); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal58_tree = (Object)adaptor.create(char_literal58);
                    adaptor.addChild(root_0, char_literal58_tree);
                    }
                    char_literal59=(Token)input.LT(1);
                    match(input,32,FOLLOW_32_in_function548); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal59_tree = (Object)adaptor.create(char_literal59);
                    adaptor.addChild(root_0, char_literal59_tree);
                    }
                    pushFollow(FOLLOW_typeRef_in_function552);
                    name=typeRef();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, name.getTree());
                    char_literal60=(Token)input.LT(1);
                    match(input,31,FOLLOW_31_in_function554); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal60_tree = (Object)adaptor.create(char_literal60);
                    adaptor.addChild(root_0, char_literal60_tree);
                    }

                    }
                    break;

            }

            char_literal61=(Token)input.LT(1);
            match(input,30,FOLLOW_30_in_function564); if (failed) return retval;
            if ( backtracking==0 ) {
            char_literal61_tree = (Object)adaptor.create(char_literal61);
            adaptor.addChild(root_0, char_literal61_tree);
            }
            // /VMADL.j/src/de/sm/csimple/CSimple.g:169:6: (~ ( ')' ) )*
            loop19:
            do {
                int alt19=2;
                int LA19_0 = input.LA(1);

                if ( ((LA19_0>=TYPEDEF && LA19_0<=30)||(LA19_0>=32 && LA19_0<=36)) ) {
                    alt19=1;
                }


                switch (alt19) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:0:0: ~ ( ')' )
            	    {
            	    set62=(Token)input.LT(1);
            	    if ( (input.LA(1)>=TYPEDEF && input.LA(1)<=30)||(input.LA(1)>=32 && input.LA(1)<=36) ) {
            	        input.consume();
            	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set62));
            	        errorRecovery=false;failed=false;
            	    }
            	    else {
            	        if (backtracking>0) {failed=true; return retval;}
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_function566);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop19;
                }
            } while (true);

            char_literal63=(Token)input.LT(1);
            match(input,31,FOLLOW_31_in_function572); if (failed) return retval;
            if ( backtracking==0 ) {
            char_literal63_tree = (Object)adaptor.create(char_literal63);
            adaptor.addChild(root_0, char_literal63_tree);
            }
            // /VMADL.j/src/de/sm/csimple/CSimple.g:171:2: ( content | ( ATTR '(' '(' IDENTIFIER ')' ')' )? ';' )
            int alt21=2;
            int LA21_0 = input.LA(1);

            if ( (LA21_0==LBRACE) ) {
                alt21=1;
            }
            else if ( (LA21_0==ATTR||LA21_0==28) ) {
                alt21=2;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("171:2: ( content | ( ATTR '(' '(' IDENTIFIER ')' ')' )? ';' )", 21, 0, input);

                throw nvae;
            }
            switch (alt21) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:171:3: content
                    {
                    pushFollow(FOLLOW_content_in_function580);
                    content64=content();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, content64.getTree());
                    if ( backtracking==0 ) {
                       functionCount++; 
                    }

                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:172:5: ( ATTR '(' '(' IDENTIFIER ')' ')' )? ';'
                    {
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:172:5: ( ATTR '(' '(' IDENTIFIER ')' ')' )?
                    int alt20=2;
                    int LA20_0 = input.LA(1);

                    if ( (LA20_0==ATTR) ) {
                        alt20=1;
                    }
                    switch (alt20) {
                        case 1 :
                            // /VMADL.j/src/de/sm/csimple/CSimple.g:172:6: ATTR '(' '(' IDENTIFIER ')' ')'
                            {
                            ATTR65=(Token)input.LT(1);
                            match(input,ATTR,FOLLOW_ATTR_in_function589); if (failed) return retval;
                            if ( backtracking==0 ) {
                            ATTR65_tree = (Object)adaptor.create(ATTR65);
                            adaptor.addChild(root_0, ATTR65_tree);
                            }
                            char_literal66=(Token)input.LT(1);
                            match(input,30,FOLLOW_30_in_function591); if (failed) return retval;
                            if ( backtracking==0 ) {
                            char_literal66_tree = (Object)adaptor.create(char_literal66);
                            adaptor.addChild(root_0, char_literal66_tree);
                            }
                            char_literal67=(Token)input.LT(1);
                            match(input,30,FOLLOW_30_in_function593); if (failed) return retval;
                            if ( backtracking==0 ) {
                            char_literal67_tree = (Object)adaptor.create(char_literal67);
                            adaptor.addChild(root_0, char_literal67_tree);
                            }
                            IDENTIFIER68=(Token)input.LT(1);
                            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_function595); if (failed) return retval;
                            if ( backtracking==0 ) {
                            IDENTIFIER68_tree = (Object)adaptor.create(IDENTIFIER68);
                            adaptor.addChild(root_0, IDENTIFIER68_tree);
                            }
                            char_literal69=(Token)input.LT(1);
                            match(input,31,FOLLOW_31_in_function597); if (failed) return retval;
                            if ( backtracking==0 ) {
                            char_literal69_tree = (Object)adaptor.create(char_literal69);
                            adaptor.addChild(root_0, char_literal69_tree);
                            }
                            char_literal70=(Token)input.LT(1);
                            match(input,31,FOLLOW_31_in_function599); if (failed) return retval;
                            if ( backtracking==0 ) {
                            char_literal70_tree = (Object)adaptor.create(char_literal70);
                            adaptor.addChild(root_0, char_literal70_tree);
                            }

                            }
                            break;

                    }

                    char_literal71=(Token)input.LT(1);
                    match(input,28,FOLLOW_28_in_function607); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal71_tree = (Object)adaptor.create(char_literal71);
                    adaptor.addChild(root_0, char_literal71_tree);
                    }
                    if ( backtracking==0 ) {
                       functionSigCount++; 
                    }

                    }
                    break;

            }

            if ( backtracking==0 ) {
              	functions.add(input.toString(name.start,name.stop).intern());	
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end function

    public static class contentcontent_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start contentcontent
    // /VMADL.j/src/de/sm/csimple/CSimple.g:179:0: contentcontent : ( content | (~ ( LBRACE | RBRACE ) )+ )* ;
    public final contentcontent_return contentcontent() throws RecognitionException {
        contentcontent_return retval = new contentcontent_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set73=null;
        content_return content72 = null;


        Object set73_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:179:15: ( ( content | (~ ( LBRACE | RBRACE ) )+ )* )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:180:2: ( content | (~ ( LBRACE | RBRACE ) )+ )*
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/csimple/CSimple.g:180:2: ( content | (~ ( LBRACE | RBRACE ) )+ )*
            loop23:
            do {
                int alt23=3;
                int LA23_0 = input.LA(1);

                if ( (LA23_0==LBRACE) ) {
                    alt23=1;
                }
                else if ( ((LA23_0>=TYPEDEF && LA23_0<=IDENTIFIER)||(LA23_0>=DIGIT && LA23_0<=36)) ) {
                    alt23=2;
                }


                switch (alt23) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:180:3: content
            	    {
            	    pushFollow(FOLLOW_content_in_contentcontent627);
            	    content72=content();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, content72.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:180:13: (~ ( LBRACE | RBRACE ) )+
            	    {
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:180:13: (~ ( LBRACE | RBRACE ) )+
            	    int cnt22=0;
            	    loop22:
            	    do {
            	        int alt22=2;
            	        int LA22_0 = input.LA(1);

            	        if ( ((LA22_0>=TYPEDEF && LA22_0<=IDENTIFIER)||(LA22_0>=DIGIT && LA22_0<=36)) ) {
            	            int LA22_2 = input.LA(2);

            	            if ( (synpred46()) ) {
            	                alt22=1;
            	            }


            	        }


            	        switch (alt22) {
            	    	case 1 :
            	    	    // /VMADL.j/src/de/sm/csimple/CSimple.g:180:14: ~ ( LBRACE | RBRACE )
            	    	    {
            	    	    set73=(Token)input.LT(1);
            	    	    if ( (input.LA(1)>=TYPEDEF && input.LA(1)<=IDENTIFIER)||(input.LA(1)>=DIGIT && input.LA(1)<=36) ) {
            	    	        input.consume();
            	    	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set73));
            	    	        errorRecovery=false;failed=false;
            	    	    }
            	    	    else {
            	    	        if (backtracking>0) {failed=true; return retval;}
            	    	        MismatchedSetException mse =
            	    	            new MismatchedSetException(null,input);
            	    	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_contentcontent632);    throw mse;
            	    	    }


            	    	    }
            	    	    break;

            	    	default :
            	    	    if ( cnt22 >= 1 ) break loop22;
            	    	    if (backtracking>0) {failed=true; return retval;}
            	                EarlyExitException eee =
            	                    new EarlyExitException(22, input);
            	                throw eee;
            	        }
            	        cnt22++;
            	    } while (true);


            	    }
            	    break;

            	default :
            	    break loop23;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end contentcontent

    public static class content_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start content
    // /VMADL.j/src/de/sm/csimple/CSimple.g:182:0: content : LBRACE contentcontent RBRACE ;
    public final content_return content() throws RecognitionException {
        content_return retval = new content_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token LBRACE74=null;
        Token RBRACE76=null;
        contentcontent_return contentcontent75 = null;


        Object LBRACE74_tree=null;
        Object RBRACE76_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:182:9: ( LBRACE contentcontent RBRACE )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:183:3: LBRACE contentcontent RBRACE
            {
            root_0 = (Object)adaptor.nil();

            LBRACE74=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_content653); if (failed) return retval;
            if ( backtracking==0 ) {
            LBRACE74_tree = (Object)adaptor.create(LBRACE74);
            adaptor.addChild(root_0, LBRACE74_tree);
            }
            pushFollow(FOLLOW_contentcontent_in_content655);
            contentcontent75=contentcontent();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, contentcontent75.getTree());
            RBRACE76=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_content657); if (failed) return retval;
            if ( backtracking==0 ) {
            RBRACE76_tree = (Object)adaptor.create(RBRACE76);
            adaptor.addChild(root_0, RBRACE76_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end content

    public static class typeRef_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start typeRef
    // /VMADL.j/src/de/sm/csimple/CSimple.g:186:0: typeRef : ( CONST )? ( STRUCT )? ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' ) ( '*' )* ;
    public final typeRef_return typeRef() throws RecognitionException {
        typeRef_return retval = new typeRef_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token CONST77=null;
        Token STRUCT78=null;
        Token IDENTIFIER79=null;
        Token IDENTIFIER80=null;
        Token char_literal81=null;
        Token IDENTIFIER82=null;
        Token char_literal83=null;
        Token char_literal84=null;

        Object CONST77_tree=null;
        Object STRUCT78_tree=null;
        Object IDENTIFIER79_tree=null;
        Object IDENTIFIER80_tree=null;
        Object char_literal81_tree=null;
        Object IDENTIFIER82_tree=null;
        Object char_literal83_tree=null;
        Object char_literal84_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:186:8: ( ( CONST )? ( STRUCT )? ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' ) ( '*' )* )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:187:2: ( CONST )? ( STRUCT )? ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' ) ( '*' )*
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/csimple/CSimple.g:187:2: ( CONST )?
            int alt24=2;
            int LA24_0 = input.LA(1);

            if ( (LA24_0==CONST) ) {
                alt24=1;
            }
            switch (alt24) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:0:0: CONST
                    {
                    CONST77=(Token)input.LT(1);
                    match(input,CONST,FOLLOW_CONST_in_typeRef666); if (failed) return retval;
                    if ( backtracking==0 ) {
                    CONST77_tree = (Object)adaptor.create(CONST77);
                    adaptor.addChild(root_0, CONST77_tree);
                    }

                    }
                    break;

            }

            // /VMADL.j/src/de/sm/csimple/CSimple.g:188:2: ( STRUCT )?
            int alt25=2;
            int LA25_0 = input.LA(1);

            if ( (LA25_0==STRUCT) ) {
                alt25=1;
            }
            switch (alt25) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:0:0: STRUCT
                    {
                    STRUCT78=(Token)input.LT(1);
                    match(input,STRUCT,FOLLOW_STRUCT_in_typeRef670); if (failed) return retval;
                    if ( backtracking==0 ) {
                    STRUCT78_tree = (Object)adaptor.create(STRUCT78);
                    adaptor.addChild(root_0, STRUCT78_tree);
                    }

                    }
                    break;

            }

            // /VMADL.j/src/de/sm/csimple/CSimple.g:189:2: ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' )
            int alt26=2;
            int LA26_0 = input.LA(1);

            if ( (LA26_0==IDENTIFIER) ) {
                int LA26_1 = input.LA(2);

                if ( (LA26_1==30) ) {
                    int LA26_2 = input.LA(3);

                    if ( (LA26_2==IDENTIFIER) ) {
                        int LA26_4 = input.LA(4);

                        if ( (LA26_4==31) ) {
                            int LA26_5 = input.LA(5);

                            if ( (LA26_5==ATTR||LA26_5==LBRACE||LA26_5==28) ) {
                                alt26=1;
                            }
                            else if ( (LA26_5==EOF||LA26_5==STRUCT||LA26_5==CONST||LA26_5==IDENTIFIER||(LA26_5>=30 && LA26_5<=32)) ) {
                                alt26=2;
                            }
                            else {
                                if (backtracking>0) {failed=true; return retval;}
                                NoViableAltException nvae =
                                    new NoViableAltException("189:2: ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' )", 26, 5, input);

                                throw nvae;
                            }
                        }
                        else if ( ((LA26_4>=TYPEDEF && LA26_4<=30)||(LA26_4>=32 && LA26_4<=36)) ) {
                            alt26=1;
                        }
                        else {
                            if (backtracking>0) {failed=true; return retval;}
                            NoViableAltException nvae =
                                new NoViableAltException("189:2: ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' )", 26, 4, input);

                            throw nvae;
                        }
                    }
                    else if ( ((LA26_2>=TYPEDEF && LA26_2<=QUOTE)||(LA26_2>=LBRACE && LA26_2<=36)) ) {
                        alt26=1;
                    }
                    else {
                        if (backtracking>0) {failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("189:2: ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' )", 26, 2, input);

                        throw nvae;
                    }
                }
                else if ( (LA26_1==EOF||LA26_1==STRUCT||LA26_1==CONST||LA26_1==IDENTIFIER||(LA26_1>=31 && LA26_1<=32)) ) {
                    alt26=1;
                }
                else {
                    if (backtracking>0) {failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("189:2: ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' )", 26, 1, input);

                    throw nvae;
                }
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("189:2: ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' )", 26, 0, input);

                throw nvae;
            }
            switch (alt26) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:189:3: IDENTIFIER
                    {
                    IDENTIFIER79=(Token)input.LT(1);
                    match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_typeRef675); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IDENTIFIER79_tree = (Object)adaptor.create(IDENTIFIER79);
                    adaptor.addChild(root_0, IDENTIFIER79_tree);
                    }

                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:190:5: IDENTIFIER '(' IDENTIFIER ')'
                    {
                    IDENTIFIER80=(Token)input.LT(1);
                    match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_typeRef681); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IDENTIFIER80_tree = (Object)adaptor.create(IDENTIFIER80);
                    adaptor.addChild(root_0, IDENTIFIER80_tree);
                    }
                    char_literal81=(Token)input.LT(1);
                    match(input,30,FOLLOW_30_in_typeRef683); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal81_tree = (Object)adaptor.create(char_literal81);
                    adaptor.addChild(root_0, char_literal81_tree);
                    }
                    IDENTIFIER82=(Token)input.LT(1);
                    match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_typeRef685); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IDENTIFIER82_tree = (Object)adaptor.create(IDENTIFIER82);
                    adaptor.addChild(root_0, IDENTIFIER82_tree);
                    }
                    char_literal83=(Token)input.LT(1);
                    match(input,31,FOLLOW_31_in_typeRef687); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal83_tree = (Object)adaptor.create(char_literal83);
                    adaptor.addChild(root_0, char_literal83_tree);
                    }

                    }
                    break;

            }

            // /VMADL.j/src/de/sm/csimple/CSimple.g:191:4: ( '*' )*
            loop27:
            do {
                int alt27=2;
                int LA27_0 = input.LA(1);

                if ( (LA27_0==32) ) {
                    alt27=1;
                }


                switch (alt27) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:191:5: '*'
            	    {
            	    char_literal84=(Token)input.LT(1);
            	    match(input,32,FOLLOW_32_in_typeRef695); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    char_literal84_tree = (Object)adaptor.create(char_literal84);
            	    adaptor.addChild(root_0, char_literal84_tree);
            	    }

            	    }
            	    break;

            	default :
            	    break loop27;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end typeRef

    public static class hexValue_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start hexValue
    // /VMADL.j/src/de/sm/csimple/CSimple.g:194:0: hexValue : HEXPREFIX ( DIGIT | 'a' .. 'f' | 'A' .. 'F' )+ ;
    public final hexValue_return hexValue() throws RecognitionException {
        hexValue_return retval = new hexValue_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token HEXPREFIX85=null;
        Token set86=null;

        Object HEXPREFIX85_tree=null;
        Object set86_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:194:9: ( HEXPREFIX ( DIGIT | 'a' .. 'f' | 'A' .. 'F' )+ )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:195:2: HEXPREFIX ( DIGIT | 'a' .. 'f' | 'A' .. 'F' )+
            {
            root_0 = (Object)adaptor.nil();

            HEXPREFIX85=(Token)input.LT(1);
            match(input,HEXPREFIX,FOLLOW_HEXPREFIX_in_hexValue706); if (failed) return retval;
            if ( backtracking==0 ) {
            HEXPREFIX85_tree = (Object)adaptor.create(HEXPREFIX85);
            adaptor.addChild(root_0, HEXPREFIX85_tree);
            }
            // /VMADL.j/src/de/sm/csimple/CSimple.g:195:12: ( DIGIT | 'a' .. 'f' | 'A' .. 'F' )+
            int cnt28=0;
            loop28:
            do {
                int alt28=2;
                int LA28_0 = input.LA(1);

                if ( (LA28_0==DIGIT) ) {
                    alt28=1;
                }


                switch (alt28) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:
            	    {
            	    set86=(Token)input.LT(1);
            	    if ( input.LA(1)==DIGIT ) {
            	        input.consume();
            	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set86));
            	        errorRecovery=false;failed=false;
            	    }
            	    else {
            	        if (backtracking>0) {failed=true; return retval;}
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_hexValue708);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt28 >= 1 ) break loop28;
            	    if (backtracking>0) {failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(28, input);
                        throw eee;
                }
                cnt28++;
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end hexValue

    // $ANTLR start synpred2
    public final void synpred2_fragment() throws RecognitionException {   
        // /VMADL.j/src/de/sm/csimple/CSimple.g:110:20: ( struct )
        // /VMADL.j/src/de/sm/csimple/CSimple.g:110:20: struct
        {
        pushFollow(FOLLOW_struct_in_synpred2196);
        struct();
        _fsp--;
        if (failed) return ;

        }
    }
    // $ANTLR end synpred2

    // $ANTLR start synpred3
    public final void synpred3_fragment() throws RecognitionException {   
        // /VMADL.j/src/de/sm/csimple/CSimple.g:110:29: ( function )
        // /VMADL.j/src/de/sm/csimple/CSimple.g:110:29: function
        {
        pushFollow(FOLLOW_function_in_synpred3200);
        function();
        _fsp--;
        if (failed) return ;

        }
    }
    // $ANTLR end synpred3

    // $ANTLR start synpred5
    public final void synpred5_fragment() throws RecognitionException {   
        // /VMADL.j/src/de/sm/csimple/CSimple.g:110:55: ( variable )
        // /VMADL.j/src/de/sm/csimple/CSimple.g:110:55: variable
        {
        pushFollow(FOLLOW_variable_in_synpred5208);
        variable();
        _fsp--;
        if (failed) return ;

        }
    }
    // $ANTLR end synpred5

    // $ANTLR start synpred7
    public final void synpred7_fragment() throws RecognitionException {   
        // /VMADL.j/src/de/sm/csimple/CSimple.g:110:76: ( externDef )
        // /VMADL.j/src/de/sm/csimple/CSimple.g:110:76: externDef
        {
        pushFollow(FOLLOW_externDef_in_synpred7216);
        externDef();
        _fsp--;
        if (failed) return ;

        }
    }
    // $ANTLR end synpred7

    // $ANTLR start synpred9
    public final void synpred9_fragment() throws RecognitionException {   
        // /VMADL.j/src/de/sm/csimple/CSimple.g:117:21: ( struct )
        // /VMADL.j/src/de/sm/csimple/CSimple.g:117:21: struct
        {
        pushFollow(FOLLOW_struct_in_synpred9252);
        struct();
        _fsp--;
        if (failed) return ;

        }
    }
    // $ANTLR end synpred9

    // $ANTLR start synpred10
    public final void synpred10_fragment() throws RecognitionException {   
        // /VMADL.j/src/de/sm/csimple/CSimple.g:117:30: ( function )
        // /VMADL.j/src/de/sm/csimple/CSimple.g:117:30: function
        {
        pushFollow(FOLLOW_function_in_synpred10256);
        function();
        _fsp--;
        if (failed) return ;

        }
    }
    // $ANTLR end synpred10

    // $ANTLR start synpred12
    public final void synpred12_fragment() throws RecognitionException {   
        // /VMADL.j/src/de/sm/csimple/CSimple.g:117:56: ( variable )
        // /VMADL.j/src/de/sm/csimple/CSimple.g:117:56: variable
        {
        pushFollow(FOLLOW_variable_in_synpred12264);
        variable();
        _fsp--;
        if (failed) return ;

        }
    }
    // $ANTLR end synpred12

    // $ANTLR start synpred46
    public final void synpred46_fragment() throws RecognitionException {   
        // /VMADL.j/src/de/sm/csimple/CSimple.g:180:14: (~ ( LBRACE | RBRACE ) )
        // /VMADL.j/src/de/sm/csimple/CSimple.g:180:14: ~ ( LBRACE | RBRACE )
        {
        if ( (input.LA(1)>=TYPEDEF && input.LA(1)<=IDENTIFIER)||(input.LA(1)>=DIGIT && input.LA(1)<=36) ) {
            input.consume();
            errorRecovery=false;failed=false;
        }
        else {
            if (backtracking>0) {failed=true; return ;}
            MismatchedSetException mse =
                new MismatchedSetException(null,input);
            recoverFromMismatchedSet(input,mse,FOLLOW_set_in_synpred46632);    throw mse;
        }


        }
    }
    // $ANTLR end synpred46

    public final boolean synpred46() {
        backtracking++;
        int start = input.mark();
        try {
            synpred46_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !failed;
        input.rewind(start);
        backtracking--;
        failed=false;
        return success;
    }
    public final boolean synpred9() {
        backtracking++;
        int start = input.mark();
        try {
            synpred9_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !failed;
        input.rewind(start);
        backtracking--;
        failed=false;
        return success;
    }
    public final boolean synpred5() {
        backtracking++;
        int start = input.mark();
        try {
            synpred5_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !failed;
        input.rewind(start);
        backtracking--;
        failed=false;
        return success;
    }
    public final boolean synpred7() {
        backtracking++;
        int start = input.mark();
        try {
            synpred7_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !failed;
        input.rewind(start);
        backtracking--;
        failed=false;
        return success;
    }
    public final boolean synpred10() {
        backtracking++;
        int start = input.mark();
        try {
            synpred10_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !failed;
        input.rewind(start);
        backtracking--;
        failed=false;
        return success;
    }
    public final boolean synpred2() {
        backtracking++;
        int start = input.mark();
        try {
            synpred2_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !failed;
        input.rewind(start);
        backtracking--;
        failed=false;
        return success;
    }
    public final boolean synpred12() {
        backtracking++;
        int start = input.mark();
        try {
            synpred12_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !failed;
        input.rewind(start);
        backtracking--;
        failed=false;
        return success;
    }
    public final boolean synpred3() {
        backtracking++;
        int start = input.mark();
        try {
            synpred3_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !failed;
        input.rewind(start);
        backtracking--;
        failed=false;
        return success;
    }


    protected DFA12 dfa12 = new DFA12(this);
    static final String DFA12_eotS =
        "\4\uffff";
    static final String DFA12_eofS =
        "\4\uffff";
    static final String DFA12_minS =
        "\2\4\2\uffff";
    static final String DFA12_maxS =
        "\2\44\2\uffff";
    static final String DFA12_acceptS =
        "\2\uffff\1\2\1\1";
    static final String DFA12_specialS =
        "\4\uffff}>";
    static final String[] DFA12_transitionS = {
            "\11\1\1\2\5\1\1\3\21\1",
            "\11\1\1\2\5\1\1\3\21\1",
            "",
            ""
    };

    static final short[] DFA12_eot = DFA.unpackEncodedString(DFA12_eotS);
    static final short[] DFA12_eof = DFA.unpackEncodedString(DFA12_eofS);
    static final char[] DFA12_min = DFA.unpackEncodedStringToUnsignedChars(DFA12_minS);
    static final char[] DFA12_max = DFA.unpackEncodedStringToUnsignedChars(DFA12_maxS);
    static final short[] DFA12_accept = DFA.unpackEncodedString(DFA12_acceptS);
    static final short[] DFA12_special = DFA.unpackEncodedString(DFA12_specialS);
    static final short[][] DFA12_transition;

    static {
        int numStates = DFA12_transitionS.length;
        DFA12_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA12_transition[i] = DFA.unpackEncodedString(DFA12_transitionS[i]);
        }
    }

    class DFA12 extends DFA {

        public DFA12(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 12;
            this.eot = DFA12_eot;
            this.eof = DFA12_eof;
            this.min = DFA12_min;
            this.max = DFA12_max;
            this.accept = DFA12_accept;
            this.special = DFA12_special;
            this.transition = DFA12_transition;
        }
        public String getDescription() {
            return "()* loopback of 138:3: ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )*";
        }
    }
 

    public static final BitSet FOLLOW_typedefinition_in_definitions192 = new BitSet(new long[]{0x000000002000A3F0L});
    public static final BitSet FOLLOW_struct_in_definitions196 = new BitSet(new long[]{0x000000002000A3F0L});
    public static final BitSet FOLLOW_function_in_definitions200 = new BitSet(new long[]{0x000000002000A3F0L});
    public static final BitSet FOLLOW_preprocessor_in_definitions204 = new BitSet(new long[]{0x000000002000A3F0L});
    public static final BitSet FOLLOW_variable_in_definitions208 = new BitSet(new long[]{0x000000002000A3F0L});
    public static final BitSet FOLLOW_NEWLINE_in_definitions212 = new BitSet(new long[]{0x000000002000A3F0L});
    public static final BitSet FOLLOW_externDef_in_definitions216 = new BitSet(new long[]{0x000000002000A3F0L});
    public static final BitSet FOLLOW_EOF_in_definitions222 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EXTERN_in_externDef232 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_QUOTE_in_externDef234 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_externDef236 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_QUOTE_in_externDef238 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_LBRACE_in_externDef243 = new BitSet(new long[]{0x000000002002A3F0L});
    public static final BitSet FOLLOW_typedefinition_in_externDef248 = new BitSet(new long[]{0x000000002002A3F0L});
    public static final BitSet FOLLOW_struct_in_externDef252 = new BitSet(new long[]{0x000000002002A3F0L});
    public static final BitSet FOLLOW_function_in_externDef256 = new BitSet(new long[]{0x000000002002A3F0L});
    public static final BitSet FOLLOW_preprocessor_in_externDef260 = new BitSet(new long[]{0x000000002002A3F0L});
    public static final BitSet FOLLOW_variable_in_externDef264 = new BitSet(new long[]{0x000000002002A3F0L});
    public static final BitSet FOLLOW_NEWLINE_in_externDef268 = new BitSet(new long[]{0x000000002002A3F0L});
    public static final BitSet FOLLOW_RBRACE_in_externDef275 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENTIFIER_in_literalValue284 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MINUS_in_literalValue288 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_DIGIT_in_literalValue291 = new BitSet(new long[]{0x0000000000040002L});
    public static final BitSet FOLLOW_hexValue_in_literalValue296 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_content_in_literalValue300 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_QUOTE_in_literalValue305 = new BitSet(new long[]{0x0000001FFFFFFFF0L});
    public static final BitSet FOLLOW_set_in_literalValue307 = new BitSet(new long[]{0x0000001FFFFFFFF0L});
    public static final BitSet FOLLOW_QUOTE_in_literalValue313 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_variable322 = new BitSet(new long[]{0x0000000000008220L});
    public static final BitSet FOLLOW_typeRef_in_variable332 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_variable337 = new BitSet(new long[]{0x000000001A000000L});
    public static final BitSet FOLLOW_25_in_variable342 = new BitSet(new long[]{0x000000000405D400L});
    public static final BitSet FOLLOW_literalValue_in_variable345 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_26_in_variable349 = new BitSet(new long[]{0x0000000018000000L});
    public static final BitSet FOLLOW_27_in_variable356 = new BitSet(new long[]{0x000000000005D400L});
    public static final BitSet FOLLOW_literalValue_in_variable358 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_28_in_variable364 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_29_in_preprocessor378 = new BitSet(new long[]{0x0000001FFFFFFFF0L});
    public static final BitSet FOLLOW_set_in_preprocessor384 = new BitSet(new long[]{0x0000001FFFFFDFF0L});
    public static final BitSet FOLLOW_PPCONTINUE_in_preprocessor397 = new BitSet(new long[]{0x0000001FFFFFFFF0L});
    public static final BitSet FOLLOW_set_in_preprocessor404 = new BitSet(new long[]{0x0000001FFFF7FFF0L});
    public static final BitSet FOLLOW_NEWLINE_in_preprocessor422 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TYPEDEF_in_typedefinition437 = new BitSet(new long[]{0x0000001FFFFFFFF0L});
    public static final BitSet FOLLOW_def_in_typedefinition439 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRUCT_in_struct451 = new BitSet(new long[]{0x0000001FFFFFFFF0L});
    public static final BitSet FOLLOW_def_in_struct453 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENTIFIER_in_struct459 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_30_in_struct461 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_struct463 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_31_in_struct465 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_content_in_struct467 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_28_in_struct469 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_content_in_def484 = new BitSet(new long[]{0x0000001FFFFFFFF0L});
    public static final BitSet FOLLOW_set_in_def488 = new BitSet(new long[]{0x0000001FFFFFFFF0L});
    public static final BitSet FOLLOW_28_in_def500 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_function509 = new BitSet(new long[]{0x00000000000082A0L});
    public static final BitSet FOLLOW_INLINE_in_function519 = new BitSet(new long[]{0x0000000000008220L});
    public static final BitSet FOLLOW_typeRef_in_function526 = new BitSet(new long[]{0x0000000040008220L});
    public static final BitSet FOLLOW_typeRef_in_function537 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_30_in_function546 = new BitSet(new long[]{0x0000000100000000L});
    public static final BitSet FOLLOW_32_in_function548 = new BitSet(new long[]{0x0000000000008220L});
    public static final BitSet FOLLOW_typeRef_in_function552 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_31_in_function554 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_30_in_function564 = new BitSet(new long[]{0x0000001FFFFFFFF0L});
    public static final BitSet FOLLOW_set_in_function566 = new BitSet(new long[]{0x0000001FFFFFFFF0L});
    public static final BitSet FOLLOW_31_in_function572 = new BitSet(new long[]{0x0000000010010800L});
    public static final BitSet FOLLOW_content_in_function580 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ATTR_in_function589 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_30_in_function591 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_30_in_function593 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_function595 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_31_in_function597 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_31_in_function599 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_28_in_function607 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_content_in_contentcontent627 = new BitSet(new long[]{0x0000001FFFFDFFF2L});
    public static final BitSet FOLLOW_set_in_contentcontent632 = new BitSet(new long[]{0x0000001FFFFDFFF2L});
    public static final BitSet FOLLOW_LBRACE_in_content653 = new BitSet(new long[]{0x0000001FFFFFFFF0L});
    public static final BitSet FOLLOW_contentcontent_in_content655 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_RBRACE_in_content657 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CONST_in_typeRef666 = new BitSet(new long[]{0x0000000000008020L});
    public static final BitSet FOLLOW_STRUCT_in_typeRef670 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_typeRef675 = new BitSet(new long[]{0x0000000100000002L});
    public static final BitSet FOLLOW_IDENTIFIER_in_typeRef681 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_30_in_typeRef683 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_typeRef685 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_31_in_typeRef687 = new BitSet(new long[]{0x0000000100000002L});
    public static final BitSet FOLLOW_32_in_typeRef695 = new BitSet(new long[]{0x0000000100000002L});
    public static final BitSet FOLLOW_HEXPREFIX_in_hexValue706 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_set_in_hexValue708 = new BitSet(new long[]{0x0000000000040002L});
    public static final BitSet FOLLOW_struct_in_synpred2196 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_function_in_synpred3200 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variable_in_synpred5208 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_externDef_in_synpred7216 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_struct_in_synpred9252 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_function_in_synpred10256 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variable_in_synpred12264 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_synpred46632 = new BitSet(new long[]{0x0000000000000002L});

}