lexer grammar Odl;
options {
  language=Java;

}
@header {
  package de.sm.odl;
}

CLASS : 'class' ;
TRAIT : 'trait' ;
REFINE : 'refine' ;
BEFORE : 'before' ;
CONST : 'const' ;
RESTRICT : 'restrict' ;
ZERO_ARR : '[0]' ;
T24 : ',' ;
T25 : '*' ;

// $ANTLR src "/VMADL.j/src/de/sm/odl/Odl.g" 117
POSITION: BEFORE;

// $ANTLR src "/VMADL.j/src/de/sm/odl/Odl.g" 119
IDENTIFIER : (LETTER | '_') ( DIGIT | LETTER | '_' )*;

// $ANTLR src "/VMADL.j/src/de/sm/odl/Odl.g" 121
DIGIT
    :    '0'..'9'
    ;
// $ANTLR src "/VMADL.j/src/de/sm/odl/Odl.g" 124
fragment LETTER
    : 'a'..'z'
    | 'A'..'Z'
    ;

// $ANTLR src "/VMADL.j/src/de/sm/odl/Odl.g" 129
NEWLINE
  : '\r'? '\n'
  //{ channel=HIDDEN; }
;

// $ANTLR src "/VMADL.j/src/de/sm/odl/Odl.g" 134
WS
  : (' '|'\t')+		//|'\n'|'\r' 
  { channel=HIDDEN; }
;

// $ANTLR src "/VMADL.j/src/de/sm/odl/Odl.g" 139
COMMENT
  : '//' (~('\n'|'\r'))* NEWLINE
  { channel=HIDDEN; }
;
  
// multiple-line comments
// $ANTLR src "/VMADL.j/src/de/sm/odl/Odl.g" 145
ML_COMMENT
  : '/*' (options {greedy=false;} : .)* '*/' 
  { channel=HIDDEN; }
;

// $ANTLR src "/VMADL.j/src/de/sm/odl/Odl.g" 150
LPARENTHESIS: '(';
// $ANTLR src "/VMADL.j/src/de/sm/odl/Odl.g" 151
RPARENTHESIS: ')';
// $ANTLR src "/VMADL.j/src/de/sm/odl/Odl.g" 152
COLON  : ':'; 
// $ANTLR src "/VMADL.j/src/de/sm/odl/Odl.g" 153
LBRACE : '{';
// $ANTLR src "/VMADL.j/src/de/sm/odl/Odl.g" 154
RBRACE : '}';