package de.sm.vmadl;

import java.util.Collection;
import java.util.HashMap;

import de.sm.vmadl.elements.ServiceModule;

public class ServiceRegistry {
	private HashMap<String, ServiceModule> registry = new HashMap<String, ServiceModule>();
	
	public ServiceModule get(String moduleName) {
		if (!registry.containsKey(moduleName)) {
			ServiceModule module = new ServiceModule();
			module.name = moduleName;
			registry.put(moduleName, module);
			return module;
		}
		return registry.get(moduleName);
	}
	
	public Collection<ServiceModule> getServices() {
		return registry.values();
	}
}
