#include <stdint.h>

#include <module.Image>

void _VMEvaluationPrimitive_update_references(void* _self, const intptr_t difference) {
	pVMEvaluationPrimitive self = (pVMEvaluationPrimitive)_self;
	
	self->number_of_arguments = (pVMInteger)((intptr_t)self->number_of_arguments + difference);
	Image_update_object_references((pVMObject)self->number_of_arguments, difference);
	
	SUPER(VMPrimitive, self, update_references, difference);
}

bool _VMEvaluationPrimitive_serialize_data(void* _self) {
	pVMEvaluationPrimitive self = (pVMEvaluationPrimitive)_self;
	
	Image_serialize_object_data((pVMObject)self->number_of_arguments);
	
	SUPER(VMPrimitive, self, serialize_data);
}

bool _VMEvaluationPrimitive_deserialize_data(void* _self) {
	pVMEvaluationPrimitive self = (pVMEvaluationPrimitive)_self;
	
	Image_deserialize_object_data((pVMObject)self->number_of_arguments);
	
	SUPER(VMPrimitive, self, deserialize_data);
}

