#include <stdint.h>

#include <module.Image>

void _VMPrimitive_update_references(void* _self, const intptr_t difference) {
	pVMPrimitive self = (pVMPrimitive)_self;
	
	int nof = self->num_of_fields;
	self->num_of_fields = 3;
	SUPER(VMObject, self, update_references, difference);
	self->num_of_fields = nof;
}

bool _VMPrimitive_serialize_data(void* _self) {
	pVMPrimitive self = (pVMPrimitive)_self;

	int nof = self->num_of_fields;
	self->num_of_fields = 3;
	if (!SUPER(VMObject, self, serialize_data))
		return false;
	self->num_of_fields = nof;
	
	return true;
}

bool _VMPrimitive_deserialize_data(void* _self) {
	pVMPrimitive self = (pVMPrimitive)_self;
	
	int nof = self->num_of_fields;
	self->num_of_fields = 3;
	if (!SUPER(VMObject, self, deserialize_data))
		return false;
	self->num_of_fields = nof;
	
	return true;
}
